﻿using System;
using System.Collections.Generic;
using System.Text;

namespace BaseLibrary
{
    public class BasicFunctionClass
    {
        static public int N = 1701;
        static public int n = 31;                           // Число базисных функций

        public double h = (b1 - a1) / (double)(n - 1);

        public int PowerOfBasicElement = 2;
        public double WidthOfBasicElement = 10.0;
        public static int primer = 1;
        public const int pr = 5;                //порядок функций Бесселя или Чебышева

        public const double _Pi = 3.14159265358979323846264338327950288419716939937510;

        public int nl = 20;
        public int TypeOfBasicElement = 5;
        public const double dloc = 25.0;        //Параметры в методах: 

        public static double omega = 1.0;
        public static int kmax = 30;

        static public double[,] a = new double[N, N];
        public double[,] X = new double[N, N];

        public static int st = 2; //st = 1,2 
        public double al = 15.0;

        public static double EpsZeidel = 0.0000001;
        public double EpsMfss = 0.00000000000000001;
        public static int[] ipvt = new int[N];
        public static double[] work = new double[N];
        public int inc = 0;
        public int irank = 0;
        public int ier = 0;
        public static double[] trac = new double[N];
        public double[] rhs = new double[N];
        public static double cond = 1.0;

        static public double b1 = 1.0;           //область определения функций 
        public double Rangemax
        {
            get { return b1; }
            set { b1 = value; }
        }

        static public double a1 = -1.0;
        public double Rangemin
        {
            get { return a1; }
            set { a1 = value; }
        }

        public int Number
        {
            get { return n; }
            set { n = value; }
        }

        static public int keyOfJob = 1; 
        public static int KeyOfJob
        {
            get { return keyOfJob; }
            set { keyOfJob = value; }
        }

        public double xi(int i)
        {
            return a1 + i * h;
        }

        public double sgn(double x)
        {
            if (x < 0.0) 
                return -1.0;
            else 
                if (x > 0.0) 
                    return 1.0;
            else return 0.0;
        }

        public double step(int n, double x)
        {
            if (n < 0) 
                return 0.0;
            else
                switch (n)
                {
                    case 0: 
                        return 1.0;
                    case 1: 
                        return x;
                    default: 
                        return x * step(n - 1, x);
                }
        }

        public double Erf(double x)
        {
            double y, a1, a2, a3, a4, a5, p, t, z, r;
            p = 0.3275911; a1 = 0.254829592; a2 = -0.284496736;
            a3 = 1.421413741; a4 = -1.453152027; a5 = 1.061405429;
            y = Math.Abs(x); t = 1.0 / (1 + p * y);
            if (y > 10.0) 
                z = 0.0;
            else 
                z = Math.Exp(-y * y);
            r = 1.0 - (a1 * t + a2 * t * t + a3 * step(3, t) +
                    a4 * step(4, t) + a5 * step(5, t)) * z;
            if (x < 0.0) 
                r = -r;
            return r;
        }
        public double Erff(double x)
        {
            double p, q;
            p = x * x;
            if (p > 100.0) 
                q = 0.0;
            else 
                q = Math.Exp(-p) / Math.Sqrt(_Pi);
            return x * Erf(x) + q;
        }

        public double SplineNloc(double x)
        {
            double p, q, d, FN, FNlD;
            p = Math.Abs(x); d = Math.Sqrt(6.0); q = (p * p - d * d);
            if (p > 10.0) 
                FN = 0.0;
            else 
                FN = Math.Exp(-p * p / 2.0) / Math.Sqrt(2.0 * _Pi);
            if (p > d) 
                FNlD = 0.0;
            else 
                FNlD = FN * q * q * q;
            return FNlD;
        }
        public double ClocN(int nl)
        {
            int i; double a2, b2, d, h, s1, s2, y;
            d = Math.Sqrt(6.0); a2 = -d; b2 = d;
            h = (b2 - a2) / (2.0 * nl); s2 = 0.0; s1 = SplineNloc(b2 - h); y = a2;
            for (i = 1; i < nl; i++)
            {
                y = y + h; s1 = s1 + SplineNloc(y);
                y = y + h; s2 = s2 + SplineNloc(y);
            }
            return (SplineNloc(a2) + SplineNloc(b2) + 4.0 * s1 + 2.0 * s2) * h / 3.0;
        }

        public double E1Log(double x)
        {
            double ret;
            if (x < 1.0)
            {
                double a0 = -0.57721566; double a1 = 0.99999193; double a2 = -0.24991055;
                double a3 = 0.05519968; double a4 = -0.00976004; double a5 = 0.00107857;
                ret = a0 + a1 * x + a2 * x * x + a3 * step(3, x) + a4 * step(4, x) + a5 * step(5, x);
            }
            else
            {
                double a1 = 8.5733287401; double b1 = 9.5733223454;
                double a2 = 18.0590169730; double b2 = 25.6329561486;
                double a3 = 8.6347608925; double b3 = 21.0996530827;
                double a4 = 0.2677737343; double b4 = 3.9584969228;
                ret = (step(4, x) + a1 * step(3, x)+ a2 * x * x  + a3 * x + a4) /
                    (step(4, x) + b1 * step(3, x) + b2 * x * x + b3 * x + b4) * 
                    Math.Exp(-x) / x + Math.Log(x);
            }
            return ret;
        }
        public double HLog(double x)
        {
            double ret;
            if (x < 1.0)
            {
                ret = x;
            }
            else
            {
                ret = Math.Log(x) + 1.0;
            }
            return ret;
        }

        public double SplinePolinomialB(int st, double x)
        {
            double ret = 0.0; double p = Math.Abs(x);
            if (st == 0)
            {
                if (p > 0.5) 
                    ret = 0.0;
                else 
                    ret = 1.0;
            }
            else
                if (st == 1)
                {
                    if (p > 1.0) 
                        ret = 0.0;
                    else 
                        ret = 1.0 - p;
                }
                else
                    if (st == 2)
                    {
                        if (p > 1.5) 
                            ret = 0.0;
                        else 
                            if (p > 0.5) 
                                ret = (p - 1.5) * (p - 1.5) / 2.0;
                            else 
                                ret = 0.75 - p * p;
                    }
                    else
                        if (st == 3)
                        {
                            double q = 1.0 - p;
                            double r = 2.0 - p;
                            if (p > 2.0) ret = 0.0;
                            else 
                                if (p > 1.0) 
                                    ret = r * r * r / 6.0;
                                else 
                                    ret = (1.0 + 3.0 * q + 3.0 * q * q - 3.0 * q * q * q) / 6.0;
                        }
            return ret;
        }

        public double SplineProectionalB(int st, double x)
        {
            double ret = 0.0;
            if (st == 0)
            {
                ret = (Erf((x + 0.5) / Math.Sqrt(2.0)) - Erf((x - 0.5) / Math.Sqrt(2.0))) / 2.0;
            }
            else
                if (st == 1)
                {
                    ret = (Erff((x + 1.0) / Math.Sqrt(2.0)) + Erff((x - 1.0) / Math.Sqrt(2.0)) -
                             2.0 * Erff(x / Math.Sqrt(2.0))) / Math.Sqrt(2.0);
                }
            return ret;
        }

        double Expp(double x)
        {
            return 1.0 / (1.0 + Math.Exp(-x)) - 0.5;
        }

        double Lnch(double x)
        {
            return Math.Log(2.0 * Math.Cosh(x / 2.0));
        }

        public double FunctionProectionalExp(double x)
        {
            return 2.0 * ((x + 1.0) * Expp(x + 1.0) + (x - 1.0) * Expp(x - 1.0) - 2.0 * x * Expp(x)) -
                    (Lnch(x + 1.0) + Lnch(x - 1.0) - 2.0 * Lnch(x)); ;
        }

        public double SplinePolinomialG(int st, double x)
        {
            double p = Math.Abs(x);
            return step(st, p);
        }

        public double SplineHiperbolic(int st, double al, double x)
        {
            double p = Math.Abs(x / al);
            double ret = 0.0;
            if (st == 1)
            {
                ret = Math.Sinh(p) / 2.0;
            }
            else
                if (st == 3)
                {
                    ret = (Math.Sinh(p) - p - p * p * p / 6.0) / 2.0 / step(4, al);
                }
            return ret;
        }

        public double SplineTrigonometric(int st, double al, double x)
        {
            double p = Math.Abs(x / al); double a = _Pi / 2.0 / al; double b = a / 2.0;
            double ret = 0.0;
            if (st == 3)
            {
                ret = a * (Math.Sin(p) - p * Math.Cos(p));
            }
            else
                if (st == 5)
                {
                    ret = (Math.Sin(p) - p * Math.Cos(p) + p * p / 3.0 * Math.Sin(p)) * b;
                }
            return ret;
        }

        public double SplineTrigonomExp(int st, double al, double x)
        {
            double p = Math.Abs(x / al); double q = (x / al);
            double ret = 0.0;
            if (st == 3)
            {
                ret = Math.Exp(-p) * (Math.Sin(p) + Math.Cos(p)) / 2.0 / al;
            }
            else
                if (st == 5)
                {
                    ret = sgn(x) * (Math.Cosh(q) * Math.Sin(q) - Math.Sinh(q) * Math.Cos(q)) / 4.0 / al;
                }
            return ret;
        }

        public double SplineOfStudent(int st, double al, double x)
        {
            double p = x / al;
            return 1.0 / step(st, 1.0 + p * p / (2.0 * st - 1.0));
        }

        public double SplineCorrelationalLag(int st, double al, double x)
        {
            double ret = 0.0; double p = Math.Abs(x / al);
            if (st == 1)
            {
                ret = 0.5 / al * Math.Exp(-p);
            }
            else
                if (st == 2)
                {
                    ret = 0.25 / al * (1.0 + p) * Math.Exp(-p);
                }
                else
                    if (st == 3)
                    {
                        ret = 3.0 / 16.0 / al * (1.0 + p + (1.0 / 3.0) * p * p) * Math.Exp(-p);
                    }
            return ret;
        }

        public double SplineCorrelationalLoc(int st, double al, double x)
        {
            double ret = 0.0; double p = Math.Abs(x / al); double a = 1.0 / (2.0 * (Math.Cosh(1.0) - 1.0));
            if (st == 1)
            {
                ret = (p < 1.0) ? a / al * Math.Sinh(1.0 - p) : 0.0;
            }
            else
                if (st == 2)
                {
                    double q = 1.0 - p;
                    double r = 2.0 - p;
                    if (p > 2.0) 
                        ret = 0.0;
                    else 
                        if (p > 1.0) 
                            ret = (r * Math.Cosh(r) - Math.Sinh(r)) / 2.0;
                        else 
                            ret = -Math.Cosh(p) + Math.Cosh(1.0) * (Math.Sinh(q) + p * Math.Cosh(q)) -
                                (Math.Sinh(p) - p * Math.Cosh(p)) / 2.0;
                }
            return a * a / al * ret;
        }

        public double SplineIntegral(int st, double al, double x)
        {
            double ret = 0.0; double p = Math.Abs(x); double q = Math.Abs(x / al);
            if (st == 2)
            {
                ret = (p < 0.5) ? (p * p + 0.25) : p;
            }
            else
                if (st == 3)
                {
                    ret = (q < 1.0) ? (-step(3, q) / 3.0 + step(2, q) + 1.0 / 3.0) : q;
                }
            return ret;
        }

        public double SplineOfVariableHardly(int st, double al, double x, double y)
        {
            double ret = 0.0;
            if (st == 1)
            {
                ret = (Math.Abs(x - y) / al * (Math.Exp(-x / al) + Math.Exp(-y / al)) / 2.0 + sgn(x - y) *
                             (Math.Exp(-x / al) - Math.Exp(-y / al))) * al;
            }
            else
                if (st == 2)
                {
                    ret = (Math.Abs(x - y) / al -
                        (1.0 + x / al * y / al) * sgn(x - y) * (Math.Atan(x / al) - Math.Atan(y / al))) * al / 4.0;
                }
            return ret;
        }

        public double FunctionGloc1(double x)
        {
            double p = Math.Abs(x);
            return (p < 1.0) ? 2.0 * step(3, p) - 3.0 * p * p + 1.0 : 0.0;
        }

        public double ClocG(int nl)
        {
            int i; double a2, b2, h, s1, s2, y;
            a2 = -1.0; b2 = 1.0;
            h = (b2 - a2) / (2.0 * nl); s2 = 0.0; s1 = FunctionGloc1(b2 - h); y = a2;
            for (i = 1; i < nl; i++)
            {
                y = y + h; s1 = s1 + FunctionGloc1(y);
                y = y + h; s2 = s2 + FunctionGloc1(y);
            };
            return (FunctionGloc1(a2) + FunctionGloc1(b2) + 4.0 * s1 + 2.0 * s2) * h / 3.0;
        }

        public double FunctionGloc2(double x)
        {
            double p = Math.Abs(x);
            return (p < 2.0) ? step(3, p) - 3.0 * p * p + 4.0 : 0.0;
        }

        public double FunctionLittleCap(double x)
        {
            double y = Math.Abs(x);
            return (y < 1) ? Math.Exp(-(1.0 / (1.0 - y * y))) : 0.0;
        }

        public double FunctionLocCos(int st, double x)
        {
            double ret = 0.0;
            double y = Math.Abs(x);
            if (st == 1)
                ret = (y < 1) ? step(st, Math.Cos(_Pi / 2.0 * x)) * step(st, 1.0 - x * x) : 0.0;
            else
                if (st == 2)
                    ret = (y < 1) ? step(st, Math.Cos(_Pi / 2.0 * x)) * step(st, 1.0 - x * x) : 0.0;
            return ret;
        }

        public double FunctionPolinomial(double x)
        {
            return x * x;
        }

        public double FunctionHiperbolic(double x)
        {
            return Math.Cosh(x) - 1.0;
        }

        public double BasicElement(int st, double al, double x, double y)
        {
            double ret = 0.0; double t = Math.Abs(x);
            switch (TypeOfBasicElement)
            {
                case 1: ret = SplinePolinomialB(0, x);
                    goto M;
                case 2: ret = SplinePolinomialB(1, x);
                    goto M;
                case 3: ret = SplineNloc(x) / ClocN(nl);
                    goto M;
                case 4: ret = FunctionGloc1(x) / ClocG(nl);
                    goto M;
                case 5: ret = SplinePolinomialG(st, x);
                    goto M;
                case 6: ret = SplinePolinomialG(3, Math.Sqrt(t));
                    goto M;
                case 7: ret = SplinePolinomialG(1, Math.Sqrt(t));
                    goto M;
                case 8: ret = SplinePolinomialB(st, x);
                    goto M;
                case 9: ret = SplineHiperbolic(st, al, x);
                    goto M;
                case 10: ret = SplineCorrelationalLag(st, al, x);
                    goto M;
                case 11: ret = SplineCorrelationalLoc(st, al, x);
                    goto M;
                case 12: ret = SplineTrigonometric(st, al, x);
                    goto M;
                case 13: ret = SplineTrigonomExp(st, al, x);
                    goto M;
                case 14: ret = SplineIntegral(st, al, x);
                    goto M;
                case 15: ret = SplineOfVariableHardly(st, al, x, y);
                    goto M;
                case 16: ret = SplineProectionalB(st, x);
                    goto M;
                case 17: ret = SplineOfStudent(st, al, x);
                    goto M;
                case 18: ret = FunctionProectionalExp(x);
                    goto M;
                case 19: ret = FunctionLittleCap(x);
                    goto M;
                case 20: ret = FunctionGloc2(x);
                    goto M;
                case 21: ret = FunctionLocCos(st, x);
                    goto M;
                case 22: ret = FunctionHiperbolic(x);
                    goto M;
                case 23: ret = FunctionPolinomial(x);
                    goto M;
                default: 
                    goto M;
            }
        M: return ret;
        }

        public double Tch(int pr, double x)
        {
            int i;
            double p, q;
            double r = 0.0;
            if (pr == 0)
                return 1.0;
            else 
                if (pr == 1)
                    return x;
                else
                {
                    p = 1.0; q = x;
                    for (i = 2; i <= pr; i++)
                    {
                        r = 2.0 * x * q - p; p = q; q = r;
                    }
                    return r;
                }
        }

        public double fb(int pr, double x, double y)
        {
            return Math.Cos(x * Math.Sin(y) - pr * y) / _Pi;
        }

        public double Bessel(int pr, double x)
        {
            int i, n1;
            double y, s1, s2, h;

            n1 = 15; h = _Pi / (2.0 * n1); s2 = 0.0; s1 = fb(pr, x, _Pi - h); y = 0.0;
            for (i = 1; i < n1; i++)
            {
                y = y + h; s1 = s1 + fb(pr, x, y);
                y = y + h; s2 = s2 + fb(pr, x, y);
            }
            return (fb(pr, x, 0.0) + fb(pr, x, _Pi) + 4.0 * s1 + 2.0 * s2) * h / 3.0;
        }

        public double fe(double x, double y)
        {
            return Math.Sqrt(1.0 - x * x * Math.Sin(y) * Math.Sin(y));
        }

        public double E(double x)
        {
            double c, d, a, b, s, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10,
            w1, w2, w3, w4, w5, w6, w7, w8, w9, w10;
            c = 0.0; d = _Pi / 2.0;
            x6 = 0.148874338981631; x7 = 0.433395394129247; x8 = 0.679409568299024;
            x9 = 0.865063366688985; x10 = 0.973906528517172;
            x1 = -x10; x2 = -x9; x3 = -x8; x4 = -x7; x5 = -x6;
            w6 = 0.295524224714753; w7 = 0.269266719309996; w8 = 0.219086362515982;
            w9 = 0.149451349150581; w10 = 0.066671344308688;
            w1 = w10; w2 = w9; w3 = w8; w4 = w7; w5 = w6;
            a = (d - c) / 2.0; b = (c + d) / 2.0;
            x1 = a * x1 + b; x2 = a * x2 + b; x3 = a * x3 + b; x4 = a * x4 + b; x5 = a * x5 + b;
            x6 = a * x6 + b; x7 = a * x7 + b; x8 = a * x8 + b; x9 = a * x9 + b; x10 = a * x10 + b;
            s = w1 * fe(x, x1) + w2 * fe(x, x2) + w3 * fe(x, x3) + w4 * fe(x, x4) + w5 * fe(x, x5) +
            w6 * fe(x, x6) + w7 * fe(x, x7) + w8 * fe(x, x8) + w9 * fe(x, x9) + w10 * fe(x, x10);
            return a * s;
        }

        public double J0(double x)
        {
            double y, p, q, f0, tet0;

            if (Math.Abs(x) < 3.0)
            {
                p = x / 3.0;
                y = 1.0 - 2.2499997 * step(2, p) + 1.2656208 * step(4, p) - 0.3163866 * step(6, p) +
                0.0444479 * step(8, p) - 0.0039444 * step(10, p) + 0.0002100 * step(12, p);
            }
            else
            {
                q = 3.0 / x;
                f0 = 0.79788456 - 0.00000077 * q - 0.00552740 * q * q - 0.00009512 * q * q * q +
                    0.00137273 * step(4, q) - 0.00072805 * step(5, q) + 0.00014476 * step(6, q);
                tet0 = x - 0.78539816 - 0.04166397 * q - 0.00003954 * q * q + 0.00262573 * q * q * q -
                    0.00054125 * step(4, q) - 0.00029333 * step(5, q) + 0.00013558 * step(6, q);
                y = 1.0 / Math.Sqrt(x) * f0 * Math.Cos(tet0);
            }
            return y;
        }

        public double ArctX(double x)
        {
            double k, s, t, a, y, eps;
            eps = 0.0000000001;
            k = 0.0; y = Math.Abs(x);
            if (y > 1.0) 
            { 
                a = 1.0 / y; s = 1.0 / y; 
            }
            else 
            { 
                s = y; a = y; 
            }
            do
            {
                if (y > 1.0)
                { 
                    t = -step(2, (2.0 * k + 1.0) / (2.0 * k + 3.0) / y); 
                    a = a * t; s = s + a; k = k + 1.0; 
                }
                else 
                { 
                    t = -step(2, (2.0 * k + 1.0) / (2.0 * k + 3.0) * y); 
                    a = a * t; s = s + a; k = k + 1.0; 
                }
            } while (Math.Abs(a) > eps);
            if (y > 1.0) 
                s = s + _Pi / 2.0 * Math.Log(y);
            if (x < 0.0) 
                s = -s;
            return s;
        }

        public double BasisElement(int i, double x)
        {
            double t = 0.0; double ret = 0.0;
            switch (TypeOfBasicElement)
            {
                case 1:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(0, 1.0, t, 0.0);
                    goto M;
                case 2:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(1, 1.0, t, 0.0);
                    goto M;
                case 3:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(1, 1.0, t, 0.0);
                    goto M;
                case 4:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(1, 1.0, t, 0.0);
                    goto M;
                case 5:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 6:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 7:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 8:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 9:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 10:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 11:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 12:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 13:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 14:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 15:
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, x, xi(i));
                    goto M;
                case 16:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 17:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 18:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 19:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 20:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 21:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 22:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 23:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                default: 
                    goto M;
            }
        M: return ret;
        }

        public double KvasiLagrangeErf(int i, double x)
        {
            double p;
            p = (x - xi(i)) / h;
            return SplineProectionalB(0, p);
        }

        public double KvasiLagrangeErff(int i, double x)
        {
            double p;
            p = (x - xi(i)) / h;
            return SplineProectionalB(1, p);
        }

        public double LagrangeAlgebraic(int i, double x)
        {
            int k; double p, ri, rk;

            p = 1.0;
            if (keyOfJob == 1)
                ri = Math.Cos((2.0 * i + 1.0) * _Pi / (2.0 * n));
            else ri = a1 + i * h;
            for (k = 0; k < n; k++)
            {
                if (keyOfJob == 1)
                    rk = Math.Cos((2.0 * k + 1.0) * _Pi / (2.0 * n));
                else rk = a1 + k * h;
                if (k != i) p = p * (x - rk) / (ri - rk);
            };
            return p;
        }

        public double LagrangeTrigonometric(int i, double x)
        {
            int k; double p, rk, ri;

            p = 1.0;
            ri = 2.0 * i * _Pi / (2.0 * n + 1);
            for (k = -n; k <= n; k++)
            {
                rk = 2.0 * k * _Pi / (2.0 * n + 1);
                if (k != i) p = p * Math.Sin((x - rk) / 2.0) / Math.Sin((ri - rk) / 2.0);
            };
            return p;
        }

        public double LagrangeTrigonometricCos(int i, double x)
        {
            int k; double p, rk, ri;
            p = 1.0;
            ri = (2.0 * i + 1) * _Pi / 2.0 / (n + 1);
            for (k = 0; k <= n; k++)
            {
                rk = (2.0 * k + 1) * _Pi / 2.0 / (n + 1);
                if (k != i) p = p * (Math.Cos(x) - Math.Cos(rk)) / (Math.Cos(ri) - Math.Cos(rk));
            }
            return p;
        }

        public double LagrangeTrigonometricSin(int i, double x)
        {
            int k; double p, rk, ri;
            p = 1.0;
            ri = (i + 1) * _Pi / (n + 1);
            for (k = 0; k <= (n - 1); k++)
            {
                rk = (k + 1) * _Pi / (n + 1);
                if (k != i) p = p * (Math.Cos(x) - Math.Cos(rk)) / (Math.Cos(ri) - Math.Cos(rk));
            }
            p = p * Math.Sin(x) / Math.Sin(ri);
            return p;
        }

        public double KvasiLagrangeNDel(int i, double x)
        {
            double p, ND;
            p = (x - xi(i)) / h;
            if (p > 10.0) ND = 0.0;
            else ND = Math.Exp(-p * p / 2.0) / Math.Sqrt(2.0 * _Pi);
            return ND;
        }

        public double KvasiLagrangeLDel(int i, double x)
        {
            double p, LD;
            p = Math.Abs((x - xi(i)) / h);
            if (p > 50.0) 
                LD = 0.0;
            else 
                LD = (3.0 / 16.0) * (1.0 + p + p * p / 3.0) * Math.Exp(-p);
            return LD;
        }

        public double KvasiLagrangeNlocDel(int i, double x)
        {
            double p;
            p = (x - xi(i)) / h;
            return SplineNloc(p);
        }

        public double BasisFunction(int i, double x)
        {
            double ret = 0.0; double t = 0.0;
            switch (TypeOfBasicElement)
            {
                case 1: 
                    ret = LagrangeAlgebraic(i, x);
                    break;
                case 2: 
                    ret = LagrangeTrigonometric(i, x);
                    break;
                case 3:
                    ret = LagrangeTrigonometricCos(i, x);
                    break;
                case 4: ret = KvasiLagrangeNDel(i, x);
                    break;
                case 5: ret = KvasiLagrangeLDel(i, x);
                    break;
                case 6: ret = KvasiLagrangeNlocDel(i, x);
                    break;
                case 7: ret = KvasiLagrangeErf(i, x);
                    break;
                case 8: ret = KvasiLagrangeErff(i, x);
                    break;
                case 9:
                    t = (x - xi(i));
                    ret = ret = SplineCorrelationalLag(st, al, x); 
                    break;
                case 10:
                    t = (x - xi(i)) / h;
                    ret = SplineCorrelationalLoc(st, al, x); 
                    break;
                default: 
                    ret = 0.0;
                    break;
            }
            return ret;

        }

        public void MatrixVectf(double[,] a)
        {
            int i, j;

            for (i = 0; i < n; i++)
                for (j = 0; j < n; j++)
                {
                    double x2 = a1 + j * h;
                    a[j, i] = BasisFunction(i, x2);
                }
            return;
        }

        public void MatrixInvers(double[,] a, double[,] X)
        {
            int i, j, k;
            for (k = 0; k < n; k++)
                for (i = 0; i < n; i++)
                    X[i, k] = (i == k) ? 1.0 : 0.0;
            for (k = 0; k < n; k++)
            {
                int l = k;
                double t = Math.Abs(a[k, k]);
                for (i = k + 1; i < n; i++)
                    if (Math.Abs(a[i, k]) > t)
                    {
                        l = i;
                        t = Math.Abs(a[i, k]);
                    }
                if (l != k)
                {
                    for (j = k; j < n; j++)
                    {
                        double t1 = a[k, j];
                        a[k, j] = a[l, j];
                        a[l, j] = t1;
                    }
                    for (j = 0; j < n; j++)
                    {
                        double t1 = X[k, j];
                        X[k, j] = X[l, j];
                        X[l, j] = t1;
                    }
                }
                for (j = k + 1; j < n; j++)
                    a[k, j] /= a[k, k];
                for (j = 0; j < n; j++)
                    X[k, j] /= a[k, k];

                for (i = 0; i < n; i++)
                    if (i != k)
                    {
                        for (j = k + 1; j < n; j++)
                            a[i, j] -= a[i, k] * a[k, j];
                        for (j = 0; j < n; j++)
                            X[i, j] -= a[i, k] * X[k, j];
                    }
            }
            return;
        }

        public double BasisFunctionInvers(int j, double x)
        {
            int i; double s;
            s = 0.0;
            for (i = 0; i < n; i++)
                s = s + X[i, j] * BasisFunction(i, x);
            return s;
        }

        public void GaussB(double[] alf, double[] bet, double[] gam, double[] b, double[] x)
        {
            int i;
            for (i = 1; i < n; i++)
            {
                alf[i] = alf[i] - bet[i - 1] * gam[i - 1] / alf[i - 1];
                b[i] = b[i] - bet[i - 1] * b[i - 1] / alf[i - 1];
            }
            x[n - 1] = b[n - 1] / alf[n - 1];
            for (i = n - 2; i >= 0; i--) 
                x[i] = (b[i] - gam[i] * x[i + 1]) / alf[i];
            return;
        }

        public void GaussS3(double[] alf, double[] bet, double[] gam, double[] b, double[] x)
        {
            int i;
            for (i = 1; i <= (n - 3); i++)
            {
                alf[i] = alf[i] - bet[i - 1] * gam[i - 1] / alf[i - 1];
                b[i] = b[i] - bet[i - 1] * b[i - 1] / alf[i - 1];
            }
            x[n - 3] = b[n - 3] / alf[n - 3];
            for (i = (n - 4); i >= 0; i--) 
                x[i] = (b[i] - gam[i] * x[i + 1]) / alf[i];
            return;
        }

        public static void Gauss(int n, double[,] a, double[] b, double[] x) 
        {
            int i, j, k;
            double det = 1.0;
            for (k = 0; k < n - 1; k++)
            {
                int l = k; double t = Math.Abs(a[k, k]);
                for (i = k + 1; i < n; i++)
                    if (Math.Abs(a[i, k]) > t) { l = i; t = Math.Abs(a[i, k]); };
                if (l != k)
                {
                    for (j = k; j < n; j++)
                    {
                        t = a[k, j];
                        a[k, j] = a[l, j]; a[l, j] = t;
                    }
                    t = b[k]; b[k] = b[l]; b[l] = t;
                }
                det *= a[k, k];
                for (i = k + 1; i < n; i++)
                {
                    double d = a[i, k] / a[k, k];
                    for (j = k + 1; j < n; j++)
                        a[i, j] -= d * a[k, j];
                    b[i] -= d * b[k];
                }
            }
            x[n - 1] = b[n - 1] / a[n - 1, n - 1];
            for (i = n - 2; i >= 0; i--)
            {
                double s = 0;
                for (j = i + 1; j < n; j++)
                    s = s + a[i, j] * x[j];
                x[i] = (b[i] - s) / a[i, i];
            }
            return;
        }
 
        public void GaussJ(double[,] a, double[] b, double[] x)//стр.137
        {
            int i, j, k;
            for (k = 0; k < n; k++)
            {
                int l = k;
                double t = Math.Abs(a[k, k]);
                for (i = k + 1; i < n; i++)
                    if (Math.Abs(a[i, k]) > t)
                    {
                        l = i;
                        t = Math.Abs(a[i, k]);
                    }
                if (l != k)
                {
                    for (j = k; j < n; j++)
                    {
                        double t1 = a[k, j];
                        a[k, j] = a[l, j];
                        a[l, j] = t1;
                    };
                    t = b[k];
                    b[k] = b[l];
                    b[l] = t;
                }
                for (j = k + 1; j < n; j++)
                    a[k, j] /= a[k, k];

                b[k] /= a[k, k];
                for (i = 0; i < n; i++)
                    if (i != k)
                    {
                        for (j = k + 1; j < n; j++)
                            a[i, j] -= a[i, k] * a[k, j];
                        b[i] -= a[i, k] * b[k];
                    }
            }
            for (i = 0; i < n; i++)
                x[i] = b[i];
            return;
        }

        public static void Relax(int n, double[,] a, double[] b, double[] x)
        {
            int i, j, k; double t, d, r;
            double aij = 0.0; double s = 0.0;
            for (i = 0; i < n; i++) x[i] = 0.0;
            for (k = 0; k < kmax; k++)
            {
                for (i = 0; i < n; i++)
                {
                    for (j = i; j < n; j++)
                    {
                        if (j == i) s = (1 - omega) * a[i, i] * x[i];
                        else s = s - omega * a[i, j] * x[j];
                    }
                    trac[i] = s + omega * b[i];
                }

                d = -1.0;
                t = trac[0] / a[0, 0];
                r = Math.Abs(t - x[0]);
                if (r > d) d = r;
                x[0] = t;
                for (i = 1; i < n; i++)
                {
                    s = 0.0;
                    for (j = 0; j < i; j++)
                    {
                        aij = omega * a[i, j];
                        s = s + aij * x[j];
                    }
                    t = (trac[i] - s) / a[i, i];
                    r = Math.Abs(t - x[i]);
                    if (r > d) d = r;
                    x[i] = t;
                };
                if (d < 0.00000001) goto M2;
            }
            //MessageBox.Show("MatrixVectZ. Tochnost ne dostignuta  k = " + k.ToString());
            goto M1;
        M2:
            //MessageBox.Show("MatrixVectZ  k = " + k.ToString());
        M1: return;
        }

        public static void Zeidel(int n,double[,] a, double[] b, double[] x)//стр.137
        {
            int i, j, k; double s, t, d, r;

            for (i = 0; i < n; i++) x[i] = 0.0;
            for (k = 0; k < kmax; k++)
            {
                d = -1.0;
                for (i = 0; i < n; i++)
                {
                    s = 0.0;
                    for (j = 0; j < i; j++) s = s + a[i, j] * x[j];
                    for (j = i + 1; j < n; j++) s = s + a[i, j] * x[j];
                    t = (b[i] - s) / a[i, i]; r = Math.Abs(t - x[i]);
                    if (r > d) d = r;
                    x[i] = t;
                };
                if (d < EpsZeidel) goto M2;
            }
            //MessageBox.Show("MatrixVectZ. Tochnost ne dostignuta" + n.ToString());
            goto M1;
        M2: //MessageBox.Show("MatrixVectZ" + n.ToString());
        M1: return;
        }

        public void Mfss(double[] aa, int n, double[] trac)
        {
            double sum, piv, hold; int i, j, k, isub, kpiv, ksub, kmi, ji, idc, jj, kk, ii, jk, l;

            isub = 0;
            ksub = 0;
            kpiv = 0;
            j = 0;
            piv = 0.0;

            for (k = 1; k <= n; k++)
            {
                j = j + k;
                trac[k - 1] = aa[j - 1];
                if ((aa[j - 1] - piv) > 0)
                {
                    piv = aa[j - 1];
                    ksub = j;
                    kpiv = k;
                }
            }

            for (i = 1; i <= n; i++)
            {
                isub = isub + i;
            m4: kmi = kpiv - i;

                if (kmi < 0)
                    goto m35;
                if (kmi == 0)
                    goto m9;
                ji = ksub - kmi;
                idc = ji - isub;
                jj = isub - i + 1;
                for (k = jj; k <= isub; k++)
                {
                    kk = k + idc;
                    hold = aa[k - 1];
                    aa[k - 1] = aa[kk - 1];
                    aa[kk - 1] = hold;
                }
                kk = ksub;
                for (k = kpiv; k <= n; k++)
                {
                    ii = kk - kmi;
                    hold = aa[kk - 1];
                    aa[kk - 1] = aa[ii - 1];
                    aa[ii - 1] = hold;
                    kk = kk + k;
                }
                jj = kpiv - 1;
                ii = isub;
                for (k = i; k <= jj; k++)
                {
                    hold = aa[ii - 1];
                    aa[ii - 1] = aa[ji - 1];
                    aa[ji - 1] = hold;
                    ii = ii + k;
                    ji = ji + 1;
                }

            m9: if (irank < 0)
                    goto m22;
                trac[kpiv - 1] = trac[i - 1];
                trac[i - 1] = kpiv;
                kk = i - 1 - irank;
                kmi = isub - kk;
                piv = 0.0;
                idc = irank + 1;
                ji = isub - 1;
                jk = kmi;
                jj = isub - i;
                for (k = i; k <= n; k++)
                {
                    sum = 0.0;
                    if (kk <= 0)
                        goto m13;
                    for (j = kmi; j <= ji; j++) { sum = sum - aa[j - 1] * aa[jk - 1]; jk = jk + 1; }
                m13: jj = jj + k;
                    if ((k - i) > 0)
                        goto m16;
                    sum = aa[isub - 1] + sum;
                    if ((sum - Math.Abs(aa[isub - 1] * EpsMfss)) <= 0)
                        goto m20;
                    aa[isub - 1] = Math.Sqrt(sum);
                    kpiv = i + 1;
                    goto m19;
                m16: sum = (aa[jk - 1] + sum) / aa[isub - 1];
                    aa[jk - 1] = sum;
                    if (aa[jj - 1] <= 0)
                        goto m19;
                    trac[k - 1] = trac[k - 1] - (sum * sum);
                    hold = trac[k - 1] / aa[jj - 1];
                    if ((piv - hold) >= 0)
                        goto m19;
                    piv = hold;
                    kpiv = k;
                    ksub = jj;
                m19: jk = jj + idc;
                }
                goto m32;
            m20: if (irank > 0)
                    goto m37;
                irank = -1;
                goto m4;
            m22: irank = i - 1;
                ii = isub - irank;
                ji = ii;
                for (k = 1; k <= irank; k++)
                {
                    ji = ji - 1;
                    jk = isub - 1;
                    jj = k - 1;
                    for (j = i; j <= n; j++)
                    {
                        idc = irank;
                        sum = 0.0;
                        kmi = ji;
                        kk = jk;
                        if (jj <= 0)
                            goto m25;
                        for (l = 1; l <= jj; l++)
                        {
                            idc = idc - 1;
                            sum = sum - aa[kmi - 1] * aa[kk - 1];
                            kmi = kmi - idc;
                            kk = kk - 1;
                        }
                    m25: aa[kk - 1] = (sum + aa[kk - 1]) / aa[kmi - 1];
                        jk = jk + j;
                    }
                }
                jj = isub - i;
                piv = 0.0;
                kk = isub - 1;
                for (k = i; k <= n; k++)
                {
                    jj = jj + k;
                    idc = 0;
                    for (j = k; j <= n; j++)
                    {
                        sum = 0.0;
                        kmi = jj + idc;
                        for (l = ii; l <= kk; l++)
                        {
                            jk = l + idc;
                            sum = sum + aa[l - 1] * aa[jk];
                        }
                        aa[kmi - 1] = sum;
                        idc = idc + j;
                    }
                    aa[jj - 1] = aa[jj - 1] + 1.0;
                    trac[k - 1] = aa[jj - 1];
                    if ((piv - aa[jj - 1]) >= 0)
                        goto m30;
                    kpiv = k;
                    ksub = jj;
                    piv = aa[jj - 1];
                m30: ii = ii + k;
                    kk = kk + k;
                }
                goto m4;
            m32: ;
            }
            if (irank == 0) 
            { 
                irank = n; 
                return; 
            }
            else 
                return;
        m35: return;
        m37: irank = -1;
            return;
        }

        public void Mlss(double[] aa, int n, double[] trac, double[] rhs)
        {
            double sum, hold; int i, j, idef, ite, ix2, isw, ista, iend, jj, kk, ii;

            idef = n - irank;
            if (n <= 0)
                goto m33;
            if (irank <= 0)
                goto m33;
            if (idef < 0)
                goto m33;
            ite = irank * (irank + 1) / 2;
            ix2 = irank + 1;
            ier = 0;
            jj = 1;
            ii = 1;
        m4: for (i = 1; i <= n; i++)
            {
                j = (int)(trac[ii - 1]);
                if (j <= 0)
                    goto m31;
                hold = rhs[ii - 1];
                rhs[ii - 1] = rhs[j - 1];
                rhs[j - 1] = hold;
                ii = ii + jj;
            }
            if (jj < 0)
                goto m32;
            isw = 1;
            if (inc * idef == 0)
                goto m28;
        m8: ista = ite;
            for (i = 1; i <= irank; i++)
            {
                ista = ista + 1;
                jj = ista;
                sum = 0.0;
                for (j = ix2; j <= n; j++)
                {
                    sum = sum + aa[jj - 1] * rhs[j - 1];
                    jj = jj + j;
                }
                rhs[i - 1] = rhs[i - 1] + sum;
            }
            if (isw == 2)
                goto m28;
        m11: ista = ite;
            for (i = ix2; i <= n; i++)
            {
                jj = ista;
                sum = 0.0;
                for (j = 1; j <= irank; j++)
                {
                    jj = jj + 1;
                    sum = sum + aa[jj - 1] * rhs[j - 1];
                }
                if (isw == 3)
                    goto m14;
                sum = -sum;
            m14: rhs[i - 1] = sum;
                ista = ista + i;
            }
            if (isw == 3)
                goto m30;
            if (isw == 2)
                goto m29;
        m16: ista = ix2;
            iend = n;
            jj = ite + ista;
        m17: sum = 0.0;
            for (i = ista; i <= iend; i++)
            {
                if (aa[jj - 1] == 0)
                    goto m31;
                rhs[i - 1] = (rhs[i - 1] - sum) / aa[jj - 1];
                if (i >= iend)
                    goto m21;
                jj = jj + ista;
                sum = 0.0;
                for (j = ista; j <= i; j++)
                {
                    sum = sum + aa[jj - 1] * rhs[j - 1];
                    jj = jj + 1;
                }
            }
        m21: sum = 0.0;
            ii = iend;
            for (i = ista; i <= iend; i++)
            {
                rhs[ii - 1] = (rhs[ii - 1] - sum) / aa[jj - 1];
                if (ii <= ista)
                    goto m25;
                kk = jj - 1;
                sum = 0.0;
                for (j = ii; j <= iend; j++)
                {
                    sum = sum + aa[kk - 1] * rhs[j - 1];
                    kk = kk + j;
                }
                jj = jj - ii;
                ii = ii - 1;
            }
        m25: if (idef == 0)
                goto m30;
            if (isw == 2)
                goto m11;
            if (isw == 3)
                goto m8;
            isw = 2;
            goto m8;
        m28: ista = 1;
            iend = irank;
            jj = 1;
            isw = 2;
            goto m17;
        m29: isw = 3;
            goto m16;
        m30: ii = n;
            jj = -1;
            goto m4;
        m31: ier = 1;
        m32: return;
        m33: ier = -1;
            return;
        }

        public static void Decomp(double[,] a, ref double cond, int[] ipvt, double[] work)
        {
            int i, j, k, m; double anorm, ynorm, znorm, ek, t;
            cond = 1.0D + 272;
            ipvt[n - 1] = 1;
            if (n != 0)
            {
                anorm = 0.0;
                for (j = 0; j < n; j++)
                {
                    t = 0.0;
                    for (i = 0; i < n; i++)
                        t = t + Math.Abs(a[i, j]);
                    if (t > anorm) 
                        anorm = t;
                }
                for (k = 0; k < n - 1; k++)
                {
                    m = k;
                    for (i = k + 1; i < n; i++)
                        if (Math.Abs(a[i, k]) > Math.Abs(a[m, k])) 
                            m = i;
                    ipvt[k] = m;
                    if (m != k) 
                        ipvt[n - 1] = -ipvt[n - 1];
                    t = a[m, k];
                    a[m, k] = a[k, k];
                    a[k, k] = t;
                    if (t != 0.0)
                    {
                        for (i = k + 1; i < n; i++)
                            a[i, k] = -a[i, k] / t;
                        for (j = k + 1; j < n; j++)
                        {
                            t = a[m, j];
                            a[m, j] = a[k, j];
                            a[k, j] = t;
                            if (t != 0.0) 
                                for (i = k + 1; i < n; i++) 
                                    a[i, j] = a[i, j] + a[i, k] * t;
                        }
                    }
                }
                for (k = 0; k < n; k++)
                {
                    t = 0.0;
                    if (k != 0)
                        for (i = 0; i < k - 1; i++) 
                            t = t + a[i, k] * work[i];
                    ek = 1.0;
                    if (t < 0.0) 
                        ek = -1.0;
                    if (a[k, k] == 0.0) 
                        goto metka;
                    work[k] = -(ek + t) / a[k, k];
                }
                for (k = n - 2; k >= 0; k--)
                {
                    t = 0.0;
                    for (i = k + 1; i < n; i++) t = t + a[i, k] * work[k];
                    work[k] = t;
                    m = ipvt[k];
                    if (m != k)
                    {
                        t = work[m];
                        work[m] = work[k];
                        work[k] = t;
                    }
                }
                ynorm = 0.0;
                for (i = 0; i < n; i++) 
                    ynorm = ynorm + Math.Abs(work[i]);
                Solve(a, work, ipvt);
                znorm = 0.0;
                for (i = 0; i < n; i++) 
                    znorm = znorm + Math.Abs(work[i]);
                cond = anorm * znorm / ynorm;
                if (cond < 1.0) 
                    cond = 1.0;
            }
        metka: 
            //MessageBox.Show("MatrixVectDS  " + n.ToString());
            return;
        }

        public static void Solve(double[,] a, double[] b, int[] ipvt)
        {
            int i, k, m; double t;

            if (n != 0)
            {
                for (k = 0; k < n - 1; k++)
                {
                    m = ipvt[k];
                    t = b[m];
                    b[m] = b[k];
                    b[k] = t;
                    for (i = k + 1; i < n; i++)
                    {
                        b[i] = b[i] + a[i, k] * t;
                    }
                }
                for (k = n - 1; k > 0; k--)
                {
                    b[k] = b[k] / a[k, k];
                    t = -b[k];
                    for (i = 0; i < k; i++)
                    {
                        b[i] = b[i] + a[i, k] * t;
                    }
                }
            }
            b[0] = b[0] / a[0, 0];
            return;
        }
    }
}
