﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline1
{
    class BasisFunctionClass : BasicFunctionClass
    {
        static public int N = 1001;
        static public int n = 21;                           // Число базисных функций

        public double h = (b1 - a1) / (double)(n - 1);

        public int PowerOfBasicElement = 2;
        public double WidthOfBasicElement = 10.0;
        public int primer = 1;
        public const double pi = 3.14159265358979323846264338327950288419716939937510;
        public const int pr = 5;                //порядок функций Бесселя или Чебышева

        static public double a1 = -1.0;
        public double Rangemin
        {
            get { return a1; }
            set {a1 = value; }
        }

        static public double b1 = 1.0;           //область определения функций 
        public double Rangemax
        {
            get { return b1; }
            set { b1 = value; }
        }

        public int Number
        {
            get { return n; }
            set { n = value; }
        }

        public double xi(int i)
        {
            return a1 + i * h;
        }

         public double BasisElement(int i, double x)
        {
            double t = 0.0; double ret = 0.0;
            switch (TypeOfBasicElement)
            {
                case 1:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(0, 1.0, t, 0.0);
                    goto M;
                case 2:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(1, 1.0, t, 0.0);
                    goto M;
                case 3:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(1, 1.0, t, 0.0);
                    goto M;
                case 4:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(1, 1.0, t, 0.0);
                    goto M;
                case 5:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 6:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 7:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 8:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 9:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 10:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 11:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 12:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 13:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 14:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 15:
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, x, xi(i));
                    goto M;
                case 16:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 17:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 18:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 19:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 20:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 21:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 22:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                case 23:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    goto M;
                default: MessageBox.Show("sorry, method");
                    goto M;
            }
        M: return ret;
        }

      }
}
