   program interp;
   uses graph,crt;
    const
          ng=640; n=549; a1=-1.0; b1=1.0; h=(b1-a1)/(n-1);
          method=6; pr=4;
    var
          x1,y1,z1:array [1..ng] of real;
          ymas:real;

{===================================================================}
      function F(x:real):real;
        begin
          Case Pr Of
            1: F:=Sin(pi*x);
            2: F:=1/(1+25*sqr(x));
            3: F:=exp(Cos(pi*x));
            4: if abs(x)>1.0 then F:=0.0 else F:=Abs(x);
            5: if abs(x)<0.5 then F:=1.0 else F:=0.0;
          end;
        end;
{===================================================================}
      function Y(x:real):real;
        begin
         if(method>4) then Y:=F(a1)+(F(b1)-F(a1))/(b1-a1)*(x-a1) else Y:=0.0;
        end;

{===================================================================}
  function Xi(i:integer):real;
  begin
    Case Method Of
     1: Xi:= Cos((2*i-1)/(2*n)*pi);
     2: Xi:= 2*pi*i/(2*n+1);
     3: Xi:= (2*i-1)*pi/2/(n+1);
     4: Xi:= pi/(n+1)*i;
     5: Xi:= a1+(i-1)*h;
     6: Xi:= a1+(i-1)*h;
   end;
end;

{====================================================================}

 function Lagr(i:integer;x:real):real;
        var
           p:real; k:integer;
        begin
           p:=1.0;
            for k:=1 to n do if k<>i then
               p:=p*(x-xi(k))/(xi(i)-xi(k));
           Lagr:=p;
        end;
{====================================================================}

 function Trig(i:integer;x:real):real;
        var
           p:real; k:integer;
        begin
           p:=1.0;
             for k:=-n to n do if k<>i then
                 p:=p*Sin((x-xi(k))/2)/Sin((xi(i)-xi(k))/2);
           Trig:=p;
         end;
{====================================================================}

 function Tcos(i:integer;x:real):real;
        var
           p:real;
           k:integer;
        begin
             p:=1.0;
             for k:=1 to n+1 do if k<>i then
                 p:=p*(Cos(x)-Cos(xi(k)))/(Cos(xi(i))-Cos(xi(k)));
         Tcos:=p;
         end;
{====================================================================}

 function Tsin(i:integer;x:real):real;
 var k:integer; p:real;
 begin
    p:=1.0;
    for k:=1 to n do if k<>i then
        p:=p*(Cos(x)-Cos(xi(k)))/(Cos(xi(i))-Cos(xi(k)));
    Tsin:=sin(x)/sin(xi(i))*p;
 end;

 {====================================================================}

 function NGauss(i:integer;x:real):real;
 var p:real;
 begin
    p:=sqr((x-Xi(i))/h);
    if p>100.0 then NGauss:=0.0 else
    NGauss:=1/sqrt(2*Pi)*exp(-p/2);
 end;
 {====================================================================}

 function KLagr(i:integer;x:real):real;
 var p:real;
 begin
    p:=abs((x-Xi(i))/h);
    if p>50.0 then KLagr:=0.0 else
    KLagr:=3/16*(1+p+sqr(p)/3)*exp(-p);
 end;

{===================================================================}
  function Fi(i:integer;x:real):real;
begin
    Case Method Of
     1: Fi:= Lagr(i,x);
     2: Fi:= Trig(i,x);
     3: Fi:= Tcos(i,x);
     4: Fi:= Tsin(i,x);
     5: Fi:= NGauss(i,x);
     6: Fi:= KLagr(i,x);
   end;
end;

{====================================================================}
 procedure Gauss(n:integer; var a:matr; var b:vect; var x:vect);
 var
   kmax,k,i,j:integer;
   smax,d,s:extended {real};
begin
 det:=1.0;
 for k:=1 to n do
 begin
    kmax:=k; smax:=abs(a[k,k]);
     for i:=k+1 to n do
       if abs(a[i,k])>smax then
            begin
              smax:=abs(a[i,k]); kmax:=i;
            end;
       for j:=k to n do
         begin
            d:=a[k,j];
            a[k,j]:=a[kmax,j];
            a[kmax,j]:=d;
         end;
         d:=b[k];
         b[k]:=b[kmax];
         b[kmax]:=d;

        det:=det*a[k,k];
        for j:=k+1 to n do
         a[k,j]:=a[k,j]/a[k,k];
         b[k]:=b[k]/a[k,k];
       for i:=1 to n do
       if i<>k then
       begin
         for j:=k+1 to n do
         a[i,j]:=a[i,j]-a[i,k]*a[k,j];
         b[i]:=b[i]-a[i,k]*b[k];
       end;
 end;
   writeln('det=','   ', det);
   readln;
   for i:=n downto 1 do
     begin
       x[i]:=b[i];
     end;

end;

{====================================================================}
procedure Ab(var a: matrix; var b: vector);
var
  i, j: integer;
begin

           for i:=1 to n do
             for j:=1 to n do
               a[j,i]:= Fi(i,Xi(j));
           for j:=1 to n do
                b[j]:=F(Xi(j));
end;

{====================================================================}

 function Sam(x:real):real;
   var
     s:real;
     i,imin,imax:integer;
   begin
     Case Method Of
       1: begin imin:=1;imax:=n end;
       2: begin imin:=-n; imax:=n end;
       3: begin imin:=1;imax:=n+1 end;
       4: begin imin:=1;imax:=n end;
       5: begin imin:=1;imax:=n end;
       6: begin imin:=1;imax:=n end;
     end;
     s:=0.0;
     for i:=imin to imax do
         begin
           s:=s+(F(Xi(i))-Y(Xi(i)))*Fi(i,x);
         end;
         Sam:=s;
   end;

Procedure Tab;
var
   x,norm,h,yd,yr: real;
   k:integer;
begin
  x:=a1; norm:=-1.0; ymas:=-1.0; h:=(b1-a1)/(ng-1);
  for k:=1 to ng do
 begin
    x1[k]:=x;
    y1[k]:=Sam(x)+Y(x);
    z1[k]:=F(x);
    yr:=abs(y1[k]-z1[k]);
    yd:=abs(z1[k]);
    if yd>ymas then ymas:=yd;
    if yr>norm then norm:=yr;
    x:=x+h;
 end;
    writeln('  norm=  ',norm:9:7,'  ymas=  ',ymas:9:7);
    readln;
end;

Procedure Graphic;
var
    s:string;
    grDriver : Integer;
    grMode   : Integer;
    ErrCode  : Integer;
    ymax,ymin,zmin,zmax:real;
    k:integer;
    xp,yp,zp:word;
begin
   Tab;
   ymin:=-ymas-0.1*ymas;
   ymax:=ymas+0.1*ymas;
   zmin:=-ymas-0.1*ymas;
   zmax:=ymas+0.1*ymas;
   grDriver := Detect;
   InitGraph(grDriver,grMode,'c:\pasc\kol');
   ErrCode := GraphResult;
 if ErrCode = grOk then
 begin
    setbkcolor(2);
    line(320,0,320,479);
    line(0,240,639,240);
    str(x1[1]:5:2,s);
    outtextxy(0,250,s);
     str(x1[ng]:5:2,s);
    outtextxy(600,250,s);
    s:='graphic';
        outtextxy(330,10,s);
    line(630,245,640,240);
    line(10,245,0,240);

    for k:=1 to ng do
       begin
        xp:=round(640/(x1[ng]-x1[1])*(x1[k]-x1[1]));
        yp:=480-round(480/(ymax-ymin)*(y1[k]-ymin));
        putpixel(xp,yp,red);
        zp:=480-round(480/(zmax-zmin)*(z1[k]-zmin));
        putpixel(xp,zp,1);
       end;
 end
       else
      WriteLn('Graphics error:',GraphErrorMsg(ErrCode));
    readln;
    Closegraph;
 end;

BEGIN
Graphic
END.

















