﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline1
{
    class SystemEquation : BasicFunctionClass
    {
        public const int ng = 1024;    
        public int MethodSLAY = 1;  //1-Gauss, 2-Gauss-Jordan
        public int n2=10001;
        public int Method=1; 
        public int m=3;

        public double h2 = 1.0;
        public int d=8;
        public int RadSim = 1;
        public int ni = 21;

        public double alg = 2.0;//3.0-6.0;
        public double alh3 = 20.0;
        public double alh5 = 20.0;
        public double ali = 2.0;
 
        public double[] b = new double[N];
        public double[] x = new double[N];
        double NormLoc;
 
        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];

        static public double ymas = 0.0;

        static public int numberGr = 1024;
        public int NumberGr
        {
            get { return numberGr; }
            set { numberGr = value; }
        }
 
        static public int numberSlay = 1;
        public int NumberSlay
        {
            get { return numberSlay; }
            set { numberSlay = value; }
        }

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }

        public double f(double x)
        {
            double ret = 0.0;
            switch (primer)
            {
                case 1: ret = 1.0 / (1.0 + 25.0 * x * x);
                    goto M;
                case 2: ret = Math.Sin(_Pi * x);
                    goto M;
                case 3: ret = Math.Exp(Math.Cos(_Pi * x));
                    goto M;
                case 4: ret = sgn(x) * step(2, x) * (x - a1) * (x - b1);
                    goto M;
                case 5: ret = Math.Abs(x);
                    goto M;
                case 6: ret = (Math.Abs(x) < 0.5) ? 1.0 : 0.0;
                    goto M;
                case 7: ret = Tch(pr, x);
                    goto M;
                case 8: ret = Bessel(pr, x);
                    goto M;
                case 9: ret = Erf(x);
                    goto M;
                default: MessageBox.Show("sorry f, bad parameter primer");
                    goto M;

            }
        M: return ret;
        }

        public void MatrixVectf(double[,] a, double[] b)
        {
            int i, j;

            for (i = 0; i < n; i++)
                for (j = 0; j < n; j++)
                {
                    a[j, i] = BasisElement(i, xi(j));
                }

            for (j = 0; j < n; j++)
            {
                b[j] = f(xi(j));
            }
            MessageBox.Show("MatrixVectf " + n.ToString());
            return;
        }

        public double Summa(double y)
        {
            int i; double s, p;
            s = 0.0;
            for (i = 0; i < n; i++)
            {
                if (TypeOfBasicElement < 5) p = f(xi(i));
                else if (MethodSLAY == 2) p = b[i]; else p = x[i];
                s = s + BasisElement(i, y) * p;
            }
            return s;
        }

        public double f2(double x, double y)
        {
            double ret = 0.0; double r = x * x + y * y;
            switch (primer)
            {
                case 1: if (KeyOfJob == 2)
                            ret = 1.0 / (1.0 + 1000000.0 * r);
                        else
                            ret = 1.0 / (1.0 + 100.0 * r);
                        goto M;
                case 2: ret = Math.Sin(_Pi * x) * Math.Cos(_Pi * y);
                    goto M;
                case 3: ret = Math.Cos(_Pi * x) * Math.Cos(_Pi * y);
                    goto M;
                case 4: ret = Math.Sin(_Pi * x) * Math.Sin(_Pi * y);
                    goto M;
                case 5: ret = Math.Exp(Math.Cos(_Pi * r) - 2 * r);
                    goto M;
                case 6: ret = Math.Exp(2 * r) / Math.Exp(2);
                    goto M;
                case 7: ret = (Math.Sqrt(r) < 0.5) ? 1.0 : 0.0;
                    goto M;
                case 8: ret = Math.Sin(_Pi * r);
                    goto M;
                case 9: ret = Math.Cos(_Pi * r);
                    goto M;

                default: MessageBox.Show("sorry F, bad parameter primer");
                    goto M; 

            }
        M: return ret;
        }
 
        public double FiH5x(int i, double x)
        {
            double ret, p, hl;
            double z = (double)(n - 1);
            double h = (b1 - a1) / z;
            hl = h * Math.Sqrt(alh5);
            p = (x - xi(i)) / hl;
            ret = sgn(p) * (Math.Sinh(p) - p - 1.0 / 6.0 * step(3, p) - 0.0 * 1.0 / 120.0 * step(5, p));
            return ret;
        }
 
        public double FiH3x(int i, double x)
        {
            double ret, p, hl;
            double z = (double)(n - 1);
            double h = (b1 - a1) / z;
            hl = h * Math.Sqrt(alh3);
            p = (x - xi(i)) / hl;
            ret = sgn(p) * (Math.Sinh(p) - p - 0.0 * 1.0 / 6.0 * step(3, p));
            return ret;
        }

        public double FiIx(int i, double x)
        {
            double ret, p, pf, hl;
            double z = (double)(n - 1);
            double h = (b1 - a1) / z;
            hl = h * Math.Sqrt(ali);
            p = (x - xi(i)) / hl; pf = Math.Abs(p);
            ret = (pf < 1.0) ? 0.5 * (-step(3, pf) / 3.0 + step(2, pf) + 1.0 / 3.0) : 0.5 * pf;
            return ret;
        }

        public double GG2(int i, int j, double x, double y)
        {
            double p, hl; 
            double ret = 0.0; double z = (double)(n - 1);
            double h = (b1 - a1) / z;
            switch (TypeOfBasicElement)
            {
                case 1: ret = step(3, Math.Abs(x - xi(i))) * step(3, Math.Abs(y - xi(j)));
                    goto M;
                case 2: ret = step(5, Math.Abs(x - xi(i))) * step(5, Math.Abs(y - xi(j)));
                    goto M;
                case 3:
                    ret = FiH3x(i, x) * FiH3x(j, y);
                    goto M;
                case 4:
                    ret = FiH5x(i, x) * FiH5x(j, y);
                    goto M;
                case 5:
                    ret = FiIx(i, x) * FiIx(j, y);
                    goto M;
                case 6:
                    hl = h * Math.Sqrt(alg);
                    p = ((x - xi(i)) / hl) * ((x - xi(i)) / hl) + ((y - xi(j)) / hl) * ((y - xi(j)) / hl);
                    if (p > 100.0) ret = 0.0;
                    else
                        ret = Math.Exp(-p / 2);
                    goto M;

                default: MessageBox.Show("sorry G, bad parameter Method");
                    goto M;
            }
        M: return ret;
        }

        public void MatrixVect2(double[,] a, double[] b)
        {
            int k, i, j, k1, i1, j1; 
            double z = (double)(n - 1);
            double h = (b1 - a1) / z;
            k1 = 0;
            for (i1 = 0; i1 < n; i1++)
                for (j1 = 0; j1 < n; j1++)
                {
                    k = 0;
                    for (i = 0; i < n; i++)
                        for (j = 0; j < n; j++)
                        {
                            a[k1, k] = GG2(i, j, xi(i1), xi(j1));
                            k = k + 1;
                        }
                    k1 = k1 + 1;
                };
            k = 0;
            for (i = 0; i < n; i++)
                for (j = 0; j < n; j++)
                {
                    b[k] = f2(xi(i), xi(j));
                    k = k + 1;
                }
            MessageBox.Show("MatrixVectf2 " + n.ToString());
            return;
        }

 

        public double Summa2(double x1, double x2)
        {
            int k, i, j; double s;
            k = 0; s = 0.0;
            for (i = 0; i < n; i++)
                for (j = 0; j < n; j++)
                {
                    s = s + x[k] * GG2(i, j, x1, x2);
                    k = k + 1;
                };
            return s;
        }

        public double Xi(int i)
        {
            double r,h2;
            double z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            r = a1 + i * h2;
            return r;
        }

        public double SplineNloc2(double x)
        {
            double p, q, r;
            p = x * x;
            if (p > 100.0) q = 0.0; else q = Math.Exp(-p / 2) / Math.Sqrt(2 * _Pi);
            if (p > d) r = 0.0; else r = q * step(m, p - d);
            return r;
        }

        public double ClocN2(int ni)
        {
            int i; double a2, b2, h, s1, s2, y,d1;
            d1 = Math.Sqrt(d); a2 = 0.0; b2 = d1;
            h = (b2 - a2) / (2.0 * ni); s2 = 0.0; s1 = SplineNloc2(b2 - h); y = a2;
            for (i = 1; i < ni; i++)
            {
                y = y + h; s1 = s1 + SplineNloc2(y);
                y = y + h; s2 = s2 + SplineNloc2(y);
            };
            return 2.0 * (SplineNloc2(a2) + SplineNloc2(b2) + 4.0 * s1 + 2.0 * s2) * h / 3.0;
        }

        public double FiGauss(int i, double x)
        {
            double p, r, h2;
            double z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            p = ((x - Xi(i)) / h2);
            if (p > 10.0) 
                r = 0.0;
            else
                r = 1.0 / Math.Sqrt(2 * _Pi) * Math.Exp(-p * p / 2);
            return r;
        }

        public double FiLocx(int i, double x)
        {
            double r,h2;
            double z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            r = SplineNloc2((x - Xi(i)) / h2) / NormLoc;
            return r;
        }

        public double FiLocr(int i, int j, double x, double y)
        {
            double r, p, q,h2;
            double z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            p = (x - Xi(i)); q = (y - Xi(j));
            r = SplineNloc2(Math.Sqrt(p * p + q * q) / h2) / NormLoc;
            return r;
        }

        public double Sam1G(double x)
        {
            double s; int i;
            s = 0.0;
            for (i = 0; i < n2; i++)
                s = s + FiGauss(i, x);
            return s;
        }

        public double Sam1L(double x)
        {
            double z,h2; int k;
            z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            k = (int)((x - a1) / h2) + 1; if (k == n2) k = n2 - 1;
            if (k == 1)
            {
                z = FiLocx(1, x) + FiLocx(2, x) + FiLocx(3, x) + 
                    FiLocx(0, x) + FiLocx(-1, x);
                goto m2;
            }
            if (k == 2)
            {
                z = FiLocx(1, x) + FiLocx(2, x) + FiLocx(3, x) + FiLocx(4, x) + 
                    FiLocx(0, x);
                goto m2;
            }
            if (k == n2 - 1)
            {
                z = FiLocx(n2 - 3, x) + FiLocx(n2 - 2, x) + FiLocx(n2 - 1, x) + FiLocx(n2, x) +
                    FiLocx(n2 + 1, x); 
                goto m2;
            }
            if (k == n2 - 2)
            {
                z = FiLocx(n2 - 4, x) + FiLocx(n2 - 3, x) + FiLocx(n2 - 2, x) + FiLocx(n2 - 1, x) + FiLocx(n2, x); 
                goto m2;
            }
            z = FiLocx(k - 2, x) + FiLocx(k - 1, x) + FiLocx(k, x) + FiLocx(k + 1, x) + FiLocx(k + 2, x);
        m2: return z;
        }

        public double SL2(int m, double x, double y)
        {
            double z, h2; int k;
            z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            k = (int)((x - a1) / h2) + 1; if (k == n2) k = n2 - 1;
            if (k == 1)
            {
                z = FiLocr(1, m, x, y) + FiLocr(2, m, x, y) + FiLocr(3, m, x, y) + 
                    FiLocr(0, m, x, y) + FiLocr(-1, m, x, y);
                goto m2;
            }
            if (k == 2)
            {
                z = FiLocr(1, m, x, y) + FiLocr(2, m, x, y) + FiLocr(3, m, x, y) + FiLocr(4, m, x, y) + 
                    FiLocr(0, m, x, y);
                goto m2;
            }
            if (k == n2 - 1)
            {
                z = FiLocr(n2 - 3, m, x, y) + FiLocr(n2-2, m, x, y) + FiLocr(n2 - 1, m, x, y) + 
                    FiLocr(n2, m, x, y) + FiLocr(n2 + 1, m, x, y);
                goto m2;
            }
            if (k == n2 - 2)
            {
                z = FiLocr(n2 - 4, m, x, y) + FiLocr(n2 - 3, m, x, y) + FiLocr(n2-2, m, x, y) + FiLocr(n2 - 1, m, x, y) + 
                    FiLocr(n2, m, x, y);
                goto m2;
            }
            z = FiLocr(k - 2, m, x, y) + FiLocr(k - 1, m, x, y) + FiLocr(k, m, x, y) + FiLocr(k + 1, m, x, y) + FiLocr(k + 2, m, x, y);
        m2: return z;
        }

        public double Sam2L(double x, double y)
        {
            double z,h2; int k;
            z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            k = (int)((y - a1) / h2) + 1; if (k == n2) k = n2 - 1;
            if (k == 1)
            {
                z = SL2(1, x, y) + SL2(2, x, y) + SL2(3, x, y) + 
                    SL2(0, x, y) + SL2(-1, x, y);
                goto m2;
            }
            if (k == 2)
            {
                z = SL2(1, x, y) + SL2(2, x, y) + SL2(3, x, y) + SL2(4, x, y) + 
                    SL2(0, x, y);
                goto m2;
            }
            if (k == n2 - 1)
            {
                z = SL2(n2 - 3, x, y) + SL2(n2-2, x, y) + SL2(n2 - 1, x, y) + 
                    SL2(n2, x, y) + SL2(n2+1, x, y);
                goto m2;
            }
            if (k == n2 - 2)
            {
                z = SL2(n2 - 4, x, y) + SL2(n2 - 3, x, y) + SL2(n2-2, x, y) + SL2(n2 - 1, x, y) + 
                    SL2(n2, x, y);
                goto m2;
            }
            z = SL2(k - 2, x, y) + SL2(k - 1, x, y) + SL2(k, x, y) + SL2(k + 1, x, y) + SL2(k + 2, x, y);
        m2: return z;
        }

        public double FiLoc(int i, int j, double x, double y)
        {
            double z;
            if (RadSim == 1) z = FiLocx(i, x) * FiLocx(j, y) / Sam1L(x) / Sam1L(y);
            else z = FiLocr(i, j, x, y) / Sam2L(x, y);
            return z;
        }

        public double FiGau(int i, int j, double x, double y)
        {
            double z;
            z = FiGauss(i, x) * FiGauss(j, y) / Sam1G(x) / Sam1G(y);
            return z;
        }

        public double SamGau(double x, double y)
        {
            double s; int i, j;
            s = 0.0;
            for (i = 0; i < n2; i++)
                for (j = 0; i < n2; j++)
                    s = s + f2(Xi(i), Xi(j)) * FiGau(i, j, x, y);
            return s;
        }

        public double SamLoc(int m, double x, double y)
        {
            double z,h2; int k;
            z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            k = (int)((x - a1) / h2) + 1; if (k == n2) k = n2 - 1;
            if (k == 1)
            {
                z = f2(Xi(1), Xi(m)) * FiLoc(1, m, x, y) + f2(Xi(2), Xi(m)) * FiLoc(2, m, x, y) + 
                    f2(Xi(3), Xi(m)) * FiLoc(3, m, x, y) + f2(Xi(0), Xi(m)) * FiLoc(0, m, x, y) + 
                f2(Xi(-1), Xi(m)) * FiLoc(-1, m, x, y);
                goto m2;
            }
            if (k == 2)
            {
                z = f2(Xi(1), Xi(m)) * FiLoc(1, m, x, y) + f2(Xi(2), Xi(m)) * FiLoc(2, m, x, y) +
                f2(Xi(3), Xi(m)) * FiLoc(3, m, x, y) + f2(Xi(4), Xi(m)) * FiLoc(4, m, x, y) +
                f2(Xi(0), Xi(m)) * FiLoc(0, m, x, y);
                goto m2;
            }
            if (k == n2 - 1)
            {
                z = f2(Xi(n2 - 3), Xi(m)) * FiLoc(n2 - 3, m, x, y) + f2(Xi(n2-2), Xi(m)) * FiLoc(n2-2, m, x, y) + 
                f2(Xi(n2 - 1), Xi(m)) * FiLoc(n2 - 1, m, x, y) + f2(Xi(n2), Xi(m)) * FiLoc(n2, m, x, y) + 
                f2(Xi(n2 + 1), Xi(m)) * FiLoc(n2 + 1, m, x, y)
                ;
                goto m2;
            }
            if (k == n2 - 2)
            {
                z = f2(Xi(n2 - 4), Xi(m)) * FiLoc(n2 - 4, m, x, y) + f2(Xi(n2 - 3), Xi(m)) * FiLoc(n2 - 3, m, x, y) +
                f2(Xi(n2-2), Xi(m)) * FiLoc(n2-2, m, x, y) + f2(Xi(n2 - 1), Xi(m)) * FiLoc(n2 - 1, m, x, y) + 
                f2(Xi(n2), Xi(m)) * FiLoc(n2, m, x, y);
                goto m2;
            }
            z = f2(Xi(k - 2), Xi(m)) * FiLoc(k - 2, m, x, y) + f2(Xi(k - 1), Xi(m)) * FiLoc(k - 1, m, x, y) +
            f2(Xi(k), Xi(m)) * FiLoc(k, m, x, y) + f2(Xi(k + 1), Xi(m)) * FiLoc(k + 1, m, x, y) +
            f2(Xi(k + 2), Xi(m)) * FiLoc(k + 2, m, x, y);
        m2: return z;
        }

        public double SamL(double x, double y)
        {
            double z,h2; int k;
            z = (double)(n2 - 1);
            h2 = (b1 - a1) / z;
            k = (int)((y - a1) / h2) + 1; if (k == n2) k = n2 - 1;
            if (k == 1)
            {
                z = SamLoc(1, x, y) + SamLoc(2, x, y) + SamLoc(3, x, y) +
                    SamLoc(0, x, y) + SamLoc(-1, x, y);
                goto m2;
            }
            if (k == 2)
            {
                z = SamLoc(1, x, y) + SamLoc(2, x, y) + SamLoc(3, x, y) + SamLoc(4, x, y) +
                    SamLoc(0, x, y);
                goto m2;
            }
            if (k == n2 - 2)
            {
                z = SamLoc(n2 - 4, x, y) + SamLoc(n2 - 3, x, y) + SamLoc(n2 - 2, x, y) + SamLoc(n2 - 1, x, y) +
                    SamLoc(n2, x, y);
                goto m2;
            }
            if (k == n2 - 1)
            {
                z = SamLoc(n2 - 3, x, y) + SamLoc(n2 - 2, x, y) + SamLoc(n2 - 1, x, y) +
                    SamLoc(n2, x, y) + SamLoc(n2 + 1, x, y);
                goto m2;
            }

            z = SamLoc(k - 2, x, y) + SamLoc(k - 1, x, y) + SamLoc(k, x, y) + SamLoc(k + 1, x, y) + SamLoc(k + 2, x, y);
        m2: return z;
        }
 
        public void Tabulation(int[] xp, int[] yp, int[] zp)
        {
            int k;
            double y, z, NormC, NormL2, s, h, yd, yr, zmax, ymax, zmin, ymin;
            double zg = 0.0; double yg = 0.0; double xg = Rangemin; double diag = Math.Sqrt(2.0);
            z = (double)(n - 1);
            h = (Rangemax - Rangemin) / z;
            y = Rangemin;
            NormC = -1.0; s = 0;
            ymas = -1.0;
            z = (double)(ng - 1);
            h = (Rangemax - Rangemin) / z;
            if (KeyOfJob == 2) NormLoc = ClocN2(ni);
            for (k = 0; k < ng; k++)
            {
                if (KeyOfJob == 0)
                {
                    yg = f(y);
                    zg = Summa(y);  
                }
                else
                    if (KeyOfJob == 1)
                    {
                        yg = f2(y, y);
                        zg = Summa2(y, y);
                    }
                    else 
                        if (KeyOfJob == 2)
                        {
                            yg = f2(y, y);
                        if (Method == 1)
                            zg = SamL(y, y);
                        else
                            zg = SamGau(y, y);
                        }
                    else
                            {
                            zg = BasicElement(PowerOfBasicElement, WidthOfBasicElement, y, 0.0);
                            yg = BasicElement(PowerOfBasicElement, WidthOfBasicElement, y, 0.0);
                            }
 
                yr = Math.Abs(yg - zg);
                if (yr > NormC)
                    NormC = yr;
                s = s + yr * yr;
                if (Math.Abs(yg) > Math.Abs(zg))
                    yd = Math.Abs(yg);
                else
                    yd = Math.Abs(zg);
                if (yd > ymas)
                    ymas = yd;
                y = y + h;
            }      

            ymax = ymas + 0.1 * ymas;
            ymin = -ymax;
            zmax = ymax;
            zmin = ymin;

            y = Rangemin;
            for (k = 0; k < ng; k++)
            {
                if (KeyOfJob == 0)
                {
                    xg = y;
                    yg = f(y);
                    zg = Summa(y);
                }
                else
                    if (KeyOfJob == 1)
                    {
                        xg = y;
                        yg = f2(y, y);
                        zg = Summa2(y, y);
                    }
                    else
                        if (KeyOfJob == 2)
                        {
                            xg = y;
                            yg = f2(y, y);
                            if (Method == 1)
                                zg = SamL(y, y);
                            else
                                zg = SamGau(y, y);
                        }
                        else
                        {
                            xg = y ;
                            zg = BasicElement(PowerOfBasicElement, WidthOfBasicElement, y, 0.0);
                            yg = BasicElement(PowerOfBasicElement, WidthOfBasicElement, y, 0.0);
                        }

                xp[k] = (int)(1024 / (b1 - a1) * (xg - a1));
                yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg - ymin));
                zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));

                y = y + h;
            }

            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());
        }
    }
}
