﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline2
{
    class IntegralEquation : BasicFunctionClass
    {
        public const int ng = 1024;    

		public const int nf = 250;             //Параметры для интегральных уравнений
        public const int ny = 25;	
        public const int nx = 25;               
		public int Key123 = 1;          //Коллокаций,слабое решение,МНК.
        //public int KeyP123 = 1;       //Способы проектирования правой части уравнения на пространство решений.

        //public int KeyOfJob = 0;          //0-Проектирование отключено, 1-проектирование включено, 2-регуляризация по Тихонову,

       public double AlfaCoPr0 = 0.000000000;
        //public double AlfaCoPr1 = 0.000000000;
        //public double AlfaMNK0 = 0.00000000000;//0.0000000000001;
        //public double AlfaMNK1 = 0.00000000000;//0.0000000000001;
        public double AlfaANT = 0.000000001;

        static public double ymas = 0.0;
        
        public int setkaIU =1;
        public int methodSLAY = 3;//1-Gauss,2-Decomp-Solve, 3-Mfss-Mlss;

       // public double[] aa = new double[N*(N+1)/2];

        public double [] b = new double [N];
        public double [] x = new double [N];
        public double[] c = new double[N];

        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];

        public double [] alf = new double [N];
        public double [] bet = new double [N];
        public double [] gam = new double [N];
        public double [] bs = new double [N];
        public double [] cs = new double [N];
        public double [] ds = new double [N];
        public double [] bb = new double [N];
        public double[] m = new double[N];

        static public int numberGr = 1024;
        public int NumberGr
        {
            get { return numberGr; }
            set { numberGr = value; }
        }

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }

        public double Xi(int i)
        {
            double ret = 0.0;
	        switch (setkaIU)
	        {
	            case 1: ret = a1+i*h;
                    break;
                case 2: ret = Math.Cos((2.0 * i + 1.0) * _Pi / (2.0 * n));
                    break;
                default: ret = 0.0; MessageBox.Show("sorry 1, bad setka");
                    break;
            }
            return ret;
        }

// Точное решение уравнения 
        public double re(double x)
        {	
	        double a2,b2,u,v;
	        switch (primer)
	        {
                case 1: return step(2, Math.Cos(_Pi / 2.0 * x));
                case 2: return step(2, Math.Sin(_Pi / 2.0 * x));
                case 3: return (Math.Abs(x) < 0.75) ? (1.0 - Math.Abs(x / 0.75)) : 0.0;
	            case 4: 
                    {
                        a2 = x - 0.5; 
                        b2 = x + 0.5; 
                        u = 1.0 / (1.0 + 100.0 * a2 * a2);
                        v = 1.0 /(1.0 + 100.0 * b2 * b2);
                        return u + v;
                    };
	            case 5:
                    if (Math.Abs(x) < 0.85)
                    {
                        a2 = Math.Sin(_Pi * x / 0.85);
                        b2 = Math.Cos(6.5 * _Pi * x / 0.85); 
                            u = step(2, 1.0 - step(2, x / 0.85)) + 0.5 * step(4, a2) * b2; 
                    }
		            else 
                        u = 0.0;
		        return u;
	            case 6:
                    if (Math.Abs(x) < 0.85)
                    {
                        a2 = Math.Cos(_Pi * x / 1.7);
                        b2 = Math.Cos(4.5 * _Pi * x / 0.85); 
                        u = 0.5 * (step(2, 1.0 - step(2, x / 0.85)) + a2 * a2 * b2); 
                    }
		            else 
                        u = 0.0;
		        return u;
	            case 7: return 1.0-x;
                case 8: return J0(_Pi * Math.Sqrt(1.0000000001 - x * x));
                case 9: return 1.0 / (1.0 + 25.0 * x * x); 
	            case 10: return 1.0;
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0; 
	        }
        }
// Ядро уравнения 
        public double K(double x,double y)
        {
	        switch (primer)
	        {
                case 1: return step(4, Math.Cos(_Pi / 2.0 * (x - y)));
                case 2: return step(4, Math.Cos(_Pi / 2.0 * (x - y)));
                case 3: return Math.Sqrt(25.0 / _Pi) * Math.Exp(-25.0 * (x - y) * (x - y));
                case 4: return Math.Sqrt(25.0 / _Pi) * Math.Exp(-25.0 * (x - y) * (x - y));
                case 5: return Math.Sqrt(60.0 / _Pi) * Math.Exp(-60.0 * (x - y) * (x - y) / (1.0 + x * x));
                case 6: return Math.Sqrt(60.0 / _Pi) * Math.Exp(-60.0 * (x - y) * (x - y) / (1.0 + x * x));
	            case 7: return 1.0/(1.0+100.0*(x-y)*(x-y));
                case 8: return Math.Cos(_Pi * _Pi * x * y);
                case 9: return Math.Cos(_Pi * _Pi * x * y); 
                case 10: return Math.Cos((x - y));
                default:
                    MessageBox.Show("sorry, method");
                    return 0.0; 
	        }
        }

// Сопряженное ядро уравнения 
        public double KS(double y, double x)
        {
            double u = x; double v = y;
            return K(v, u);           
        }

// Вычисление правой части уравнения численным методом Симпсона, если это необходимо 
	    public double Calculatedf(double x)
        {
	        int i,n1; double y,s1,s2,h1;

	        n1 = 25;
            h1 = (b1-a1) / (2.0 * n1);
            s2 = 0.0;
            s1 = K(x, b1 - h1) * re(b1 - h1); 
            y = a1;
	        for (i=1;i<n1;i++)
		    {
		        y = y + h1;
                s1 = s1 + K(x, y) * re(y);
		        y = y + h1;
                s2 = s2 + K(x, y) * re(y);
		    };
            return (K(x, a1) * re(a1) + K(x, b1) * re(b1) + 4.0 * s1 + 2.0 * s2) * h1 / 3.0;
        }

// Определение правой части уравнения 
        public double f(double x)
        {	
	        switch (primer)
	        {
	        case 1: return
        0.5 * step(2, Math.Cos(_Pi / 2.0 * x)) + 0.125;
	        case 2: return
        0.5 * step(2, Math.Sin(_Pi / 2.0 * x)) + 0.125;
            case 3: return Calculatedf(x);
            case 4: return Calculatedf(x);
            case 5: return Calculatedf(x);
            case 6: return Calculatedf(x);
            case 7: return Calculatedf(x);
            case 8: return 2.0 * Math.Sin(_Pi * Math.Sqrt(1.0 + _Pi * _Pi * x * x)) / (_Pi * Math.Sqrt(1.0 + _Pi * _Pi * x * x));
            case 9: return Calculatedf(x);
            case 10: return 2.0 * Math.Cos(x) * Math.Sin(1.0);
            default:
                MessageBox.Show("sorry, primer");
                return 0.0; 
	        }
        }
         
        public double Fisy(double y,int i)
	    {
	        return KS(y,Xi(i));
	    }

        public double Fisx(int j, double x)
        {
            return KS(Xi(j), x);
        }
        //public double Fix(double x,int j)
        //{
        //    return K(x,Xi(j));
        //}
        
        public double KFisx(double x,int i)
        {
            int k;
            double s, d, yc, yl, yr, fc, fl, fr, hy;
            hy = (b1 - a1) / (double)ny;
            d = Math.Sqrt(3.0 / 5.0); s = 0.0;
            for (k = 0; k < ny; k++)
            {
                yc = a1 + k * hy + hy / 2.0; yl = yc - d * hy / 2.0; yr = yc + d * hy / 2.0;
                fc = Fisy(yc, i) * K(x,yc); fl = Fisy(yl, i) * K(x,yl); fr = Fisy(yr, i) * K(x,yr);
                s = s + 5.0 * fl + 8.0 * fc + 5.0 * fr;
            };
            return s * hy / 18.0;
        }

//Матричные элементы для проектирования
        public double FisxKFisx(int j, int i)
        {
            int k; double s, d, xc, xl, xr, fc, fl, fr, hx;
            hx = (b1 - a1) / (double)nf;
            d = Math.Sqrt(3.0 / 5.0); s = 0.0;

            for (k = 0; k < nf; k++)
            {
                xc = a1 + k * hx + hx / 2.0; xl = xc - d * hx / 2.0; xr = xc + d * hx / 2.0;
                fc = Fisx(j,xc) * KFisx(xc, i); fl = Fisx(j, xl) * KFisx(xl, i); 
                fr = Fisx(j,xr) * KFisx(xr, i);
                s = s + 5.0 * fl + 8.0 * fc + 5.0 * fr;
            };
            return s * hx / 18.0;
        }

        //public double FixKFisx(int j, int i)
        //{
        //    int k; double s, d, xc, xl, xr, fc, fl, fr, hx;
        //    hx = (b1 - a1) / (double)nx;
        //    d = Math.Sqrt(3.0 / 5.0); s = 0.0;

        //    for (k = 0; k < nx; k++)
        //    {
        //        xc = a1 + k * hx + hx / 2.0; xl = xc - d * hx / 2.0; xr = xc + d * hx / 2.0;
        //        fc = Fix(xc,j) * KFisx(xc, i); fl = Fix(xl,j) * KFisx(xl, i);
        //        fr = Fix(xr,j) * KFisx(xr, i);
        //        s = s + 5.0 * fl + 8.0 * fc + 5.0 * fr;
        //    };
        //    return s * hx / 18.0;
        //}

//Элементы вектора для проектирования
        public double Fisxf(int j)
        {
            int k; double s, d, xc, xl, xr, fc, fl, fr, hx;
            hx = (b1 - a1) / (double)nf;
            d = Math.Sqrt(3.0 / 5.0); s = 0.0;
            for (k = 0; k < nf; k++)
            {
                xc = a1 + k * hx + hx / 2.0; xl = xc - d * hx / 2.0; xr = xc + d * hx / 2.0;
                fc = Fisx(j,xc) * f(xc); fl = Fisx(j,xl) * f(xl); fr = Fisx(j,xr) * f(xr);
                s = s + 5.0 * fl + 8.0 * fc + 5.0 * fr;
            };
            return s * hx / 18.0;
        }
        //public double Fixf(int j)
        //{
        //    int k; double s, d, xc, xl, xr, fc, fl, fr, hx;
        //    hx = (b1 - a1) / (double)nx;
        //    d = Math.Sqrt(3.0 / 5.0); s = 0.0;
        //    for (k = 0; k < nx; k++)
        //    {
        //        xc = a1 + k * hx + hx / 2.0; xl = xc - d * hx / 2.0; xr = xc + d * hx / 2.0;
        //        fc = Fix(xc,j) * f(xc); fl = Fix(xl,j) * f(xl); fr = Fix(xr,j) * f(xr);
        //        s = s + 5.0 * fl + 8.0 * fc + 5.0 * fr;
        //    };
        //    return s * hx / 18.0;
        //}
//Матричные элементы для МНК
        public double KFisxKFisx(int j, int i) 
        {
            int k; double s, xc, fc;
            double hf = (b1 - a1) / (double)nf;
            s = 0.0;
            for (k = 0; k < nf; k++)
            {
                xc = a1 + k * hf + hf / 2.0;
                fc = KFisx(xc, j) * KFisx(xc, i);
                s = s + fc;
            };
            return s * hf;
        }
//Элементы вектора для МНК
        public double KFisxf(int j)
        {
            int k; double s, xc, fc;
            double hf = (b1 - a1) / (double)nf;
            s = 0.0;
            for (k = 0; k < nf; k++)
            {
                xc = a1 + k * hf + hf / 2.0;
                fc = KFisx(xc, j) * f(xc);
                s = s + fc;
            };
            return s * hf;
        }

        //public double ff(double x, double[] c)
        //{
        //    int i;
        //    double s = 0.0;
        //    for (i = 0; i < n; i++)
        //        s = s + KFiy(x, i) * c[i];
        //    return s;
        //}

        //public double Fixff(int j, double[] c)
        //{
        //    int k;
        //    double s, d, xc, xl, xr, fc, fl, fr, hx;
        //    hx = (b1 - a1) / (double)nx;
        //    d = Math.Sqrt(3.0 / 5.0); 
        //    s = 0.0;
        //    for (k = 0; k < nx; k++)
        //    {
        //        xc = a1 + k * hx + hx / 2.0; xl = xc - d * hx / 2.0; xr = xc + d * hx / 2.0;
        //        fc = Fix(xc, j) * ff(xc, c); fl = Fix(xl, j) * ff(xl, c); fr = Fix(xr, j) * ff(xr, c);
        //        s = s + 5.0 * fl + 8.0 * fc + 5.0 * fr;
        //    };
        //    return s * hx / 18.0;
        //}

        //public double KFiyff(int j, double[] c)
        //{
        //    int k; double s, xc, fc;
        //    double hf = (b1 - a1) / (double)nf; 
        //    s = 0.0;
        //    for (k = 0; k < nf; k++)
        //    {
        //        xc = a1 + k * hf + hf / 2.0;
        //        fc = KFiy(xc, j) * ff(xc, c);
        //        s = s + fc;
        //    };
        //    return s * hf;
        //}

//Матрица-вектор для интерполяции, проектирования и МНК 
//без предварительного проектирования   
        public void MatrixVectf(double[,] a, double[] b, int Key123)
        {
            int i, j; double d; 
            double z = 0.0;
            double AlfaMNK = 0.00000000000001;
            double AlfaPr = 0.00000000000001;
            double AlfaColl = 0.00000001;
            d = AlfaCoPr0;
            bool log;
            if (Key123 == 3){ 
                log = (AlfaMNK > AlfaCoPr0) && ((primer == 3)||
                            (primer == 5) || (primer == 6) || (primer == 8));
                        d = (log) ? AlfaMNK : AlfaCoPr0;
                        if ((primer == 4) && (n > 27)) d = (0.000000000001 > AlfaCoPr0) ? 0.0000000000001 : AlfaCoPr0;
                        if ((primer == 7) && (n > 31)) d = (0.0000000001 > AlfaCoPr0) ? 0.0000000001 : AlfaCoPr0;
                        if (primer == 9) d = (0.0000000000001 > AlfaCoPr0) ? 0.0000000000001 : AlfaCoPr0;
                        } 
                          else
                            if (Key123 == 2)
                            {
                                log = (AlfaPr > AlfaCoPr0) && ((primer == 3) || (primer == 4) ||
                                            (primer == 6) || (primer == 8));
                                d = (log) ? AlfaPr : AlfaCoPr0;
                                if (primer == 9) d = (0.000000001 > AlfaCoPr0) ? 0.000000001 : AlfaCoPr0;
                                if ((primer == 5) && (n > 27)) d = (0.0000000001 > AlfaCoPr0) ? 0.0000000001 : AlfaCoPr0;
                                if ((primer == 7) && (n > 31)) d = (0.000001 > AlfaCoPr0) ? 0.000001 : AlfaCoPr0;
                            }
                            else
                                    if (Key123 == 1)
                                    {
                                        log = (AlfaCoPr0 < AlfaColl) && ((primer == 3) || (primer == 4) ||
                                                    (primer == 6) || (primer == 8));
                                        d = (log) ? AlfaColl : AlfaCoPr0;
                                        if (primer == 9) d = (0.000000001 > AlfaCoPr0) ? 0.000000001 : AlfaCoPr0;
                                        if ((primer == 5) && (n > 27)) d = (0.000001 > AlfaCoPr0) ? 0.000001 : AlfaCoPr0;
                                        if ((primer == 7) && (n > 31)) d = (0.001 > AlfaCoPr0) ? 0.001 : AlfaCoPr0;

                                    }
            for (j = 0; j < n; j++)
            {
                for (i = 0; i < n; i++)
		        {
                    switch (Key123)
	                {
                        case 1:
                            z = KFisx(Xi(j),i); //Интерполяция
                            break;
                        case 2:
                            z = FisxKFisx(j, i);//Проектирование
                            break;
                        //case 3:
                        //    z = FixKFisx(j, i);//Проектирование
                        //    break;
                        case 3:
                            z = KFisxKFisx(j, i);//МНК
                            break; 
                        default:
                            MessageBox.Show("sorry1, MatrixVectf");
                            break;
	                }
	                a[j,i] = z;
	                if (i == j) a[j,i]+=d;
	            }
            }

            //if (Key123 == 3)
            //{
            //    k = 0;
            //    for (j = 0; j < n; j++)
            //        for (i = 0; i <= j; i++)
            //        {
            //            k = k + 1;
            //            aa[k - 1] = a[i, j];
            //        }
            //}

            for (j=0; j < n; j++)
	        {
                switch (Key123)
		        {
                    case 1:
                        z = f(Xi(j));//Интерполяция
                        break;
                    case 2:
                        z = Fisxf(j);//Проектирование
                        break;
                    //case 3:
                    //    z = Fixf(j);//Проектирование
                    //    break;
                    case 3:
                        z = KFisxf(j); //МНК
                        break;
                    default:
                        MessageBox.Show("sorry2, MatrixVectf");
                        break;
                }
	            b[j]=z;
            }

            MessageBox.Show("MatrixVectf n = " + n.ToString());
            return;
        }

        //public void MatrixVectff(double[,] a, double[] b, double[] aa, int Key123)
        //{
        //    int i, j, k; double d;  double z = 0.0; 
        //    d = (Key123 == 3) ? AlfaMNK1 : AlfaCoPr1;
        //    if (primer == 8) d = (d > 0) ? d : Alfa8;
        //    if (primer == 9) d = (d > 0) ? d : Alfa9;

        //    for (j = 0; j < n; j++)
        //    {
        //        for (i = 0; i < n; i++)
        //        {
        //            switch (Key123)
        //            {
        //                case 1: z = KFiy(Xi(j),i); //Интерполяция, базис KFiY(x)
        //                    break;
        //                //case 2: z = FixKFiy(j,i);//Проектирование на R(K), базис KFiY(x)
        //                //    break;
        //                //case 3: z = KFiyKFiy(j,i);//МНК, базис KFiY(x)
        //                //    break;
        //                default:
        //                    MessageBox.Show("sorry1, MatrixVectff");
        //                    break;
        //            }
        //            a[j,i] = z;
        //            if (i == j)
                    
        //                a[j, i] += d;
                    
        //         }
        //    }
        //    if (Key123 == 3)
        //    {
        //        k = 0;
        //        for (j = 0; j < n; j++)
        //            for (i = 0; i <= j; i++)
        //            {
        //                k = k + 1;
        //                aa[k - 1] = a[i, j];
        //            }
        //    }
        //    for (j = 0; j < n; j++)
        //        c[j] = b[j];
        //    for (j = 0; j < n; j++)
        //    {
        //        switch (Key123)
        //        {
        //            case 1: z = ff(Xi(j), c);
        //                break;
        //            //case 2: z = Fixff(j, c);
        //            //    break;
        //            //case 3: z = KFiyff(j, c); 
        //            //    break;
        //            default:
        //                MessageBox.Show("sorry2, MatrixVectff");
        //                break;
        //        }
        //        b[j]=z;
        //    }
        //    MessageBox.Show("MatrixVectff n = " + n.ToString());
        //    return;
        //}

        public double Summa(double y)
        {
            int i; double s,z;
            s = 0.0;
            for (i = 0; i < n; i++)
            {
                z = Fisy(y,i) * b[i]; 
                s = s + z;
            }
            return s;
        }

        public double KANT(double a,double b)
        {
            int k;
            double s, xc, fc, hx;
            hx = (b1 - a1) / (double)n;
            s = 0.0;
            for (k = 0; k < n; k++)
            {
                xc = a1 + k * hx + hx / 2.0;
                fc = K(xc, a) * K(xc, b);
                s = s + fc;
            };
            return s * hx;
        }

        public double Kf(double a)
        {
            int k;
            double s, xc, fc, hx;
            hx = (b1 - a1) / (double)n;
            s = 0.0;
            for (k = 0; k < n; k++)
            {
                xc = a1 + k * hx + hx / 2.0;
                fc = K(xc, a) * f(xc);
                s = s + fc;
            };
            return s;
        }

        public void MatrixVectT(double[,] a, double[] b, int Key123)
        {
            int i, j;
            double hy, yi, yj;
            hy = (b1 - a1) / (double)n;
            for (j = 0; j < n; j++)
            {
                yj = a1 + j * hy + hy / 2.0;
                for (i = 0; i < n; i++)
                {
                    yi = a1 + i * hy + hy / 2.0;
                    a[j, i] = KANT(yj, yi);
                    if (i == j) a[j, i] += AlfaANT;
                }
            }
            //if (methodSLAY == 3)
            //{
            //    k = 0;
            //    for (j = 0; j < n; j++)
            //        for (i = 0; i <= j; i++)
            //        {
            //            k = k + 1;
            //            aa[k - 1] = a[i, j];
            //        }
            //}
            for (j = 0; j < n; j++)
                {
                    b[j] = Kf(a1 + j * hy + hy / 2.0);
                }
            MessageBox.Show("MatrixVectT n = " + n.ToString());
            return;
        }

        public void MatrixVectS(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            { alf[i - 1] = 2.0 / 3.0; b[i - 1] = (x[i - 1] - 2.0 * x[i] + x[i + 1]) / h / h; };
            for (i = 1; i <= (n - 3); i++)
            { bet[i - 1] = 1.0 / 6.0; gam[i - 1] = 1.0 / 6.0; };
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            //MessageBox.Show("MatrixVectS n = " + n.ToString());
            return;
        }

        public double SummaS3(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) { bs[0] = (x[1] - x[0]) / h - h / 6.0 * m[0]; cs[0] = 0.0; ds[0] = m[0] / 6.0 / h; }
                else
                { bs[i] = (x[i + 1] - x[i]) / h - h / 6.0 * (m[i] + 2.0 * m[i - 1]); cs[i] = m[i - 1] / 2.0; 
                    ds[i] = (m[i] - m[i - 1]) / 6.0 / h; };
            };
            i = (int)((y - a1) / h);
            if (i == (n - 1)) return x[n - 1];
            else
            {
                r = y - (a1 + i * h);
                s = x[i] + bs[i] * r + cs[i] * r * r + ds[i] * r * r * r;
                return s;
            }
        }

 
        public void Tabulation(int [] xp, int [] yp, int [] zp)//стр.137
        {
	        int k;  
            //double y, NormC, NormL2, s, h, yd, yr, zs, ymas, zmax, ymax, zmin, ymin, xg, yg, zg;
            double y, NormC, NormL2, s, h, yd, yr, zs, zmax, ymax, zmin, ymin, xg, yg, zg;
            y = a1; NormC = -1.0; s = 0; zs = 0.0;
            ymas=-1.0; 
            double z = (double)(ng-1); 
            h=(b1 - a1 ) /z;
            if (KeyOfJob == 2)
            {
                MatrixVectS(alf, bet, gam, bb);
                GaussS3(alf, bet, gam, bb, m);
            }
            for (k = 0; k < ng; k++)
            {
                yg = re(y);
                if (KeyOfJob == 2)
                zs = SummaS3(y, b, bs, cs, ds);
                zg = (KeyOfJob == 2)? zs: Summa(y);
                if (Math.Abs(yg) > Math.Abs(zg)) 
                    yd = Math.Abs(yg);
                else 
                    yd = Math.Abs(zg);
                if (yd > ymas)
                    ymas = yd;
                yr = Math.Abs(yg - zg);
                if (yr > NormC)
                    NormC = yr;
                s = s + yr * yr;
                y = y + h;
            }

            ymax = ymas + 0.1 * ymas; 
            ymin = -ymax;
            zmax = ymax; 
            zmin = ymin;

            y = a1;
            ymas = -1.0;
            for (k = 0; k < ng; k++)
	        {
		        xg=y;
                yg = re(y);
                if (KeyOfJob == 2)
                zs = SummaS3(y, b, bs, cs, ds);
                zg = (KeyOfJob == 2) ? zs : Summa(y);
                xp[k] = (int)(1024 / (b1 - a1) * (xg - a1));
		        yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg -ymin));
		        zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));
		        y = y + h;
	        }

            Number = n;
            Rangemin = a1;
            Rangemax = b1;
            NumberGr = ng;
            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());
           
            //		        cout <<"NormC="<<NormC<<"   "<<"NormL2="<<NormL2<<"   "<<"a1="<<a1<<"   "<<"ymin="<<ymin<<"   ";
//		        cout <<'\n';
        }
    }
}
