﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline3
{
    class BondaryEquation : BasicFunctionClass
    {

        public const int ng = 1024;              
        public const int stloc = 4;

        public int primer2 = 1; //1-20;
        static public int numberMethod2 = 1;//1,2,3,4,5,6,7,8,9

        static public int numberSlay = 1;// = methodSLAY;метод решения СЛАУ: 1-Gauss,2-Decomp-Solve
        
        public int primer4 = 1;//1-5;
        static public int numberMethod4 = 1;//1,2,3,4;

        static public double ymas = 0.0;
        

        public double[] b = new double[N];
        public double[] x = new double[N];
        public double[] c = new double[N];

        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];

        public double[] alf = new double[N];
        public double[] bet = new double[N];
        public double[] gam = new double[N];
        public double[] bs = new double[N];
        public double[] cs = new double[N];
        public double[] ds = new double[N];
        public double[] m = new double[N];

        static public int numberGr = 1024;
        public int NumberGr
        {
            get { return numberGr; }
            set { numberGr = value; }
        }

        public int NumberMethod2
        {
            get { return numberMethod2; }
            set { numberMethod2 = value; }
        }

        public int NumberMethod4
        {
            get { return numberMethod4; }
            set { numberMethod4 = value; }
        }

        public int NumberSlay
        {
            get { return numberSlay; }
            set { numberSlay = value; }
        }

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }

//------------------------------------------------------------------------------------------------------
        public double p2(double x)
        {
            double a = 1.0;
            switch (primer2)
            {
                case 1: return 1.0;// задача 15)
                case 8: return 1.0;//задача 5),x>=0
                case 13: return (1.0 + x * x);//задача 18)
                case 16: return x * x;//задача 17)
                case 20: return 1.0;//задача 16)
                case 6: return x;//задача 19),x>0.0
                case 7: return x;//задача 14),x>0.0
                case 2: return (1.0 + x * x);//задача 11)
                case 9: return 1.0;//задача 13)
                case 10: return 1.0;//задача 8)
                case 11: return 1.0;//задача 20)
                case 12: return 1.0;//задача 6),x>=0
                case 3: return 0.02 * step(3, 1.0 + 25.0 * x * x);
                case 14: return x * x;     //Функция Бесселя
                case 15: return step(2, a * a + x * x); //задача 7)
                case 4: return (1.0 + x * x);
                case 17: return x * Math.Cos(x) - Math.Sin(x);//задача 10),x>0,x<=pi Обл.опр. существенна
                case 18: return x;//задача 9),x>0 Обл.опр. существенна
                case 19: return (1.0 - x * x) * x; //Полный эллиптический интеграл Обл.опр. существенна
                case 5: return (x * x - 0.25) * x * x; //Любопытный

                case 21: return (x * x - 1.0);
                case 22: return (x * x - 1.0);
                case 23: return (x * x - 1.0);
                case 24: return Math.Sin(x);
                case 25: return 1.0;//задача 12)


                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public double q2(double x)
        {
            double ad = 1.0; int bi = 0;//параметры для задачи 12
            double a6 = -1.0;//параметры для задачи 14
            switch (primer2)
            {
                case 1: return 4.0 * x;
                case 8: return x;
                case 13: return 2.0 * x;
                case 16: return -2.0 * x;
                case 29: return x;
                case 6: return -(x + 1.0);
                case 7: return -(x + 1.0);
                case 2: return 4.0 * x;
                case 9: return Math.Sin(x) / Math.Cos(x);
                case 10: return Math.Sin(x) / Math.Cos(x);
                case 11: return -4.0 * x;
                case 12: return 2.0 * a6 * x;
                case 3: return 0.02 * step(2, 1.0 + 25.0 * x * x);
                case 14: return x;     //Функция Бесселя
                case 15: return 0.0;
                case 4: return x;
                case 17: return x * Math.Sin(x);
                case 18: return -2.0 * (ad * x + bi);
                case 19: return (1.0 - x * x);
                case 5: return 0.0;

                case 21: return -x;
                case 22: return 1.0;
                case 23: return x;
                case 24: return (Math.Sin(x) * Math.Sin(x) - Math.Cos(x));
                case 25: return -4.0 * x;

                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }

        }

        public double r2(double x)
        {
            double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25; //параметр для задачи 4)
            double b = 1.0; //параметры для задачи 16
            switch (primer2)
            {
                case 1: return (2.0 + x * x * 4.0);
                case 8: return (0.5 + x * x / 4.0);
                case 13: return 1.0 / (1.0 + x * x);
                case 16: return (2.0 + k4 * k4 * x * x);
                case 20: return 0.25 * x * x - 1.0;
                case 6: return -2.0 * (x - 1.0);
                case 7: return 1.0;
                case 2: return 2.0;
                case 9: return -Math.Cos(x) * Math.Cos(x);
                case 10: return Math.Cos(x) * Math.Cos(x);
                case 11: return (4.0 * x * x - 2.0);
                case 12: return step(2, a6 * x);
                case 3: return 1.0 + 25.0 * x * x;
                case 14: return x * x - pr * pr;     //Функция Бесселя
                case 15: return b * b;
                case 4: return 2.0;
                case 17: return -Math.Sin(x);
                case 18: return ad * ad * x + 2.0 * ad * bi;
                case 19: return x;
                case 5: return 1.0 / 16.0;

                case 21: return -3.0;
                case 22: return -6.0;
                case 23: return -0.25;
                case 24: return Math.Sin(x) * Math.Sin(x) * Math.Sin(x);
                case 25: return (1.0 + 4.0 * x * x);

                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }

        }

        public double f2(double x)
        {
            switch (primer2)
            {
                case 1: return 0.0;
                case 8: return 0.0;
                case 13: return 0.0;
                case 16: return 0.0;
                case 20: return 0.0;
                case 6: return 0.0;
                case 7: return 0.0;
                case 2: return 2.0 * (Math.Cos(x) - x);
                case 9: return 0.0;
                case 10: return 0.0;
                case 11: return 0.0;
                case 12: return 0.0;
                case 3: return 75.0 * x * x - x;
                case 14: return 0.0;     //Функция Бесселя
                case 15: return 0.0;
                case 4: return 0.0;
                case 17: return 0.0;
                case 18: return 0.0;
                case 19: return 0.0;     //задача 18)
                case 5: return 0.0;

                case 21: return 0.0;
                case 22: return 0.0;
                case 23: return 0.0;
                case 24: return 0.0;
                case 25: return Math.Exp(x * x);

                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }

        }

        public double re2(double x)
        {
            double c1 = 1.0; double c2 = 1.0;
            double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25;
            double a = 1.0; double b = 1.0;
            double u;
            switch (primer2)
            {
                case 1: return Math.Exp(-x * x) * (c1 + c2 * x);
                case 8: return Math.Exp(-x * x / 4) * (c1 + c2 * x);
                case 13: return 1.0 / Math.Sqrt(1.0 + x * x) * (c1 + c2 * x);
                case 16: return x * (c1 * Math.Cos(k4 * x) + c2 * Math.Sin(k4 * x));
                case 20: return Math.Exp(-x * x / 4.0) * (c1 * Math.Exp(x * Math.Sqrt(1.5)) +
                    c2 * Math.Exp(-x * Math.Sqrt(1.5)));
                case 6: return c1 * (3.0 * x + 1.0) * Math.Exp(-x) + c2 * Math.Exp(2.0 * x);
                case 7: return c1 * (x + 1) + c2 * Math.Exp(x);
                case 2: return 1.0 / (1.0 + x * x) * (c1 + c2 * x - x * x * x / 3.0 - 2.0 * Math.Cos(x));
                case 9: return c1 * Math.Exp(Math.Sin(x)) + c2 * Math.Exp(-Math.Sin(x));
                case 10: return c1 * Math.Cos(Math.Sin(x)) + c2 * Math.Sin(Math.Sin(x));
                case 11: return Math.Exp(x * x) * (c1 + c2 * x);
                case 12: return (a6 > 0.0) ? Math.Exp(-a6 * x * x / 2.0) * (c1 * Math.Cosh(x * Math.Sqrt(a6)) +
                    c2 * Math.Sinh(x * Math.Sqrt(a6))) :
                             Math.Exp(-a6 * x * x / 2.0) * (c1 * Math.Cos(x * Math.Sqrt(-a6)) +
                             c2 * Math.Sin(x * Math.Sqrt(-a6)));
                case 3: return 1.0 / (1.0 + 25.0 * x * x);
                case 14: return Bessel(pr, x);     //Функция Бесселя
                case 15: u = Math.Sqrt(a * a + b * b) / a * Math.Atan(x / a);
                    return Math.Sqrt(a * a + x * x) * (c1 * Math.Cos(u) + c2 * Math.Sin(u));
                case 4: u = Math.Sqrt(2.0) * Math.Log(x + Math.Sqrt(1.0 + x * x));
                    return c1 * Math.Cos(u) + c2 * Math.Sin(u);
                case 17: return c1 * x + c2 * Math.Sin(x);
                case 18: return Math.Exp(ad * x) * (c1 + c2 * step(2 * bi + 1, x));
                case 19: return E(x);
                case 5: return c1 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x - 0.5)) +
                    c2 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x + 0.5));

                case 21: return c2 * step(3, Math.Sqrt(Math.Abs(x * x - 1.0)));// +c1 * (2.0 * x * x * x - x);
                case 22: return step(3, Math.Sqrt(Math.Abs(x + 1.0))) * Math.Sqrt(Math.Abs(x - 1.0)) * (4.0 * x - 1.0);
                case 23: return c1 * Math.Sqrt(Math.Abs(x + 1.0)) + c2 * Math.Sqrt(Math.Abs(x - 1.0));
                case 24: return Math.Exp(Math.Cos(x) / 2.0) * (c1 * Math.Cos(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)) +
                        c2 * Math.Sin(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)));
                case 25: return Math.Exp(x * x) * (1.0 + c1 * Math.Cos(x) + c2 * Math.Sin(x));

                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public double re2p(double x)
        {
            double c1 = 1.0; double c2 = 1.0; double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25;
            double a = 1.0; 
            switch (primer2)
            {
                case 1: return Math.Exp(-x * x) * (-x * 2.0) * (1.0 + x) + Math.Exp(-x * x);
                case 8: return Math.Exp(-x * x / 4) * (-x / 2.0) * (1.0 + x) + Math.Exp(-x * x / 4.0);
                case 13: return (-x) * 1.0 / step(3, Math.Sqrt(1.0 + x * x)) * (1.0 + x) + 1.0 / Math.Sqrt(1.0 + x * x);
                case 16: return x * (-k4 * Math.Sin(k4 * x) + k4 * Math.Cos(k4 * x));
                case 20: return Math.Exp(-x * x / 4) * (-x / 2.0) * (Math.Exp(x * Math.Sqrt(1.5)) +
                    Math.Exp(-x * Math.Sqrt(1.5))) +
                            Math.Exp(-x * x / 4) * (Math.Sqrt(1.5) * Math.Exp(x * Math.Sqrt(1.5)) -
                            Math.Sqrt(1.5) * Math.Exp(-x * Math.Sqrt(1.5)));
                case 6: return c1 * (3.0 * Math.Exp(-x) - (3.0 * x + 1.0) * Math.Exp(-x)) + c2 * 2.0 * Math.Exp(2.0 * x);
                case 7: return c1 + c2 * Math.Exp(x);
                case 2: return -(2.0 * x) / step(2, Math.Sqrt(1.0 + x * x)) * (c1 + c2 * x - x * x * x / 3.0 - 
                    2.0 * Math.Cos(x)) + 1.0 / (1.0 + x * x) * (c2 - x * x + 2.0 * Math.Sin(x));
                case 9: return c1 * Math.Exp(Math.Sin(x)) * Math.Cos(x) - c2 * Math.Exp(-Math.Sin(x)) * Math.Cos(x);
                case 10: return -c1 * Math.Sin(Math.Sin(x)) * Math.Cos(x) + c2 * Math.Cos(Math.Sin(x)) * Math.Cos(x);
                case 11: return Math.Exp(x * x) * (2.0 * x) * (c1 + c2 * x) + Math.Exp(x * x) * c2;
                case 12: return (a6 > 0.0) ? Math.Exp(-a6 * x * x / 2.0) * (-a6 * x) * (c1 * Math.Cosh(x * Math.Sqrt(a6)) +
                    c2 * Math.Sinh(x * Math.Sqrt(a6))) +
                             Math.Exp(-a6 * x * x / 2.0) * (c1 * Math.Sinh(x * Math.Sqrt(a6)) * Math.Sqrt(a6) +
                             c2 * Math.Cosh(x * Math.Sqrt(a6)) * Math.Sqrt(a6)) :
                             Math.Exp(-a6 * x * x / 2.0) * (-a6 * x) * (c1 * Math.Cos(x * Math.Sqrt(-a6)) +
                             c2 * Math.Sin(x * Math.Sqrt(-a6))) +
                             Math.Exp(-a6 * x * x / 2.0) * (-c1 * Math.Sin(x * Math.Sqrt(-a6)) * Math.Sqrt(-a6) +
                             c2 * Math.Cos(x * Math.Sqrt(-a6)) * Math.Sqrt(-a6));
                case 3: return -50.0 * x / step(2, 1.0 + 25.0 * x * x);
                case 14: return Bessel(pr, x);     //Функция Бесселя
                case 15: return Math.Sqrt(a * a + x * x) / a * Math.Atan(x / a);
                case 4: return Math.Sqrt(2.0) * Math.Log(x + Math.Sqrt(1.0 + x * x));
                case 17: return c1 + c2 * Math.Cos(x);
                case 18: return ad * Math.Exp(ad * x) * (c1 + c2 * step(2 * bi + 1, x)) +
                    Math.Exp(ad * x) * (2 * bi + 1) * c2 * step(2 * bi, x);
                case 19: return E(x);
                case 5: return c1 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x - 0.5)) +
                    c2 * Math.Sqrt(Math.Abs(x)) * Math.Sqrt(Math.Abs(x - 0.5));

                case 21: return c1 * (2.0 * x * x * x - x) + c2 * step(3, Math.Sqrt(Math.Abs(x * x - 1.0)));
                case 22: return step(3, Math.Sqrt(Math.Abs(x + 1.0))) * Math.Sqrt(Math.Abs(x - 1.0)) * (4.0 * x - 1.0);
                case 23: return c1 * Math.Sqrt(Math.Abs(x + 1.0)) + c2 * Math.Sqrt(Math.Abs(x - 1.0));
                case 24: return Math.Exp(Math.Cos(x) / 2.0) * (c1 * Math.Cos(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)) +
                        c2 * Math.Sin(Math.Cos(x) / 2.0 * Math.Sqrt(3.0)));
                case 25: return Math.Exp(x * x) * (2.0 * x) * (1.0 + c1 * Math.Cos(x) + c2 * Math.Sin(x)) +
                        Math.Exp(x * x) * (-c1 * Math.Sin(x) + c2 * Math.Cos(x));
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public double g2a(double y)
        {
            double ala = 1.0;
            double bea = 0.0;
            return ala * re2(y) + bea * re2p(y);
        }

        public double g2b(double y)
        {
            double alb = 1.0;
            double beb = 0.0;
            return alb * re2(y) + beb * re2p(y);
        }

        public double Y(double y)
        {
            double c, d;
            c = (re2(a1) * b1 - re2(b1) * a1) / (b1 - a1);
            d = (re2(b1) - re2(a1)) / (b1 - a1);
            return c + d * y;
        }

        public double GG2(double x, double y)
        {
            double h1, p, q, qf, r, rf;
            h1 = h * al;
            p = (x - y); q = (x - y) / h1; qf = Math.Abs(q); r = (x - y) / h; rf = Math.Abs(r);
            switch (NumberMethod2)
            {
                case 3: return sgn(p) * p * p * p;
                case 4: return sgn(p) * p * p * p * p * p;
                case 5: return sgn(p) * step(7, p);
                case 6: return sgn(p) * step(9, p);
                case 7: return sgn(p) * step(11, p);
                case 8: return (qf < 1.0) ? 0.5 * (-step(3, qf) / 3.0 + step(2, qf) + 1.0 / 3.0) : 0.5 * qf;
                default:
                    MessageBox.Show("sorry, NumberMethod");
                    return 0.0;
            }
        }

        public double GG2p(double x, double y)
        {
            double h1, p, q, qf, r, rf;
            h1 = h * al;
            p = (x - y); q = (x - y) / h1; qf = Math.Abs(q); r = (x - y) / h; rf = Math.Abs(r);
            switch (NumberMethod2)
            {
                case 3: return 3.0 * sgn(p) * p * p;
                case 4: return 5.0 * sgn(p) * p * p * p * p;
                case 5: return 7.0 * sgn(p) * step(6, p);
                case 6: return 9.0 * sgn(p) * step(8, p);
                case 7: return 11.0 * sgn(p) * step(10, p);
                case 8: return (qf < 1.0) ? 0.5 * (-sgn(q) * q * q + 2.0 * q) / h1 : 0.5 * sgn(q) / h1;
                default:
                    MessageBox.Show("sorry, NumberMethod");
                    return 0.0;
            }
        }

        public double GG2pp(double x, double y)
        {
            double h1, p, q, qf, r, rf;
            h1 = h * al;
            p = (x - y); q = (x - y) / h1; qf = Math.Abs(q); r = (x - y) / h; rf = Math.Abs(r);

            switch (NumberMethod2)
            {
                case 3: return 6.0 * sgn(p) * p;
                case 4: return 20.0 * sgn(p) * p * p * p;
                case 5: return 42.0 * sgn(p) * step(5, p);
                case 6: return 72.0 * sgn(p) * step(7, p);
                case 7: return 110.0 * sgn(p) * step(9, p);
                case 8: return (qf < 1.0) ? (-sgn(q) * q + 1.0) / h1 / h1 : 0.0;
                default:
                    MessageBox.Show("sorry, NumberMethod");
                    return 0.0;
            }
        }

        public double FiGG2(int i, double x)
        {
            return GG2(x, a1 + i * h);
        }

        public void MatrixVectGG2(double[,] a, double[] b)
        {
            double ala = 1.0; double bea = 0.0; double alb = 1.0; double beb = 0.0;
            int i, k;
            for (i = 0; i < n; i++)
                for (k = 1; k < (n - 1); k++)
                {
                    a[k, i] = p2(xi(k)) * GG2pp(xi(k), xi(i)) + q2(xi(k)) * GG2p(xi(k), xi(i)) +
                        r2(xi(k)) * GG2(xi(k), xi(i));
                };
            for (i = 0; i < n; i++)
            {
                a[0, i] = ala * GG2(a1, xi(i)) + bea * GG2p(a1, xi(i));
            };
            for (i = 0; i < n; i++)
            {
                a[n - 1, i] = alb * GG2(b1, xi(i)) + beb * GG2p(a1, xi(i));
            };
            for (k = 1; k < (n - 1); k++)
            {
                b[k] = f2(xi(k));
            };
            b[0] = g2a(a1); b[n - 1] = g2b(b1);
            MessageBox.Show("MatrixVectGG2 n = " + n.ToString());
            return;
        }

//Уравнение 4-го порядка
        public double p4(double x)
        {
            switch (primer4)
            {
                case 1: return 1.0;// задача 15)
                case 2: return 1.0;// задача 15)
                case 3: return 1.0;// задача 15)
                case 4: return 4.0;//задача 5),x>=0
                case 5: return 1.0;//задача 18)

                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }
        }

        public double q4(double x)
        {
            switch (primer4)
            {
                case 1: return 1.0;
                case 2: return 1.0;
                case 3: return 0.0;
                case 4: return -12.0;
                case 5: return 0.0;


                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }

        }

        public double r4(double x)
        {
            double ad = 1.0;
            switch (primer4)
            {
                case 1: return -1.0;
                case 2: return 6.0;
                case 3: return 2.0 * ad * ad;
                case 4: return 11.0;
                case 5: return -12.0;

                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }

        }

        public double s4(double x)
        {

            switch (primer4)
            {
                case 1: return _Pi * _Pi;
                case 2: return 3.0;
                case 3: return 0.0;
                case 4: return -3.0;
                case 5: return 0.0;

                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }

        }

        public double t4(double x)
        {
            double ad = 1.0;
            switch (primer4)
            {
                case 1: return -_Pi * _Pi * _Pi * _Pi;
                case 2: return 3.0;
                case 3: return ad * ad * ad * ad;
                case 4: return 0.0;
                case 5: return 12.0;

                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }

        }

        public double f4(double x)
        {
            double ad = 1.0;
            switch (primer4)
            {
                case 1: return _Pi * _Pi * Math.Sin(_Pi * x);
                case 2: return Math.Exp(-x * x / 2.0) * (x * x * x * x - x * x * x);
                case 3: return Math.Cosh(ad * x);
                case 4: return 4.0 * Math.Cos(x);
                case 5: return 16.0 * x * x * x * x * Math.Exp(x * x);

                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }

        }

        public double re4(double x)
        {
            double c1 = 1.0; double c2 = 1.0; double c3 = 1.0; double c4 = 1.0;
            double ad = 1.0; 
            double p = Math.Sqrt(6.0 + 2.0 * Math.Sqrt(6.0)); 
            double q = Math.Sqrt(6.0 - 2.0 * Math.Sqrt(6.0)); 
            switch (primer4)
            {
                case 1: return Math.Sin(_Pi * x);
                case 2: return Math.Exp(-x * x / 2.0);
                case 3: return Math.Sin(ad * x) * (c1 + c2 * x) + Math.Cos(ad * x) * (c3 + c4 * x)+
                    Math.Cosh(ad * x)/4.0/ad/ad;
                case 4: return c1 + c2*Math.Exp(x / 2)+c3*Math.Exp(x) + c4 * Math.Exp(3.0*x/2.0)+
                    (18.0*Math.Sin(x)-14.0* Math.Cos(x))/65.0;
                case 5: return Math.Exp(x * x) + c1 * Math.Exp(p * x) + c2 * Math.Exp(-p * x) +
                     c3 * Math.Exp(q * x) + c4 * Math.Exp(-q * x); 
 
                 default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }
        }

        public double repp4(double x)
        {

            double c1 = 1.0; double c2 = 1.0; double c3 = 1.0; double c4 = 1.0; 
            double ad = 1.0;
            double p = Math.Sqrt(6.0 + 2.0 * Math.Sqrt(6.0)); double p2 = 6.0 + 2.0 * Math.Sqrt(6.0);
            double q = Math.Sqrt(6.0 - 2.0 * Math.Sqrt(6.0)); double q2 = 6.0 - 2.0 * Math.Sqrt(6.0);
            switch (primer4)
            {
                case 1: return -_Pi * _Pi * Math.Sin(_Pi * x);
                case 2: return (x * x - 1.0) * Math.Exp(-x * x / 2.0);
                case 3: return 2.0 * ad * c2 * Math.Cos(ad * x) - 2.0 * ad * c4 * Math.Sin(ad * x)-
                    Math.Sin(ad * x) * (c1 + c2 * x) * ad * ad - Math.Cos(ad * x) * (c3 + c4 * x) * ad * ad +
                    Math.Cosh(ad * x) / 4.0;
                case 4: return c2/4 * Math.Exp(x / 2) + c3 * Math.Exp(x) + c4 * 3.0*3.0/2.0/2.0*Math.Exp(3.0 * x / 2.0) +
                    (-18.0 * Math.Sin(x) + 14.0 * Math.Cos(x)) / 65.0;
                case 5: return (2.0+4.0*x*x)*Math.Exp(x * x) + c1 * p2*Math.Exp(p * x) + c2 * p2*Math.Exp(-p * x) +
                 c3 * q2 * Math.Exp(q * x) + c4 * q2 * Math.Exp(-q * x); 
                default:
                    MessageBox.Show("sorry, primer4");
                    return 0.0;
            }
        }

        public double ga4(double y)
        {
            return re4(y);
        }
        public double gapp4(double y)
        {
            return repp4(y);
        }

        public double gb4(double y)
        {
            return re4(y);
        }
        public double gbpp4(double y)
        {
            return repp4(y);
        }

        public double GG4(double x, double y)
        {
            double p = (x - y); 
            switch (NumberMethod4)
            {
                case 1: return sgn(p) * step(5, p);
                case 2: return sgn(p) * step(7, p);
                case 3: return sgn(p) * step(9, p);
                case 4: return sgn(p) * step(11, p);
                default:
                    MessageBox.Show("sorry, methodGG4");
                    return 0.0;
            }
        }

        public double GG4p(double x, double y)
        {
            double p = (x - y); 
            switch (NumberMethod4)
            {
                case 1: return 5.0 * sgn(p) * step(4, p);
                case 2: return 7.0 * sgn(p) * step(6, p);
                case 3: return 9.0 * sgn(p) * step(8, p);
                case 4: return 11.0 * sgn(p) * step(10, p);
                default:
                    MessageBox.Show("sorry, methodGGp4");
                    return 0.0;
            }
        }

        public double GG4pp(double x, double y)
        {
            double p = (x - y); 
            switch (NumberMethod4)
            {
                case 1: return 20.0 * sgn(p) * step(3, p);
                case 2: return 42.0 * sgn(p) * step(5, p);
                case 3: return 72.0 * sgn(p) * step(7, p);
                case 4: return 110.0 * sgn(p) * step(9, p);
                default:
                    MessageBox.Show("sorry, methodGGpp4");
                    return 0.0;
            }
        }

        public double GG4ppp(double x, double y)
        {
            double p = (x - y); 
            switch (NumberMethod4)
            {
                case 1: return 60.0 * sgn(p) * step(2, p);
                case 2: return 210.0 * sgn(p) * step(4, p);
                case 3: return 504.0 * sgn(p) * step(6, p);
                case 4: return 990.0 * sgn(p) * step(8, p);

                default:
                    MessageBox.Show("sorry, methodGGppp4");
                    return 0.0;
            }
        }

        public double GG4pppp(double x, double y)
        {
            double p = (x - y); 
            switch (NumberMethod4)
            {
                case 1: return 120.0 * sgn(p) * step(1, p);
                case 2: return 840.0 * sgn(p) * step(3, p);
                case 3: return 3024.0 * sgn(p) * step(5, p);
                case 4: return 7920.0 * sgn(p) * step(7, p);
                default:
                    MessageBox.Show("sorry, methodGGpppp4");
                    return 0.0;
            }
        }
        public double FiGG4(int i, double x)
        {
            return GG4(x, xi(i));
        }


        public void MatrixVectGG4(double[,] a, double[] b)//стр.137
        {
            double u = 0.0; 
            int i, k; 
            for (i = 0; i < n; i++)
                for (k = 2; k < (n - 2); k++)
                {
                    u = a1 + k * h;
                    a[k, i] = p4(u) * GG4pppp(u, xi(i)) + q4(u) * GG4ppp(u, xi(i)) + 
                        r4(u) * GG4pp(u, xi(i)) + s4(u) * GG4p(u, xi(i)) + t4(u) * GG4(u, xi(i));
                };
            for (i = 0; i < n; i++)
            {
                a[0, i] = GG4(a1, xi(i));
                a[1, i] = GG4pp(a1, xi(i));
            };
            for (i = 0; i < n; i++)
            {
                a[n - 1, i] = GG4(b1, xi(i));
                a[n - 2, i] = GG4pp(b1, xi(i));

            };
            for (k = 2; k < (n - 2); k++)
            {
                u = a1 + k * h;
                b[k] = f4(u);
            };
            b[0] = ga4(a1);
            b[1] = gapp4(a1); 
            b[n - 1] = gb4(b1); 
            b[n - 2] = gbpp4(b1);
            MessageBox.Show("MatrixVectGG4 n = " + n.ToString());
            return;
        }

        //Многочленное приближение
        public void MatrixVectAG(double[,] a, double[] b)
        {
            int i, k; double u;
            double d = (re2(b1) - re2(a1)) / (b1 - a1);
            for (i = 0; i < n; i++)
                for (k = 0; k < n; k++)
                {
                    u = a1 + (b1 - a1) / (n + 1) * (k + 1);
                    a[k, i] = p2(u) *
                        (
                        (u - a1) * (u - b1) * i * (i - 1) * step(i - 2, u) +
                        2.0 * (2.0 * u - a1 - b1) * i * step(i - 1, u) + 2.0 * step(i, u)
                        )
                        +
                        q2(u) *
                        (
                        (2.0 * u - a1 - b1) * step(i, u) + (u - a1) * (u - b1) * i * step(i - 1, u)
                        )
                        +
                        r2(u) *
                        (
                        (u - a1) * (u - b1) * step(i, u)
                        );
                }

            for (k = 0; k < n; k++)
            {
                u = a1 + (b1 - a1) / (n + 1) * (k + 1);
                b[k] = f2(u) - (d * q2(u) + Y(u) * r2(u));
            }
            MessageBox.Show("MatrixVectAG n = " + n.ToString());
            return;
        }

        public double SummaAG(double[] x, double y)
        {
            int i; double s; double p;
            s = 0.0;
            for (i = 0; i < n; i++)
            {
                p = (numberSlay == 1) ? x[i] : b[i]; 
                s = s + (y - a1) * (y - b1) * step(i, y) * p;
            }
            return s;
        }

        //Сеточное приближение
        public void MatrixVectSet(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            double ala = 1.0; double bea = 0.0; double alb = 1.0; double beb = 0.0;

            alf[0] = ala * h - bea; gam[0] = bea; b[0] = h * g2a(a1);
            for (i = 1; i <= (n - 2); i++)
            {
                alf[i] = 2.0 * p2(xi(i)) - r2(xi(i)) * h * h; gam[i] =
                              -p2(xi(i)) - q2(xi(i)) * h / 2.0; b[i] = -h * h * f2(xi(i));
            }
            alf[n - 1] = alb * h + beb; gam[n - 1] = 0.0; b[n - 1] = h * g2b(b1);
            for (i = 1; i <= (n - 2); i++)
            {
                bet[i - 1] = -p2(xi(i)) + q2(xi(i)) * h / 2.0;
            }
            bet[n - 2] = -beb; bet[n - 1] = 0.0;
            MessageBox.Show("MatrixVectSet n = " + n.ToString());
            return;
        }

        public double SummaGG(double[] x, double y)
        {
            int i; double s; double z; double p;
            s = 0.0; 
            for (i = 0; i < n; i++)
            {
                z = (keyOfJob == 2) ? FiGG2(i, y) : FiGG4(i, y);
                p = (numberSlay == 1) ? x[i] : b[i]; 
                s = s + z * p;
            };
            return s;
        }

        public void MatrixVectS(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            { alf[i - 1] = 2.0 / 3.0; b[i - 1] = (x[i - 1] - 2.0 * x[i] + x[i + 1]) / h / h; };
            for (i = 1; i <= (n - 3); i++)
            { bet[i - 1] = 1.0 / 6.0; gam[i - 1] = 1.0 / 6.0; };
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            return;
        }

        public double SummaS3(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) { bs[0] = (x[1] - x[0]) / h - h / 6.0 * m[0]; 
                    cs[0] = 0.0; ds[0] = m[0] / 6.0 / h; }
                else
                { bs[i] = (x[i + 1] - x[i]) / h - h / 6.0 * (m[i] + 2.0 * m[i - 1]); 
                    cs[i] = m[i - 1] / 2.0; ds[i] = (m[i] - m[i - 1]) / 6.0 / h; };
            }
            i = (int)((y - a1) / h);
            if (i == (n - 1)) 
                return x[n - 1];
            else
            {
                r = y - (a1 + i * h);
                s = x[i] + bs[i] * r + cs[i] * r * r + ds[i] * r * r * r;
                return s;
            }
        }
         
        public void Tabulation(int[] xp, int[] yp, int[] zp)//стр.137
        {
            int k;
            double y, NormC, NormL2, s, h, yd, yr, zmax, ymax, zmin, ymin, yg, zg;
            NormC = -1.0; s = 0; zg = 0.0;
            ymas = -1.0;
            double z = (double)(ng - 1);
            h = (b1 - a1) / z;

            if (keyOfJob == 2) 
                if (NumberMethod2 == 1)
                {
                    MatrixVectS(alf, bet, gam, b);
                    GaussS3(alf, bet, gam, b, m);
                }

            y = a1;
            for (k = 0; k < ng; k++)
            {
                if (keyOfJob == 2)
                {
                    yg = re2(y);
                    if (NumberMethod2 == 1)
                        zg = SummaS3(y, x, bs, cs, ds);
                    if (NumberMethod2 == 2)
                        zg = SummaAG(x, y) + Y(y);
                    if (NumberMethod2 > 2)
                        zg = SummaGG(x, y);
                }
                else
                {
                    yg = re4(y);
                    zg = SummaGG(x, y);
                }
                if (Math.Abs(yg) > Math.Abs(zg))
                    yd = Math.Abs(yg);
                else
                    yd = Math.Abs(zg);
                if (yd > ymas)
                    ymas = yd;
                yr = Math.Abs(yg - zg);
                if (yr > NormC)
                    NormC = yr;
                s = s + yr * yr;
                y = y + h;
            }

            ymax = ymas + 0.1 * ymas;
            ymin = -ymax;
            zmax = ymax;
            zmin = ymin;

            y = a1;
            for (k = 0; k < ng; k++)
            {
                if (keyOfJob == 2)
                {
                    yg = re2(y);
                    if (NumberMethod2 == 1)
                        zg = SummaS3(y, x, bs, cs, ds);
                    if (NumberMethod2 == 2)
                        zg = SummaAG(x, y) + Y(y);
                    if (NumberMethod2 > 2)
                        zg = SummaGG(x, y);
                }
                else
                {
                    yg = re4(y);
                    zg = SummaGG(x, y);
                }

                xp[k] = (int)(1024 / (b1 - a1) * (y - a1));
                yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg - ymin));
                zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));
                y = y + h;
            }

            Number = n;
            Rangemin = a1;
            Rangemax = b1;
            NumberGr = ng;
            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());
        }
    }
}
