using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline3
{
    public partial class Form1 : Form
    {
        
        BondaryEquation bondaryEquation = new BondaryEquation();

        public Form1()
        {
            InitializeComponent();
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();

            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";

            comboBox1.SelectedItem = "2";
            comboBox2.SelectedItem = "1";
            comboBox3.SelectedItem = "1";
            comboBox4.SelectedItem = "1";

            this.textBox3.Text = bondaryEquation.Number.ToString();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            bondaryEquation.Number = Convert.ToInt32(this.textBox3.Text);
            int num = bondaryEquation.Number;
            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   5 : " + BasicFunctionClass.N.ToString());
                return;
            }

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            bondaryEquation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            bondaryEquation.Rangemax = Convert.ToDouble(str, provider);

            bondaryEquation.h = (bondaryEquation.Rangemax - bondaryEquation.Rangemin) / (double)(num - 1);

            BasicFunctionClass.KeyOfJob = Convert.ToInt32(comboBox1.SelectedItem);
            bondaryEquation.primer2 = Convert.ToInt32(comboBox2.SelectedItem);
            bondaryEquation.NumberMethod2 = Convert.ToInt32(comboBox3.SelectedItem);
            bondaryEquation.NumberSlay = Convert.ToInt32(comboBox4.SelectedItem);

            if (BasicFunctionClass.KeyOfJob == 4)
            {
                bondaryEquation.primer4 = Convert.ToInt32(comboBox2.SelectedItem);
                if (bondaryEquation.primer4 > 5)
                {
                    MessageBox.Show("  .    6.");
                    return;
                }
                bondaryEquation.NumberMethod4 = Convert.ToInt32(comboBox3.SelectedItem);
                if (bondaryEquation.NumberMethod4 > 4)
                {
                    MessageBox.Show("  .    5.");
                    return;
                }
            }

            if (BasicFunctionClass.KeyOfJob == 2)
            {
                if (bondaryEquation.NumberMethod2 == 1)
                {
                    bondaryEquation.MatrixVectSet(bondaryEquation.alf, bondaryEquation.bet,
                        bondaryEquation.gam, bondaryEquation.b);
                    bondaryEquation.GaussB(bondaryEquation.alf, bondaryEquation.bet,
                        bondaryEquation.gam, bondaryEquation.b, bondaryEquation.x);
                    bondaryEquation.Tabulation(bondaryEquation.xp, bondaryEquation.yp, bondaryEquation.zp);
                }
                else
                    if (bondaryEquation.NumberMethod2 == 2)
                    {
                        bondaryEquation.MatrixVectAG(BasicFunctionClass.a, bondaryEquation.b);
                        if (bondaryEquation.NumberSlay == 1)
                        {
                            BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, bondaryEquation.b, bondaryEquation.x);
                        }
                        else
                        {
                            BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond, BasicFunctionClass.ipvt,
                                BasicFunctionClass.work);
                            MessageBox.Show("Cond : " + BasicFunctionClass.cond.ToString());
                            BasicFunctionClass.Solve(BasicFunctionClass.a, bondaryEquation.b, BasicFunctionClass.ipvt);
                        }
                        bondaryEquation.Tabulation(bondaryEquation.xp, bondaryEquation.yp, bondaryEquation.zp);
                    }
                    else
                        if (bondaryEquation.NumberMethod2 > 2)
                        {
                            bondaryEquation.MatrixVectGG2(BasicFunctionClass.a, bondaryEquation.b);

                            if (bondaryEquation.NumberSlay == 1)
                            {
                                BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, bondaryEquation.b, bondaryEquation.x);
                            }
                            else
                            {
                                BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond, BasicFunctionClass.ipvt,
                                    BasicFunctionClass.work);
                                MessageBox.Show("Cond : " + BasicFunctionClass.cond.ToString());
                                BasicFunctionClass.Solve(BasicFunctionClass.a, bondaryEquation.b, BasicFunctionClass.ipvt);
                            }
                            bondaryEquation.Tabulation(bondaryEquation.xp, bondaryEquation.yp, bondaryEquation.zp);
                        }
            }

            if (BasicFunctionClass.KeyOfJob == 4)
            {
                bondaryEquation.MatrixVectGG4(BasicFunctionClass.a, bondaryEquation.b);

                if (bondaryEquation.NumberSlay == 1)
                {
                    BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, bondaryEquation.b, bondaryEquation.x);
                }
                else
                {
                    BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond, BasicFunctionClass.ipvt,
                        BasicFunctionClass.work);
                    MessageBox.Show("Cond : " + BasicFunctionClass.cond.ToString());
                    BasicFunctionClass.Solve(BasicFunctionClass.a, bondaryEquation.b, BasicFunctionClass.ipvt);
                }
                bondaryEquation.Tabulation(bondaryEquation.xp, bondaryEquation.yp, bondaryEquation.zp);
            }

            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}