using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline4
{
    public partial class Form1 : Form
    {

        ProblemAproximation problemAproximation = new ProblemAproximation();

        public Form1()
        {
            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            InitializeComponent();

            this.textBox1.Text = "-1.0";
            this.textBox2.Text = "1.0";

            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            problemAproximation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            problemAproximation.Rangemax = Convert.ToDouble(str, provider);

            this.textBox3.Text = problemAproximation.Number.ToString();
            this.textBox4.Text = "10.0";

            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            problemAproximation.WidthOfBasicElement = Convert.ToDouble(str, provider);              

            comboBox1.SelectedItem = "1";
            comboBox2.SelectedItem = "1";
            comboBox3.SelectedItem = "0";
            comboBox4.SelectedItem = "0";
            comboBox5.SelectedItem = "1";
        }

        private void button1_Click(object sender, EventArgs e)
        {

            System.Globalization.NumberFormatInfo provider = new System.Globalization.NumberFormatInfo();
            provider.NumberDecimalSeparator = ",";
            provider.NumberGroupSeparator = " ";
            provider.NumberGroupSizes = new int[] { 3 };

            problemAproximation.Number = Convert.ToInt32(this.textBox3.Text);

            int num = problemAproximation.Number;
            if (num < 5 || num > BasicFunctionClass.N)
            {
                MessageBox.Show("   .   5 : " + BasicFunctionClass.N.ToString());
                return;
            }

            problemAproximation.m = num * 10;
            problemAproximation.h = (problemAproximation.Rangemax - problemAproximation.Rangemin) / (double)(num - 1);
            problemAproximation.h1 = (problemAproximation.Rangemax - problemAproximation.Rangemin) / 
                (double)(problemAproximation.m - 1);

            BasicFunctionClass.primer = comboBox1.SelectedIndex + 1;
            if (BasicFunctionClass.primer < 1 || BasicFunctionClass.primer > 9)
            {
                MessageBox.Show("  .   1 : 9");
                return;
            }
            problemAproximation.NumberMethod = comboBox2.SelectedIndex + 1;
            if (problemAproximation.NumberMethod < 0 || problemAproximation.NumberMethod > 23)
            {
                MessageBox.Show("  .   1 : 23");
                return;
            }

            problemAproximation.PowerOfBasicElement = comboBox3.SelectedIndex;
            if (problemAproximation.PowerOfBasicElement < 0 || problemAproximation.PowerOfBasicElement > 23)
            {
                MessageBox.Show("  .   0 : 11");
                return;
            }
            BasicFunctionClass.KeyOfJob = comboBox4.SelectedIndex;
            if (BasicFunctionClass.KeyOfJob < 0 || BasicFunctionClass.KeyOfJob > 1)
            {
                MessageBox.Show("  .   0 : 1");
                return;
            }

            bool ret = CheckPowerOfBasic(problemAproximation.NumberMethod, 
                problemAproximation.PowerOfBasicElement);
            if (ret == false)
                return;


            string str = this.textBox1.Text;
            str = str.Replace('.', ',');
            problemAproximation.Rangemin = Convert.ToDouble(str, provider);
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            problemAproximation.Rangemax = Convert.ToDouble(str, provider);
            problemAproximation.methodSlay = comboBox5.SelectedIndex + 1; ;
            str = this.textBox2.Text;
            str = str.Replace('.', ',');
            problemAproximation.WidthOfBasicElement = Convert.ToDouble(str, provider);             

            if (problemAproximation.NumberMethod == 1)
            {
                problemAproximation.MatrixVectS(problemAproximation.alf, problemAproximation.bet, 
                    problemAproximation.gam, problemAproximation.b);
                problemAproximation.GaussS3(problemAproximation.alf, problemAproximation.bet, 
                    problemAproximation.gam, problemAproximation.b, problemAproximation.x);
                problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                    problemAproximation.zp);
            }
            else 
            if (problemAproximation.NumberMethod == 2)
            {
                problemAproximation.MatrixVectB(problemAproximation.alf, problemAproximation.bet, 
                    problemAproximation.gam, problemAproximation.b);
                problemAproximation.GaussB(problemAproximation.alf, problemAproximation.bet, 
                    problemAproximation.gam, problemAproximation.b, problemAproximation.x);
                problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                    problemAproximation.zp);
            }
            else 
            if (problemAproximation.NumberMethod == 3)
            {
                problemAproximation.MatrixVectA(BasicFunctionClass.a, problemAproximation.b);
                BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, problemAproximation.b, 
                    problemAproximation.x);
                problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                    problemAproximation.zp);
            }
            else
                if (problemAproximation.NumberMethod == 4)
                {
                    problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                        problemAproximation.zp);
                }
                else
                {
                    if (problemAproximation.methodSlay == 1)
                    {
                        problemAproximation.MatrixVectf(BasicFunctionClass.a, problemAproximation.aa, 
                            problemAproximation.b);
                        BasicFunctionClass.Gauss(BasicFunctionClass.n, BasicFunctionClass.a, problemAproximation.b, 
                            problemAproximation.x);
                        problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                            problemAproximation.zp);
                    }
                    else
                        if (problemAproximation.methodSlay == 2)
                        {
                            problemAproximation.MatrixVectf(BasicFunctionClass.a, problemAproximation.aa, 
                                problemAproximation.b);
                            BasicFunctionClass.Decomp(BasicFunctionClass.a, ref BasicFunctionClass.cond,
                                BasicFunctionClass.ipvt, BasicFunctionClass.work);

                            MessageBox.Show("Cond = " + BasicFunctionClass.cond.ToString());

                            BasicFunctionClass.Solve(BasicFunctionClass.a, problemAproximation.b,
                                BasicFunctionClass.ipvt);
                            problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                                problemAproximation.zp);
                        }
                    else
                        if (problemAproximation.methodSlay == 3)
                        {
                            problemAproximation.MatrixVectf(BasicFunctionClass.a, problemAproximation.aa,
                                problemAproximation.b);
                            problemAproximation.Mfss(problemAproximation.aa, problemAproximation.Number,
                                BasicFunctionClass.trac);
                            problemAproximation.Mlss(problemAproximation.aa, problemAproximation.Number,
                                BasicFunctionClass.trac, problemAproximation.b);
                            problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                                problemAproximation.zp);
                        }
                        else
                            if (problemAproximation.methodSlay == 4)
                            {
                                problemAproximation.MatrixVectf(BasicFunctionClass.a, problemAproximation.aa, 
                                    problemAproximation.b);
                                BasicFunctionClass.Zeidel(BasicFunctionClass.n, BasicFunctionClass.a, problemAproximation.b, 
                                    problemAproximation.x);
                                problemAproximation.Tabulation(problemAproximation.xp, problemAproximation.yp, 
                                    problemAproximation.zp);
                            };
                    }
            Form2 frm = new Form2();
            frm.Show();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private bool CheckPowerOfBasic(int type, int power)
        {
            int[] p5 = { 1, 3, 5, 7, 9, 11 };
            int[] p8 = { 0, 1, 2, 3 };
            int[] p9 = { 1, 3 };
            int[] p10 = { 1, 2, 3 };
            int[] p11 = { 1, 2 };
            int[] p12 = { 3, 5 };
            int[] p13 = { 3, 5 };
            int[] p14 = { 2, 3 };
            int[] p15 = { 1, 2 };
            int[] p16 = { 0, 1 };
            int[] p17 = { 1, 2, 3 };
            int[] p21 = { 1, 2 };
            bool ret = true;
            switch (type)
            {
                case 5:
                    ret = CheckPowerByType(p5, type, power);
                    break;
                case 8:
                    ret = CheckPowerByType(p8, type, power);
                    break;
                case 9:
                    ret = CheckPowerByType(p9, type, power);
                    break;
                case 10:
                    ret = CheckPowerByType(p10, type, power);
                    break;
                case 11:
                    ret = CheckPowerByType(p11, type, power);
                    break;
                case 12:
                    ret = CheckPowerByType(p12, type, power);
                    break;
                case 13:
                    ret = CheckPowerByType(p13, type, power);
                    break;
                case 14:
                    ret = CheckPowerByType(p14, type, power);
                    break;
                case 15:
                    ret = CheckPowerByType(p15, type, power);
                    break;
                case 16:
                    ret = CheckPowerByType(p16, type, power);
                    break;
                case 17:
                    ret = CheckPowerByType(p17, type, power);
                    break;
                case 21:
                    ret = CheckPowerByType(p21, type, power);
                    break;
                default:
                    break;
            }

            return ret;
        }

        private bool CheckPowerByType(int[] p, int type, int power)
        {
            string mes = "";
            for (int i = 0; i < p.Length; i++)
            {
                mes = mes + " " + p[i].ToString();
            }
            bool find = false;
            for (int i = 0; i < p.Length; i++)
            {
                if (power == p[i])
                {
                    find = true;
                    break;
                }
            }
            if (find == false)
            {
                MessageBox.Show("   " 
                    + type.ToString() + ".    .\n   : " + mes);
                return false;
            }

            return true;

        }


    }
}