﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline4
{
    class LinearMethod : BasicFunctionClass
    {
        public const int N = 1001;

        static public int n = 21;

        public double h = (b1 - a1) / (double)(n - 1);

        public const int kmax = 1000;
        public double EpsZeidel = 0.00000001;
        public double EpsMfss = 0.000000000000000000001;
        public double AlfaMfss = 0.000000000001; //11, n=101
        public int[] ipvt = new int[N];
        public double[] work = new double[N];
        public int inc = 0;
        public int irank = 0;
        public int ier = 0;
        public double[] trac = new double[N];
        public double[] rhs = new double[N];
        public double al = 10.0;
        public double cond = 1.0;

        static public double a1;
        public double Rangemin
        {
            get { return a1; }
            set { a1 = value; }
        }

        static public double b1;
        public double Rangemax
        {
            get { return b1; }
            set { b1 = value; }
        }
        
        public void GaussB(double[] alf, double[] bet, double[] gam, double[] b, double[] x)//стр.137
        {
            int i;
            for (i = 1; i < n; i++)
            {
                alf[i] = alf[i] - bet[i - 1] * gam[i - 1] / alf[i - 1];
                b[i] = b[i] - bet[i - 1] * b[i - 1] / alf[i - 1];
            }
            x[n - 1] = b[n - 1] / alf[n - 1];
            for (i = n - 2; i >= 0; i--) x[i] = (b[i] - gam[i] * x[i + 1]) / alf[i];
            MessageBox.Show("Hello GaussB  " + n.ToString());
            return;
            //printf("n=   %d   Hello GaussB\n",n);
            //return;
        }

        public void GaussS3(double[] alf, double[] bet, double[] gam, double[] b, double[] x)//стр.137
        {
            int i;
            for (i = 1; i <= (n - 3); i++)
            {
                alf[i] = alf[i] - bet[i - 1] * gam[i - 1] / alf[i - 1];
                b[i] = b[i] - bet[i - 1] * b[i - 1] / alf[i - 1];
            }
            x[n - 3] = b[n - 3] / alf[n - 3];
            for (i = (n - 4); i >= 0; i--) x[i] = (b[i] - gam[i] * x[i + 1]) / alf[i];
            MessageBox.Show("Hello GaussS3  " + n.ToString());
            return;
            // printf("n=   %d   Hello GaussS3\n",n);
            // return;
        }

 
        public void Gauss(double[,] a, double[] b, double[] x) //стр.137
        {
            int i, j, k;
            double det = 1.0;
            for (k = 0; k < n - 1; k++)
            {
                ///*
                int l = k; double t = Math.Abs(a[k, k]);
                for (i = k + 1; i < n; i++)
                    if (Math.Abs(a[i, k]) > t) { l = i; t = Math.Abs(a[i, k]); };
                if (l != k)
                {
                    for (j = k; j < n; j++)
                    {
                        t = a[k, j];
                        a[k, j] = a[l, j]; a[l, j] = t;
                    };
                    t = b[k]; b[k] = b[l]; b[l] = t;
                }
                //*/
                det *= a[k, k];
                for (i = k + 1; i < n; i++)
                {
                    double d = a[i, k] / a[k, k];
                    for (j = k + 1; j < n; j++)
                        a[i, j] -= d * a[k, j];
                    b[i] -= d * b[k];
                }
            };
            x[n - 1] = b[n - 1] / a[n - 1, n - 1];
            for (i = n - 2; i >= 0; i--)
            {
                double s = 0;
                for (j = i + 1; j < n; j++)
                    s = s + a[i, j] * x[j];
                x[i] = (b[i] - s) / a[i, i];
            };
            //	        cout <<"det="<<det<<"   ";
            //	        printf("n=   %d   Hello Gauss\n",n);
            MessageBox.Show("Hello Gauss n = " + n.ToString());
            return;
        }

        public void GaussJ(double[,] a, double[] b, double[] x)//стр.137
        {
            int i, j, k;
            for (k = 0; k < n; k++)
            {
                int l = k;
                double t = Math.Abs(a[k, k]);
                for (i = k + 1; i < n; i++)
                    if (Math.Abs(a[i, k]) > t)
                    {
                        l = i;
                        t = Math.Abs(a[i, k]);
                    }
                if (l != k)
                {
                    for (j = k; j < n; j++)
                    {
                        double t1 = a[k, j];
                        a[k, j] = a[l, j];
                        a[l, j] = t1;
                    };
                    t = b[k];
                    b[k] = b[l];
                    b[l] = t;
                }
                for (j = k + 1; j < n; j++)
                    a[k, j] /= a[k, k];

                b[k] /= a[k, k];
                for (i = 0; i < n; i++)
                    if (i != k)
                    {
                        for (j = k + 1; j < n; j++)
                            a[i, j] -= a[i, k] * a[k, j];
                        b[i] -= a[i, k] * b[k];
                    }
            }
            for (i = 0; i < n; i++)
                x[i] = b[i];
            MessageBox.Show("Hello Gauss-Jordan n = " + n.ToString());
            return;
        }

        public void Zeidel(double[,] a, double[] b, double[] x)//стр.137
        {
            int i, j, k; double s, t, d, r;

            for (i = 0; i < n; i++) x[i] = 0.0;
            for (k = 0; k < kmax; k++)
            {
                d = -1.0;
                for (i = 0; i < n; i++)
                {
                    s = 0.0;
                    for (j = 0; j < i; j++) s = s + a[i, j] * x[j];
                    for (j = i + 1; j < n; j++) s = s + a[i, j] * x[j];
                    t = (b[i] - s) / a[i, i]; r = Math.Abs(t - x[i]);
                    if (r > d) d = r;
                    x[i] = t;
                };
                if (d < EpsZeidel) goto M2;
            }
            MessageBox.Show("MatrixVectZ. Tochnost ne dostignuta" + n.ToString());
            goto M1;
        M2:
            //	        printf("k=   %d   Hello Zeidel\n",k);
            MessageBox.Show("MatrixVectZ  " + n.ToString());
        M1: return;
        }

         public void Mfss(double[] aa, int n, double[] trac)//стр.137
        {
            double sum, piv, hold; int i, j, k, isub, kpiv, ksub, kmi, ji, idc, jj, kk, ii, jk, l;

            isub = 0;
            ksub = 0;
            kpiv = 0;
            j = 0;
            piv = 0.0;

            for (k = 1; k <= n; k++)
            {
                j = j + k;
                trac[k - 1] = aa[j - 1];
                if ((aa[j - 1] - piv) > 0)
                {
                    piv = aa[j - 1];
                    ksub = j;
                    kpiv = k;
                }
            }

            for (i = 1; i <= n; i++)
            {
                isub = isub + i;
            m4: kmi = kpiv - i;

                if (kmi < 0)
                    goto m35;
                if (kmi == 0)
                    goto m9;
                ji = ksub - kmi;
                idc = ji - isub;
                jj = isub - i + 1;
                for (k = jj; k <= isub; k++)
                {
                    kk = k + idc;
                    hold = aa[k - 1];
                    aa[k - 1] = aa[kk - 1];
                    aa[kk - 1] = hold;
                }
                kk = ksub;
                for (k = kpiv; k <= n; k++)
                {
                    ii = kk - kmi;
                    hold = aa[kk - 1];
                    aa[kk - 1] = aa[ii - 1];
                    aa[ii - 1] = hold;
                    kk = kk + k;
                }
                jj = kpiv - 1;
                ii = isub;
                for (k = i; k <= jj; k++)
                {
                    hold = aa[ii - 1];
                    aa[ii - 1] = aa[ji - 1];
                    aa[ji - 1] = hold;
                    ii = ii + k;
                    ji = ji + 1;
                }

            m9: if (irank < 0)
                    goto m22;
                trac[kpiv - 1] = trac[i - 1];
                trac[i - 1] = kpiv;
                kk = i - 1 - irank;
                kmi = isub - kk;
                piv = 0.0;
                idc = irank + 1;
                ji = isub - 1;
                jk = kmi;
                jj = isub - i;
                for (k = i; k <= n; k++)
                {
                    sum = 0.0;
                    if (kk <= 0)
                        goto m13;
                    for (j = kmi; j <= ji; j++) { sum = sum - aa[j - 1] * aa[jk - 1]; jk = jk + 1; }
                m13: jj = jj + k;
                    if ((k - i) > 0)
                        goto m16;
                    sum = aa[isub - 1] + sum;
                    if ((sum - Math.Abs(aa[isub - 1] * EpsMfss)) <= 0)
                        goto m20;
                    aa[isub - 1] = Math.Sqrt(sum);
                    kpiv = i + 1;
                    goto m19;
                m16: sum = (aa[jk - 1] + sum) / aa[isub - 1];
                    aa[jk - 1] = sum;
                    if (aa[jj - 1] <= 0)
                        goto m19;
                    trac[k - 1] = trac[k - 1] - (sum * sum);
                    hold = trac[k - 1] / aa[jj - 1];
                    if ((piv - hold) >= 0)
                        goto m19;
                    piv = hold;
                    kpiv = k;
                    ksub = jj;
                m19: jk = jj + idc;
                }
                goto m32;
            m20: if (irank > 0)
                    goto m37;
                irank = -1;
                goto m4;
            m22: irank = i - 1;
                ii = isub - irank;
                ji = ii;
                for (k = 1; k <= irank; k++)
                {
                    ji = ji - 1;
                    jk = isub - 1;
                    jj = k - 1;
                    for (j = i; j <= n; j++)
                    {
                        idc = irank;
                        sum = 0.0;
                        kmi = ji;
                        kk = jk;
                        if (jj <= 0)
                            goto m25;
                        for (l = 1; l <= jj; l++)
                        {
                            idc = idc - 1;
                            sum = sum - aa[kmi - 1] * aa[kk - 1];
                            kmi = kmi - idc;
                            kk = kk - 1;
                        }
                    m25: aa[kk - 1] = (sum + aa[kk - 1]) / aa[kmi - 1];
                        jk = jk + j;
                    }
                }
                jj = isub - i;
                piv = 0.0;
                kk = isub - 1;
                for (k = i; k <= n; k++)
                {
                    jj = jj + k;
                    idc = 0;
                    for (j = k; j <= n; j++)
                    {
                        sum = 0.0;
                        kmi = jj + idc;
                        for (l = ii; l <= kk; l++)
                        {
                            jk = l + idc;
                            sum = sum + aa[l - 1] * aa[jk];
                        }
                        aa[kmi - 1] = sum;
                        idc = idc + j;
                    }
                    aa[jj - 1] = aa[jj - 1] + 1.0;
                    trac[k - 1] = aa[jj - 1];
                    if ((piv - aa[jj - 1]) >= 0)
                        goto m30;
                    kpiv = k;
                    ksub = jj;
                    piv = aa[jj - 1];
                m30: ii = ii + k;
                    kk = kk + k;
                }
                goto m4;
            m32: ;
            }
            if (irank == 0) { irank = n; return; }
            else return;
        m35: return;
        m37: irank = -1;
            return;
        }

        public void Mlss(double[] aa, int n, double[] trac, double[] rhs)
        {
            double sum, hold; int i, j, idef, ite, ix2, isw, ista, iend, jj, kk, ii;
            MessageBox.Show("Hello Mfss-Mlss n = " + n.ToString());
            idef = n - irank;
            if (n <= 0)
                goto m33;
            if (irank <= 0)
                goto m33;
            if (idef < 0)
                goto m33;
            ite = irank * (irank + 1) / 2;
            ix2 = irank + 1;
            ier = 0;
            jj = 1;
            ii = 1;
        m4: for (i = 1; i <= n; i++)
            {
                j = (int)(trac[ii - 1]);
                if (j <= 0)
                    goto m31;
                hold = rhs[ii - 1];
                rhs[ii - 1] = rhs[j - 1];
                rhs[j - 1] = hold;
                ii = ii + jj;
            }
            if (jj < 0)
                goto m32;
            isw = 1;
            if (inc * idef == 0)
                goto m28;
        m8: ista = ite;
            for (i = 1; i <= irank; i++)
            {
                ista = ista + 1;
                jj = ista;
                sum = 0.0;
                for (j = ix2; j <= n; j++)
                {
                    sum = sum + aa[jj - 1] * rhs[j - 1];
                    jj = jj + j;
                }
                rhs[i - 1] = rhs[i - 1] + sum;
            }
            if (isw == 2)
                goto m28;
        m11: ista = ite;
            for (i = ix2; i <= n; i++)
            {
                jj = ista;
                sum = 0.0;
                for (j = 1; j <= irank; j++)
                {
                    jj = jj + 1;
                    sum = sum + aa[jj - 1] * rhs[j - 1];
                }
                if (isw == 3)
                    goto m14;
                sum = -sum;
            m14: rhs[i - 1] = sum;
                ista = ista + i;
            }
            if (isw == 3)
                goto m30;
            if (isw == 2)
                goto m29;
        m16: ista = ix2;
            iend = n;
            jj = ite + ista;
        m17: sum = 0.0;
            for (i = ista; i <= iend; i++)
            {
                if (aa[jj - 1] == 0)
                    goto m31;
                rhs[i - 1] = (rhs[i - 1] - sum) / aa[jj - 1];
                if (i >= iend)
                    goto m21;
                jj = jj + ista;
                sum = 0.0;
                for (j = ista; j <= i; j++)
                {
                    sum = sum + aa[jj - 1] * rhs[j - 1];
                    jj = jj + 1;
                }
            }
        m21: sum = 0.0;
            ii = iend;
            for (i = ista; i <= iend; i++)
            {
                rhs[ii - 1] = (rhs[ii - 1] - sum) / aa[jj - 1];
                if (ii <= ista)
                    goto m25;
                kk = jj - 1;
                sum = 0.0;
                for (j = ii; j <= iend; j++)
                {
                    sum = sum + aa[kk - 1] * rhs[j - 1];
                    kk = kk + j;
                }
                jj = jj - ii;
                ii = ii - 1;
            }

        m25: if (idef == 0)
                goto m30;
            if (isw == 2)
                goto m11;
            if (isw == 3)
                goto m8;
            isw = 2;
            goto m8;
        m28: ista = 1;
            iend = irank;
            jj = 1;
            isw = 2;
            goto m17;
        m29: isw = 3;
            goto m16;
        m30: ii = n;
            jj = -1;
            goto m4;
        m31: ier = 1;
        m32: return;
        m33: ier = -1;
            return;
        }

        public void Decomp(double[,] a, ref double cond, int[] ipvt, double[] work)
        {
            int i, j, k, m; double anorm, ynorm, znorm, ek, t;

            ipvt[n - 1] = 1;
            if (n != 0)
            {

                anorm = 0.0;
                for (j = 0; j < n; j++)
                {
                    t = 0.0;
                    for (i = 0; i < n; i++)
                        t = t + Math.Abs(a[i, j]);
                    if (t > anorm) anorm = t;
                }
                for (k = 0; k < n - 1; k++)
                {
                    m = k;
                    for (i = k + 1; i < n; i++)
                        if (Math.Abs(a[i, k]) > Math.Abs(a[m, k])) m = i;
                    ipvt[k] = m;
                    if (m != k) ipvt[n - 1] = -ipvt[n - 1];
                    t = a[m, k];
                    a[m, k] = a[k, k];
                    a[k, k] = t;
                    if (t != 0.0)
                    {
                        for (i = k + 1; i < n; i++)
                            a[i, k] = -a[i, k] / t;
                        for (j = k + 1; j < n; j++)
                        {
                            t = a[m, j];
                            a[m, j] = a[k, j];
                            a[k, j] = t;
                            if (t != 0.0) for (i = k + 1; i < n; i++) a[i, j] = a[i, j] + a[i, k] * t;
                        }
                    }
                }
                for (k = 0; k < n; k++)
                {
                    t = 0.0;
                    if (k != 0)
                        for (i = 0; i < k - 1; i++) t = t + a[i, k] * work[i];
                    ek = 1.0;
                    if (t < 0.0) ek = 1.0;
                    if (a[k, k] == 0.0) goto m90;
                    work[k] = -(ek + t) / a[k, k];
                }
                for (k = n - 2; k >= 0; k--)
                {
                    t = 0.0;
                    for (i = k + 1; i < n; i++) t = t + a[i, k] * work[k];
                    work[k] = t;
                    m = ipvt[k];
                    if (m != k)
                    {
                        t = work[m];
                        work[m] = work[k];
                        work[k] = t;
                    }
                }
                ynorm = 0.0;
                for (i = 0; i < n; i++) ynorm = ynorm + Math.Abs(work[i]);
                Solve(a, work, ipvt);
                znorm = 0.0;
                for (i = 0; i < n; i++) znorm = znorm + Math.Abs(work[i]);
                cond = anorm * znorm / ynorm;
                if (cond < 1.0) cond = 1.0;
                goto m;
            }
            cond = 1.0;
            if (Math.Abs(a[0, 0]) != 0.0) goto m;
        m90: cond = 1.0D + 72;
        m: MessageBox.Show("MatrixVectDS  " + n.ToString());
            return;
        }

        public void Solve(double[,] a, double[] b, int[] ipvt)
        {
            int i, k, m; double t;

            if (n != 0)
            {
                for (k = 0; k < n - 1; k++)
                {
                    m = ipvt[k];
                    t = b[m];
                    b[m] = b[k];
                    b[k] = t;
                    for (i = k + 1; i < n; i++)
                    {
                        b[i] = b[i] + a[i, k] * t;
                    }
                }
                for (k = n - 1; k > 0; k--)
                {
                    b[k] = b[k] / a[k, k];
                    t = -b[k];
                    for (i = 0; i < k; i++)
                    {
                        b[i] = b[i] + a[i, k] * t;
                    }
                }
            }
            b[0] = b[0] / a[0, 0];
            return;
        }

    }
}
