﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline4
{
    class ProblemAproximation : BasicFunctionClass
    {
        public const int ng = 1024;

        public int m = n * 10;
        public double h1 = (b1 - a1) / (double)(n * 10 - 1);

        public int SpB=3; 
        public int setka = 0; //0-равномерная сетка, 1-чебышовская

        public int NumberMethod = 1;
        public int methodSlay = 1;

        static public double ymas = 0.0;

        public double AlfaMfss = 0.000000000001; //11, n=101

        public double[] aa = new double[N * (N + 1) / 2];
        public double[] b = new double[N];
        public double[] x = new double[N];
        public double[] c = new double[N];

        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];

        public double[] alf = new double[N];
        public double[] bet = new double[N];
        public double[] gam = new double[N];
        public double[] bs = new double[N];
        public double[] cs = new double[N];
        public double[] ds = new double[N];

        static public int numberGr = 1024;
        public int NumberGr
        {
            get { return numberGr; }
            set { numberGr = value; }
        }
 
        static public int numberSlay = 1;
        public int NumberSlay
        {
            get { return numberSlay; }
            set { numberSlay = value; }
        }

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }

        public double f(double x)
        {
            double ret = 0.0;
            switch (primer)
            {
                case 1: ret = 1.0 / (1.0 + 25.0 * x * x);
                    goto M;
                case 2: ret = Math.Sin(_Pi * x);
                    goto M; 
                case 3: ret = Math.Exp(Math.Cos(_Pi * x));
                    goto M; 
                case 4: ret = sgn(x) * step(2, x) * (x - a1) * (x - b1);
                    goto M; 
                case 5: ret = Math.Abs(x);
                    goto M; 
                case 6: ret = (Math.Abs(x) < 0.5) ? 1.0 : 0.0;
                    goto M; 
                case 7: ret = Tch(pr, x);
                    goto M; 
                case 8: ret = Bessel(pr, x);
                    goto M; 
                case 9: ret = Erf(x);
                    goto M; 
                default: MessageBox.Show("sorry, bad parameter primer");
                    goto M; 
            }
        M: return ret;
        }

        public double BasisElementApr(int i, double x)
        {
            double t = 0.0; double ret = 0.0;
            switch (TypeOfBasicElement)
            {
                case 1:
                    NumberMethod = 1;
                    goto M;
                case 2:
                    NumberMethod = 2;
                    goto M;
                case 3:
                    NumberMethod = 3;
                    goto M;
                case 4:
                    NumberMethod = 4;
                    goto M;
                case 5:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 5;
                    goto M;
                case 6:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 6;
                    goto M;
                case 7:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 7;
                    goto M;
                case 8:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 8;
                    goto M;
                case 9:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 9;
                    goto M;
                case 10:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 10;
                    goto M;
                case 11:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 11;
                    goto M;
                case 12:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 12;
                    goto M;
                case 13:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 13;
                    goto M;
                case 14:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 14;
                    goto M;
                case 15:
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, x, xi(i));
                    NumberMethod = 15;
                    goto M;
                case 16:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 16;
                    goto M;
                case 17:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 17;
                    goto M;
                case 18:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 18;
                    goto M;
                case 19:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 19;
                    goto M;
                case 20:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 20;
                    goto M;
                case 21:
                    t = (x - xi(i)) / h;
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 21;
                    goto M;
                case 22:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 22;
                    goto M;
                case 23:
                    t = (x - xi(i));
                    ret = BasicElement(PowerOfBasicElement, WidthOfBasicElement, t, 0.0);
                    NumberMethod = 23;
                    goto M;
                default: MessageBox.Show("sorry, method");
                    goto M;
            }
        M: return ret;
        }

        public void MatrixVectf(double[,] a, double[] aa, double[] x)
        {
            int i, j, k, k1; double s, z1, z2;
            if ((KeyOfJob == 0) && (methodSlay != 3))
            {
                for (i = 0; i < n; i++)
                    for (j = 0; j < n; j++)
                    {
                        a[j, i] = BasisElementApr(i, xi(j));
                    };
                for (j = 0; j < n; j++)
                {
                    b[j] = f(xi(j));
                }
                goto M;
            }
            if ((KeyOfJob == 1) && (methodSlay != 3))
            {
                for (j = 0; j < n; j++)
                    for (i = 0; i < n; i++)
                    {
                        s = 0.0;
                        for (k1 = 0; k1 < m; k1++)
                        {
                            z1 = BasisElementApr(i, a1 + k1 * h1);
                            z2 = BasisElementApr(j, a1 + k1 * h1);
                            s = s + z1 * z2;
                        }
                        if (i == j) s = s + AlfaMfss;
                        a[i, j] = s;
                    }
                for (i = 0; i < n; i++)
                {
                    s = 0.0;
                    for (k1 = 0; k1 < m; k1++)
                    {
                        z1 = BasisElementApr(i, a1 + k1 * h1);
                        z2 = f(a1 + k1 * h1);
                        s = s + z1 * z2;
                    }
                    b[i] = s;
                }
                goto M;
            }
            if ((KeyOfJob == 1) && (methodSlay == 3))
            {
                k = 0;
                for (j = 0; j < n; j++)
                    for (i = 0; i <= j; i++)
                    {
                        k = k + 1;
                        s = 0.0;
                        for (k1 = 0; k1 < m; k1++)
                        {
                            z1 = BasisElementApr(i, a1 + k1 * h1);
                            z2 = BasisElementApr(j, a1 + k1 * h1);
                            s = s + z1 * z2;
                        }
                        if (i == j) s = s + AlfaMfss;
                        aa[k - 1] = s;
                    }
                for (i = 0; i < n; i++)
                {
                    s = 0.0;
                    for (k1 = 0; k1 < m; k1++)
                    {
                        z1 = BasisElementApr(i, a1 + k1 * h1);
                        z2 = f(a1 + k1 * h1);
                        s = s + z1 * z2;
                    }
                    b[i] = s;
                }
            }
            else
            {
                MessageBox.Show("KeyOfJob = 0, methodSlay = 3 - inadmissible combination");
                return;
            }
            M:;MessageBox.Show("MatrixVectf  " + n.ToString());
            return;
        }

        public void MatrixVectA(double[,] a, double[] b)//стр.137
        {
            int i, j;
            double x2 = 0.0;

            for (i = 0; i < n; i++)
                for (j = 0; j < n; j++)
                {
                    if (setka == 0) x2 = a1 + j * h; else x2 = Math.Cos((2.0 * j + 1) * _Pi / 2.0 / n);
                    a[j, i] = step(i, x2);
                };

            for (j = 0; j < n; j++)
            {
                if (setka == 0) x2 = a1 + j * h; else x2 = Math.Cos((2.0 * j + 1) * _Pi / 2.0 / n);
                b[j] = f(x2);
            };
            MessageBox.Show("MatrixVectA  " + n.ToString());
            return;
        }
        
        public void MatrixVectB(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i; 
            double a23 = 2.0 / 3.0; double a34 = 0.75; double a16 = 1.0 / 6.0; double a18 = 0.125; 
	        for (i = 0; i < n; i++)         
	        {
                if (SpB == 3) alf[i] = a23; else alf[i] = a34; 
                b[i]=f(a1+i*h);
	        }
	        for (i = 0; i < n-1 ; i++)
	        {
                if (SpB == 3) bet[i] = a16 ; else bet[i] = a18; 
                if (SpB == 3) gam[i] = a16; else gam[i] = a18; 
	        }
	        bet[n-1]=0.0; gam[n-1]=0.0;
            MessageBox.Show("MatrixVectB  " + n.ToString());
            return;
        }

        public void MatrixVectS(double[] alf, double[] bet, double[] gam, double[] b)//стр.137
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            { 
                alf[i - 1] = 2.0 / 3.0; b[i - 1] = (f(a1 + (i - 1) * h) - 2.0 * f(a1 + i * h) + 
                f(a1 + (i + 1) * h)) / h / h; 
            }
            for (i = 1; i <= (n - 3); i++)
            { 
                bet[i - 1] = 1.0 / 6.0; gam[i - 1] = 1.0 / 6.0; 
            }
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            MessageBox.Show("MatrixVectS  " + n.ToString());
            return;
        }

        public void GaussO2(double[] x)
        {
            int i, j; double x1, s;
            x[0] = 0.0;
            for (i = 0; i < n; i++)
            {
                s = 0.0; x1 = a1 + i * h;
                for (j = 0; j < i; j++) s = s + x[j];
                x[i] = (f(x1) - s) * 2.0;
            }
            MessageBox.Show("Hello GaussO2  " + n.ToString());
            return;
        }

        public double Summa(double[] x, double y)
        {
            int i; double s,p;
            s = 0.0;
            for (i = 0; i < n; i++)
            {
                p = (methodSlay >= 2) ? b[i] : x[i];
                s = s + BasisElementApr(i, y) * p;
            }
            return s;
        }

        public double SummaA(double[] x, double y)
        {
            int i; double p;
            p = x[n - 1];
            for (i = n - 2; i >= 0; i--) p = x[i] + y * p;
            return p;
        }

        public double SummaS3(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) { bs[i] = (f(a1 + h) - f(a1)) / h - h / 6.0 * x[0]; cs[i] = 0.0; ds[i] = x[0] / 6.0 / h; }
                else
                { 
                    bs[i] = (f(a1 + (i + 1) * h) - f(a1 + (i) * h)) / h - h / 6.0 * (x[i] + 2.0 * x[i - 1]);
                    cs[i] = x[i - 1] / 2.0; ds[i] = (x[i] - x[i - 1]) / 6.0 / h; 
                };
            }
            i = (int)((y - a1) / h); 
            if (i == (n - 1)) 
            { 
                i = (n - 2); 
            }
            {
                r = y - (a1 + i * h);
                s = f(a1 + i * h) + bs[i] * r + cs[i] * r * r + ds[i] * r * r * r;
                return s;
            }
        }

        public double SummaB(double[] x, double y)
        {
	        int i,j; double z;
            i = (int)((y - a1) / h); 
            double s=0.0;
	        if (i == 0) 
	        {
                s=0.0;
                for (j = 0; j <= 2; j++) 
                {
                    if (SpB == 3) 
                        z = SplinePolinomialB(3, (y - (a1 + j * h)) / h);
                    else
                        z = SplinePolinomialB(2, (y - (a1 + j * h)) / h);
                    s=s+z*x[j];
                };
	        goto M;
	        }
	        else
                if (i == (n - 1)) { i = (n - 2); }
                else
                    if (i == (n - 2))
                    {
                        s = 0.0;
                        for (j = n - 3; j <= n - 1; j++)
                        {
                            if (SpB == 3) 
                                z = SplinePolinomialB(3, (y - (a1 + j * h)) / h);
                            else 
                                z = SplinePolinomialB(2, (y - (a1 + j * h)) / h);
                            s = s + z * x[j];
                        };
                        goto M;
                    }
                    else
                    {
                        s = 0.0;
                        for (j = (i - 1); j <= (i + 2); j++)
                        {
                            if (SpB == 3) 
                                z = SplinePolinomialB(3, (y - (a1 + j * h)) / h);
                            else 
                                z = SplinePolinomialB(2, (y - (a1 + j * h)) / h);
                            s = s + z * x[j];
                        };
                        goto M;
                    };
        M: return s;
        }

        public double alfa(int j)
        {
            int i; double y, s, z;

            s = 0.0;
            for (i = -n; i <= n; i++)
            {
                y = 2.0 * i / (2.0 * n + 1.0);
                z = f(y) - (f(a1) + (f(b1) - f(a1)) * (y - a1) / (b1 - a1));
                s = s + z * Math.Cos(_Pi * j * y);
            }
            return s * 2.0 / (2.0 * n + 1.0);
        }

        public double beta(int j)
        {
            int i; double y, s, z;
            s = 0.0;
            for (i = -n; i <= n; i++)
            {
                y = 2.0 * i / (2.0 * n + 1.0);
                z = f(y) - (f(a1) + (f(b1) - f(a1)) * (y - a1) / (b1 - a1));
                s = s + z * Math.Sin(_Pi * j * y);
            }
            return s * 2.0 / (2.0 * n + 1.0);
        }

        public double SummaT(double x)
        {
            int j; double s, z;

            s = 0.0; z = f(a1) + (f(b1) - f(a1)) * (x - a1) / (b1 - a1);
            for (j = 1; j <= n; j++) s = s + (alfa(j) * Math.Cos(_Pi * j * x) + beta(j) * Math.Sin(_Pi * j * x));
            s = s + alfa(0) / 2.0 + z;
            return s;
        }

        public void Tabulation(int[] xp, int[] yp, int[] zp)
        {
            int k;
            double y, NormC, NormL2, s, h, yd, yr, zmax, ymax, zmin, ymin, xg, yg;
            double zg = 0.0;
            y = a1; NormC = -1.0; s = 0;
            ymas = -1.0;
            double z = (double)(ng - 1);
            h = (b1 - a1) / z;
            for (k = 0; k < ng; k++)
            {
                yg = f(y);
                if (NumberMethod == 1) 
                    zg = SummaS3(y, x, bs, cs, ds);
                else
                    if (NumberMethod == 2) 
                        zg = SummaB(x, y);
                    else
                        if (NumberMethod == 3) 
                            zg = SummaA(x, y);
                        else
                            if (NumberMethod == 4) 
                                zg = SummaT(y);
                            else 
                                zg = Summa(x, y);
                {
                    yr = Math.Abs(yg - zg);
                    if (yr > NormC)
                        NormC = yr;
                    s = s + yr * yr;
                }
                if (Math.Abs(yg) > Math.Abs(zg))
                    yd = Math.Abs(yg);
                else
                    yd = Math.Abs(zg);
                if (yd > ymas)
                    ymas = yd;
                y = y + h;
            }

            ymax = ymas + 0.1 * ymas;
            ymin = -ymax;
            zmax = ymax;
            zmin = ymin;

            y = a1;
            ymas = -1.0;
            for (k = 0; k < ng; k++)
            {
                xg = y;
                yg = f(y);
                if (NumberMethod == 1) 
                    zg = SummaS3(y, x, bs, cs, ds);
                else
                    if (NumberMethod == 2) 
                        zg = SummaB(x, y);
                    else
                        if (NumberMethod == 3) 
                            zg = SummaA(x, y);
                        else
                            if (NumberMethod == 4) 
                                zg = SummaT(y);
                            else 
                                zg = Summa(x, y);
                xp[k] = (int)(1024 / (b1 - a1) * (xg - a1));
                yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg - ymin));
                zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));
                y = y + h;
            }

            Number = n;
            Rangemin = a1;
            Rangemax = b1;
            NumberGr = ng;
            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());
        }
    }
}
