﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline6
{
    class DifferenceIntegration : BasicFunctionClass
    {
        public const int ng = 1024;

        public int power = 5;

        public double z = (double)(n - 1);

        public int NamberMethod = 4;

        static public double ymas = 0.0;

        public double[] b = new double[N];
        public double[] x = new double[N];
        public double[] c = new double[N];
        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];
        public double[] alf = new double[N];
        public double[] bet = new double[N];
        public double[] gam = new double[N];
        public double[] bs = new double[N];
        public double[] cs = new double[N];
        public double[] ds = new double[N];
        public double[] es = new double[N];


        static public int numberGr = 1024;

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }

        public double f(double x)
            {
            double ret = 0.0;
            switch (primer)
            {
                case 1: ret = 1.0 / (1.0 + 25.0 * x * x);
                    goto M; 
                case 2: ret = _Pi * Math.Cos(4.0 * _Pi * x) * Math.Cos(0.25 * Math.Sin(4.0 * _Pi * x));  
                    goto M; 
                case 3: ret = Math.Atan(x); 
                    goto M; 
                case 4: ret = x * Math.Atan(x); 
                    goto M; 
                case 5: ret = Math.Log(x + Math.Sqrt(1.0 + x * x)); 
                    goto M;
                case 6: ret = Math.Exp(Math.Sin(4.0 * _Pi * x)) * Math.Cos(4.0 * _Pi * x);
                    goto M;
                case 7: ret = step(4, Math.Cos(_Pi * 2.0 * x));
                    goto M;
                case 8: ret = 15.0 * x / (step(4, 15.0 * x) + 2.0 * 15.0 * 15.0 * x * x + 5.0);
                    goto M;
                case 9: ret = (3.0 * sgn(10.0 * x - 5.0) * step(2, (10.0 * x - 5.0)) +
                        3.0 * sgn(10.0 * x + 5.0) * step(2, (10.0 * x + 5.0))) * 10.0;
                    goto M;
                case 10: ret = 1.0 / step(3, (1.0 + 25.0 * x * x));
                    goto M;
                case 11: ret = Math.Sin(4.0 * _Pi * x) / (1.0 + step(2, Math.Cos(_Pi * 4.0 * x))) * 4.0 * _Pi;
                    goto M;
                case 12: ret = ArctX(100.0 * x);
                    goto M; 
                default: MessageBox.Show("sorry 1, bad parameter primer");
                    goto M; 
            }
        M: return ret;
        }

        public double fp(double x)
        {
            double ret = 0.0;
            switch (primer)
            {

                case 1: ret = -50.0 * x / step(2, (1.0 + 25.0 * x * x));
                    goto M; 
                case 2: ret = -_Pi * _Pi * (step(2, Math.Cos(4.0 * _Pi * x)) * Math.Sin(0.25 * Math.Sin(4.0 * _Pi * x)) +
                        4.0 * Math.Sin(4.0 * _Pi * x) * Math.Cos(0.25 * Math.Sin(4.0 * _Pi * x))); 
                    goto M; 
                case 3: ret = 1.0 /(1.0 + x * x);
                    goto M; 
                case 4: ret = Math.Atan(x) + x /(1.0 + x * x); ;
                    goto M; 
                case 5: ret = 1.0 / Math.Sqrt(1.0 + x * x); 
                    goto M;
                case 6: ret = 4.0 * _Pi * Math.Exp(Math.Sin(4.0 * _Pi * x)) *
                        (step(2, Math.Cos(4.0 * _Pi * x)) - Math.Sin(4.0 * _Pi * x));
                    goto M;
                case 7: ret = -8.0 * _Pi * step(3, Math.Cos(_Pi * 2.0 * x)) * Math.Sin(2.0 * _Pi * x);
                    goto M;
                case 8: ret = (-3.0 * step(4, 15.0 * x) - 2.0 * step(2, 15.0 * x)+5.0) / 
                        step(2,(step(4, 15.0 * x) + 2.0 * 15.0 * 15.0 * x * x + 5.0))*15.0;
                    goto M;
                case 9: ret = 600.0 * (Math.Abs(10.0 * x - 5.0) + Math.Abs(10.0 * x + 5.0));
                    goto M;
                case 10: ret = -6.0 * 5.0 * x / step(4, (1.0 + 25.0 * x * x)) * 5.0;
                    goto M;
                case 11: ret = (Math.Cos(_Pi * 4.0 * x) * (1.0 + step(2, Math.Cos(_Pi * 4.0 * x))) +
                        Math.Cos(_Pi * 4.0 * x) * 2.0 * step(2, Math.Sin(4.0 * _Pi * x))) /
                            step(2, (1.0 + step(2, Math.Cos(_Pi * 4.0 * x)))) * 16.0 * _Pi * _Pi;
                    goto M;
                case 12: ret = (Math.Abs(100.0 * x) < 0.000001) ? (1.0 - 10000.0 * x * x / 3.0) * 100.0 :
                    Math.Atan(100.0 * x) / (100.0 * x) * 100.0;
                    goto M; 
                default: MessageBox.Show("sorry 1, bad parameter primer");
                    goto M; 
            }
        M: return ret;
        }

 
        public double fInt(double x)
        {
            double ret = 0.0;
            switch (primer)
            {
                case 1: ret = Math.Atan(x * 5.0) / 5.0; 
                    goto M;
                case 2: ret = Math.Sin(0.25 * Math.Sin(4.0 * _Pi * x));
                    goto M; 
                case 3: ret = x * Math.Atan(x) - 0.5 * Math.Log(1.0 + x * x);
                    goto M; 
                case 4: ret = 0.5 * x * x * Math.Atan(x) - 0.5 * x + 0.5 * Math.Atan(x);
                    goto M; 
                case 5: ret = x * Math.Log(x + Math.Sqrt(1.0 + x * x)) - Math.Sqrt(1.0 + x * x) + 1.0;
                    goto M; 
                case 6: ret = (Math.Exp(Math.Sin(4.0 * _Pi * x)) - 1.0) / _Pi / 4.0;
                    goto M; 
                case 7: ret = (0.375 * (_Pi * 2.0 * x) + 0.25 * Math.Sin(2.0 * _Pi * 2.0 * x) +
                        Math.Sin(4.0 * _Pi * 2.0 * x) / 32.0) / (_Pi * 2.0);
                    goto M; 
                case 8: ret = 0.25 * (Math.Atan((1.0 + 15.0 * 15.0 * x * x) / 2.0) - Math.Atan(0.5))/15.0;
                    goto M; 
                case 9: ret = (sgn(10.0 * x - 5.0) * step(3, (10.0 * x - 5.0)) +
                        sgn(10.0 * x + 5.0) * step(3, (10.0 * x + 5.0))) - 250.0;
                    goto M;
                case 10: ret = (5.0 * x / step(2, (1.0 + 25.0 * x * x)) / 4.0 +
                        0.375 * 5.0 * x / (1.0 + 25.0 * x * x) + 0.375 * Math.Atan(5.0 * x)) / 5.0;
                    goto M;
                case 11: ret = -Math.Atan(Math.Cos(4.0 * _Pi * x)) + Math.Atan(1.0);
                    goto M; 
                case 12: ret = 0.0;
                    goto M; 
               default: MessageBox.Show("sorry 1, bad parameter primer");
                    goto M;//break; 
            }
        M: return ret;
        }

        public double G(double x, double y)
        {
            int power = 5; 
            double p = Math.Abs(x - y); 
            return step(power,p);
        }

        public double Gp(double x, double y)
        {
            int power = 5; 
            double p = (x - y);
            return power * Math.Sign(p) * step(power - 1, p); 
        }

        public double FiG(int i, double x)
        {
            return G(x, xi(i));
        }

        public double BasInt(double x)
        {
            double p = Math.Abs(x);
            if (p > 1.0) 
                return 0.5 * sgn(x);
            else 
                return x - 0.5 * sgn(x) * x * x;
        }

        public double FiGp(int i, double x)
        {
            return Gp(x, xi(i));
        }

        public void MatrixVectf(double[,] a, double[] b)//стр.137
        {
            int i, j;

            for (i = 0; i < n; i++)
                for (j = 0; j < n; j++)
                {
                    a[j, i] = FiG(i, xi(j));
                }

            for (j = 0; j < n; j++)
            {
                b[j] = f(xi(j));
            }
            MessageBox.Show("MatrixVectf" + n.ToString());
            return;
        }

        public double Summa(double[] x, double y)
        {
            int i; double s;
            s = 0.0;
            for (i = 0; i < n; i++)
            {
                s = s + FiGp(i, y) * x[i];
            }
            return s;
        }

        public double Fii(int i, double x)
        {
            return h * BasInt((x - (a1 + i * h)) / h);
        }

        public double SummaI(double y)
        {
            int i; double s;
            s = 0.0;
            for (i = 0; i < n; i++)
            {
                s = s + (Fii(i, y) - Fii(i, 0)) * f(a1 + i * h);
            }
            return s;
        }

        public void MatrixVectSI(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            { 
                alf[i - 1] = 2.0 / 3.0; b[i - 1] = (f(a1 + (i - 1) * h) - 2.0 * f(a1 + i * h) + 
                    f(a1 + (i + 1) * h)) / h / h; 
            }
            for (i = 1; i <= (n - 3); i++)
            { 
                bet[i - 1] = 1.0 / 6.0; gam[i - 1] = 1.0 / 6.0; 
            }
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            MessageBox.Show("MatrixVectSI n = " + n.ToString());
            return;
        }

        public void MatrixVectSD(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            {
                alf[i - 1] = 2.0 / 3.0; 
                b[i - 1] = (f(a1 + (i - 1) * h) - 2.0 * f(a1 + i * h) +
                  f(a1 + (i + 1) * h)) / h / h;
            }
            for (i = 1; i <= (n - 3); i++)
            { 
                bet[i - 1] = 1.0 / 6.0; 
                gam[i - 1] = 1.0 / 6.0; 
            }
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            MessageBox.Show("MatrixVectSI n = " + n.ToString());
            return;
        }

        public double SummaS3I(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) 
                { 
                    bs[i] = (f(a1 + h) - f(a1)) / h - h / 6.0 * x[0];
                    cs[i] = 0.0; ds[i] = x[0] / 6.0 / h; 
                }
                else
                { 
                    bs[i] = (f(a1 + (i + 1) * h) - f(a1 + i * h)) / h -
                          h / 6.0 * (x[i] + 2.0 * x[i - 1]); 
                    cs[i] = x[i - 1] / 2.0; ds[i] = (x[i] - x[i - 1]) / 6.0 / h; 
                }
            }
            es[0] = 0.0;
            for (i = 0; i <= (n - 2); i++) 
                es[i + 1] = es[i] + f(a1 + i * h) * h + bs[i] * h * h / 2.0 +
                    cs[i] * h * h * h / 3.0 + ds[i] * h * h * h * h / 4.0;
            i = (int)((y - a1) / h);
            {
                r = y - (a1 + i * h);
                s = es[i] + f(a1 + i * h) * r + bs[i] * r * r / 2.0 + cs[i] * r * r * r / 3.0 +
                    ds[i] * r * r * r * r / 4.0;
                return s;
            }
        }

        public double SummaS3D(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) 
                { 
                    bs[i] = (f(a1 + h) - f(a1)) / h - h / 6.0 * x[0]; cs[i] = 0.0; 
                    ds[i] = x[0] / 6.0 / h; 
                }
                else
                {
                    bs[i] = (f(a1 + (i + 1) * h) - f(a1 + i * h)) / h - h / 6.0 * (x[i] + 2.0 * x[i - 1]);
                    cs[i] = x[i - 1] / 2.0; ds[i] = (x[i] - x[i - 1]) / 6.0 / h;
                }
            }
            i = (int)((y - a1) / h);
            {
                r = y - (a1 + i * h);
                s = bs[i] + cs[i] * r * 2.0 +
                    ds[i] * r * r * 3.0;
                return s;
            }
        }

        public void Tabulation(int[] xp, int[] yp, int[] zp)
        {
            int k;
            double y, NormC, NormL2, h, yd, yr, s, zmax, ymax, zmin, ymin, xg;
            NormC = -1.0;
            ymas = -1.0; double zg = 0.0; double yg = 0.0;
            double z = (double)(ng - 1);
            h = (b1 - a1) / z;
            if ((NamberMethod == 1) && (keyOfJob == 1))
            {
                MatrixVectSI(alf, bet, gam, b);
                GaussS3(alf, bet, gam, b, x);
            }
            if ((NamberMethod == 1) && (keyOfJob == 3))
            {
                MatrixVectSD(alf, bet, gam, b);
                GaussS3(alf, bet, gam, b, x);
            }
            y = a1; s = 0.0;
            for (k = 0; k < ng; k++)
            {
                if ((NamberMethod == 1) && (keyOfJob == 1))
                {
                    yg = fInt(y);
                    zg = SummaS3I(y, x, bs, cs, ds) - SummaS3I(0.0, x, bs, cs, ds);
                } 
                else 
                    if ((NamberMethod == 2) && (keyOfJob == 1))
                    {
                        yg = fInt(y);
                        zg = SummaI(y);
                    } 
                    else 
                        if ((NamberMethod == 1) && (keyOfJob == 2))
                        {
                            zg = Bessel(0, y);
                            yg = J0(y);
                        } 
                        else 
                            if ((NamberMethod == 2) && (keyOfJob == 2))
                            {
                                zg = ArctX(y * 100.0);
                                yg = ArctX(y * 100.0);
                            } 
                            else 
                                if ((NamberMethod == 1) && (keyOfJob == 3))
                                {
                                    yg = fp(y);
                                    zg = SummaS3D(y, x, bs, cs, ds);
                                } 
                                else
                                    if ((NamberMethod == 2) && (keyOfJob == 3))
                                    {
                                        yg = fp(y);
                                        zg = Summa(x, y);
                                    } 
                                    else
                                    { 
                                        MessageBox.Show("Здесь только два метода, 1 и 2"); 
                                        break; 
                                    }
                                    if (Math.Abs(yg) > Math.Abs(zg))
                                        yd = Math.Abs(yg);
                                    else
                                        yd = Math.Abs(zg);
                                    if (yd > ymas)
                                        ymas = yd;
                                    yr = Math.Abs(yg - zg);
                                    if (yr > NormC)
                                        NormC = yr;
                                    s = s + yr * yr;
                                    y = y + h;
            }
            ymax = ymas + 0.1 * ymas;
            ymin = -ymax;
            zmax = ymax;
            zmin = ymin;
            y = a1;
            for (k = 0; k < ng; k++)
            {
                xg = y;
                if ((NamberMethod == 1) && (keyOfJob == 1))
                {
                    yg = fInt(y);
                    zg = SummaS3I(y, x, bs, cs, ds) - SummaS3I(0.0, x, bs, cs, ds);
                } 
                else 
                    if ((NamberMethod == 2) && (keyOfJob == 1))
                    {
                        yg = fInt(y);
                        zg = SummaI(y);
                    } 
                    else 
                        if ((NamberMethod == 1) && (keyOfJob == 2))
                        {
                            zg = Bessel(0, y);
                            yg = J0(y);
                        } 
                        else 
                            if ((NamberMethod == 2) && (keyOfJob == 2))
                            {
                                zg = ArctX(y * 100.0);
                                yg = ArctX(y * 100.0);
                            } 
                            else 
                                if ((NamberMethod == 1) && (keyOfJob == 3))
                                {
                                    yg = fp(y);
                                    zg = SummaS3D(y, x, bs, cs, ds);
                                } 
                                else 
                                    if ((NamberMethod == 2) && (keyOfJob == 3))
                                    {
                                        yg = fp(y);
                                        zg = Summa(x, y);
                                    } 
                                    else
                                    { 
                                        MessageBox.Show("Здесь только два метода, 1 и 2"); 
                                        break; 
                                    }

                                    xp[k] = (int)(1024 / (b1 - a1) * (xg - a1));
                                    yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg - ymin));
                                    zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));
                                    y = y + h;
            }
            Number = n;
            Rangemin = a1;
            Rangemax = b1;
            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());
        }
    }
}
    

