﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using BaseLibrary;

namespace Spline7
{
    class ProblemCochy : BasicFunctionClass
    {
        public const int ng = 1024; 
        public double z = (double)(n - 1);
        public int primer1 = 1; 
        public int primer2 = 3;
        public int NumberMethod = 1; //1-метод Рунге-Кутта, 2-О-сплайн, 3-двумерный сплайн (для ур-я 1-го порядка)

        static public double ymas = 0.0;

        public double[] b = new double[n];
        public double[] x = new double[n];
        public double[] c = new double[n];
        public int[] xp = new int[ng];
        public int[] yp = new int[ng];
        public int[] zp = new int[ng];
        public double[] alf = new double[n];
        public double[] bet = new double[n];
        public double[] gam = new double[n];
        public double[] bs = new double[n];
        public double[] cs = new double[n];
        public double[] ds = new double[n];
        public double[] es = new double[n];
        public double[] m = new double[n];

        static public int numberGr = 1024;
        public int NumberGr
        {
            get { return numberGr; }
            set { numberGr = value; }
        }

        static public int[] xcoord;
        public int[] Xcoord
        {
            get { return xcoord; }
            set { xcoord = value; }
        }

        static public int[] ycoord;
        public int[] Ycoord
        {
            get { return ycoord; }
            set { ycoord = value; }
        }

        static public int[] zcoord;
        public int[] Zcoord
        {
            get { return zcoord; }
            set { zcoord = value; }
        }
        
        //Уравнение второго порядка линейное для О-сплайна
        public double p2(double x)
        {
            switch (primer2)
            {
                case 1: return 0.02 * step(3, 1.0 + 25.0 * x * x);
                case 2: return 1.0;//задача 13)
                case 3: return (1.0 + x * x);//задача 18)
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }
        }

        public double q2(double x)
        {
            switch (primer2)
            {
                case 1: return 0.02 * step(2, 1.0 + 25.0 * x * x);
                case 2: return Math.Sin(x) / Math.Cos(x);
                case 3: return 2.0 * x;
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }
        }

        public double r2(double x)
        {
            switch (primer2)
            {
                case 1: return 1.0 + 25.0 * x * x;
                case 2: return -Math.Cos(x) * Math.Cos(x);
                case 3: return 1.0 / (1.0 + x * x);
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }

        }

        public double fg2(double x)
        {
            switch (primer2)
            {
                case 1: return 75.0 * x * x - x;
                case 2: return 0.0;
                case 3: return 0.0;
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }

        }

        public double re2(double x)
        {
            double c1 = 1.0; double c2 = 1.0;
            switch (primer2)
            {
                case 1: return 1.0 / (1.0 + 25.0 * x * x);
                case 2: return c1 * Math.Exp(Math.Sin(x)) + c2 * Math.Exp(-Math.Sin(x));
                case 3: return 1.0 / Math.Sqrt(1.0 + x * x) * (c1 + c2 * x);
                default:
                    MessageBox.Show("sorry, primer2");
                    return 0.0;
            }
        }

        public double rep2(double x)
        {

            double c1 = 1.0; double c2 = 1.0; //double ad = 1.0; int bi = 0; double a6 = -1.0; double k4 = 0.25;
            switch (primer2)
            {
                case 1: return -50.0 * x / step(2, 1.0 + 25.0 * x * x);
                case 2: return c1 * Math.Exp(Math.Sin(x)) * Math.Cos(x) - c2 * Math.Exp(-Math.Sin(x)) * Math.Cos(x);
                case 3: return (-x) * 1.0 / step(3, Math.Sqrt(1.0 + x * x)) * (1.0 + x) + 1.0 / Math.Sqrt(1.0 + x * x);
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }
        public double repp2(double x)
        {

            double c1 = 1.0; double c2 = 1.0; double u1, u2, v1, v2;
            
            switch (primer2)
            {
                case 1: 
                    double a = step(2, 1.0 + 25.0 * x * x); 
                    double b = step(3, 1.0 + 25.0 * x * x); 
                    return 5000.0 * x * x / b  - 50.0 /a;
                case 2:  u1 = Math.Exp(Math.Sin(x)) * step(2, Math.Cos(x));
                         u2 = Math.Exp(-Math.Sin(x)) * step(2, Math.Cos(x));
                         v1 = Math.Exp(Math.Sin(x)) * Math.Sin(x);
                         v2 = Math.Exp(-Math.Sin(x)) * Math.Sin(x);
                    return c1 * u1 - c1 * v1 + c2 * u2 + c2 * v2;
                case 3:  u1 = step(3, Math.Sqrt(1.0 + x * x));
                        u2 = step(3, (1.0 + x * x)); 
                        v1 = Math.Sqrt(1.0 + x * x);
                       v2 = x * x * (1.0 + x);
                    return -((1.0 + 2.0 * x) * u1 - 3.0 * v2 * v1)/ u2  - x / u1;
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        //О-сплайн для уравнение второго порядка
        public double Fi2(double x)
        {
            double u,v,ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) 
                ret = 0.0;
            else 
                if (x < 0.0) 
                    ret = u * u * u / 6.0;
                else 
                    if (x < 1.0) 
                        ret = x + v * v * v / 6.0;
                    else 
                        ret = x;
            return ret;
        }

        public double Fi2p(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) 
                ret = 0.0;
            else 
                if (x < 0.0) 
                    ret = u * u  / 2.0;
                else 
                    if (x < 1.0) 
                        ret = 1 -  v * v / 2.0;
                    else 
                        ret = 1;
            return ret;
        }

        public double Fi2pp(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else 
                if (x < 0.0) 
                    ret = u;
                else 
                    if (x < 1.0) 
                        ret = v;
                    else 
                        ret = 0;
            return ret;
        }

        public double Fii2(int i, double x)
        {
            double xi,zi;
            xi = a1 + i * h;
            zi = Fi2((x - xi) / h);
            return zi * h * h;
        }

        public double AFik2(int i, int k)
        {
            double xi, yk, zik;
            xi = a1 + i * h; yk = a1 + k * h;
            zik = p2(yk) * Fi2pp((yk - xi) / h) + q2(yk) * Fi2p((yk - xi) / h) * h + 
                r2(yk) * Fi2((yk - xi) / h) * h * h;
            return zik;
        }


        public void LambdaP2(double[] x)
        {
                int i,k; double xk,yk,s;
                x[0] = 0.0;
            for (k = 1; k < n; k++)
            {
                xk = a1 + k * h;
                yk = fg2(xk) - p2(xk) * repp2(a1) - q2(xk) * (rep2(a1) + repp2(a1) * (xk - a1)) -
                    r2(xk) * (re2(a1) + rep2(a1) * (xk - a1) + 0.5 * repp2(a1) * (xk - a1) * (xk - a1));
                s = 0.0;
                for (i = 1; i < k; i++)
                    s = s + x[i] * AFik2(i,k);
                x[k] = (yk - s)/AFik2(k,k);
            }
            return; 
        }


        public double SummaP2(double[] x, double y)
        {
            int i; double s;
            s = 0.0;
            for (i = 1; i < n; i++)
            {
                s = s + Fii2(i, y) * x[i];
            }
            return s + re2(a1) + (y - a1) * rep2(a1) +0.5 * repp2(a1) * (y - a1) * (y - a1);
        }

        //Уравнение второго порядка линейное для Рунге-Кутта
        public double f2(double x, double u, double v)
        {       
            double p = 0.02 * step(3, 1.0 + 25.0 * x * x);
            switch (primer2)
            {
                case 3: 
                    return 0.0 - (2.0 * x) / (1.0 + x * x) * v - 1.0 / (1.0 + x * x) / (1.0 + x * x) * u;
                case 1: 
                    return (75.0 * x * x - x) / p 
                        - 0.02 * step(2, 1.0 + 25.0 * x * x) * v /p  - (1.0 + 25.0 * x * x) * u /p;
                case 2: 
                    return 0.0 - Math.Sin(x) / Math.Cos(x) * v + Math.Cos(x) * Math.Cos(x) * u;

                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public double g2(double x, double u, double v)
        {
            return v;
        }

        public void RungeKutta2(double[] x)
        {
            int k; double k1, k2, k3, k4, q1, q2, q3, q4;
            double y = a1; 
            double u = re2(a1); 
            double v = rep2(a1);
            for (k = 0; k < n; k++)
            {
                x[k] = u;
                k1 = g2(y, u, v);
                q1 = f2(y, u, v);
                k2 = g2(y + h / 2.0, u + h * k1 / 2.0, v + h * q1 / 2.0);
                q2 = f2(y + h / 2.0, u + h * k1 / 2.0, v + h * q1 / 2.0);
                k3 = g2(y + h / 2.0, u + h * k2 / 2.0, v + h * q2 / 2.0);
                q3 = f2(y + h / 2.0, u + h * k2 / 2.0, v + h * q2 / 2.0);
                k4 = g2(y + h, u + h * k3, v + h * q3);
                q4 = f2(y + h, u + h * k3, v + h * q3);
                u = u + h * (k1 + 2.0 * k2 + 2.0 * k3 + k4) / 6.0;
                v = v + h * (q1 + 2.0 * q2 + 2.0 * q3 + q4) / 6.0;
                y = y + h;
            }
        }

        //Уравнение первого порядка линейное для О-сплайна
        public double p1(double x)
        {
            switch (primer1)
            {
                case 1: return 1.0;
                case 2: return 1.0;
                case 3: return 1.0;
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }
        }

        public double q1(double x)
        {
            switch (primer1)
            {
                case 1: return 2.0 * x;
                case 2: return Math.Cos(x);
                case 3: return Math.Cos(x);
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }

        }
        public double fg1(double x)
        {
            switch (primer1)
            {
                case 1: return x * Math.Exp(-x * x);
                case 2: return 0.5 * Math.Sin(2.0 * x);
                case 3: return Math.Exp(-Math.Sin(x));
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }

        }
        public double re1(double x)
        {
            double c = 1.0;
            switch (primer1)
            {
                case 1: return (x * x / 2.0 + c) * Math.Exp(-x * x);
                case 2: return Math.Sin(x) - 1.0 + c * Math.Exp(-Math.Sin(x));
                case 3: return (x + c) * Math.Exp(-Math.Sin(x));
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }
        }
        public double rep1(double x)
        {
            double c = 1.0;
            switch (primer1)
            {
                case 1: return (x * x / 2.0 + c) * Math.Exp(-x * x) * (-2.0 * x) + x * Math.Exp(-x * x);
                case 2: return Math.Cos(x) + c * Math.Exp(-Math.Sin(x)) * (-Math.Cos(x));
                case 3: return (x + c) * Math.Exp(-Math.Sin(x)) * (-Math.Cos(x)) + Math.Exp(-Math.Sin(x));
                default:
                    MessageBox.Show("sorry, primer1");
                    return 0.0;
            }
        }

        //О-сплайн для уравнения первого порядка
        public double Fi1(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) 
                ret = 0.0;
            else 
                if (x < 0.0) 
                    ret = u * u / 2.0;
                else 
                    if (x < 1.0) 
                        ret = 1 - v * v / 2.0;
                    else 
                        ret = 1;
            return ret;
        }

        public double Fi1p(double x)
        {
            double u, v, ret;
            u = x + 1.0; v = 1.0 - x;
            if (x < -1.0) ret = 0.0;
            else 
                if (x < 0.0) 
                    ret = u;
                else 
                    if (x < 1.0) 
                        ret = v;
                    else 
                        ret = 0;
            return ret;
        }

        public double Fii1(int i, double x)
        {
            double xi, zi;
            xi = a1 + i * h;
            zi = Fi1((x - xi) / h);
            return zi;
        }

        public double AFik1(int i, int k)
        {
            double xi, yk, zik;
            xi = a1 + i * h; yk = a1 + k * h;
            zik = p1(yk) * Fi1p((yk - xi) / h) + q1(yk) * Fi1((yk - xi) / h) * h;
            return zik;
        }


        public void LambdaP1(double[] x)
        {
            int i, k; double xk, yk, s;
            x[0] = 0.0;
            for (k = 1; k < n; k++)
            {
                xk = a1 + k * h;
                yk = (fg1(xk) - q1(xk) * re1(a1) - p1(xk) * rep1(a1) - q1(xk) * rep1(a1) * (xk - a1)) * h;
                s = 0.0;
                for (i = 0; i < k; i++)
                    s = s + x[i] * AFik1(i, k);
                x[k] = (yk - s) / AFik1(k, k);
            }
            return;
        }

        public double SummaP1(double[] x, double y)
        {
            int i; double s;
            s = 0.0;
            for (i = 1; i < n; i++)
            {
                s = s + Fii1(i, y) * x[i];
            }
            return s + re1(a1) + rep1(a1) * (y - a1);
        }

        //Уравнение первого порядка линейное для Рунге-Кутта     
        public double f1(double x, double y)
        {
            switch (primer1)
            {
                case 1: return x * Math.Exp(-x*x) - 2.0 * x * y;
                case 2: return 0.5 * Math.Sin(2.0 * x) - Math.Cos(x) * y;
                case 3: return Math.Exp(-Math.Sin(x)) - Math.Cos(x) * y;
                default:
                    MessageBox.Show("sorry, primer");
                    return 0.0;
            }
        }

        public void RungeKutta1(double[] x)
        {
            int k; double k1, k2, k3, k4;
            double y = a1; double u = re1(a1); 
            for (k = 0; k < n; k++)
            {
                x[k] = u; 
                k1 = f1(y, u);
                k2 = f1(y + h / 2.0, u + h * k1 / 2.0);
                k3 = f1(y + h / 2.0, u + h * k2 / 2.0);
                k4 = f1(y + h, u + h * k3);
                u = u + h * (k1 + 2.0 * k2 + 2.0 * k3 + k4) / 6.0;
                y = y + h;
            }
        }

        public void MatrixVectS(double[] alf, double[] bet, double[] gam, double[] b)
        {
            int i;
            for (i = 1; i <= (n - 2); i++)
            { 
                alf[i - 1] = 2.0 / 3.0; 
                b[i - 1] = (x[i - 1] - 2.0 * x[i] + x[i + 1]) / h / h; 
            }
            for (i = 1; i <= (n - 3); i++)
            { 
                bet[i - 1] = 1.0 / 6.0; 
                gam[i - 1] = 1.0 / 6.0; 
            }
            bet[n - 3] = 0.0; gam[n - 3] = 0.0;
            MessageBox.Show("MatrixVectS n = " + n.ToString());
            return;
        }

         public double SummaS3(double y, double[] x, double[] bs, double[] cs, double[] ds)
        {
            int i; double r, s;
            for (i = 0; i <= (n - 2); i++)
            {
                if (i == 0) { bs[0] = (x[1] - x[0]) / h - h / 6.0 * m[0]; cs[0] = 0.0; ds[0] = m[0] / 6.0 / h; }
                else
                { 
                    bs[i] = (x[i + 1] - x[i]) / h - h / 6.0 * (m[i] + 2.0 * m[i - 1]); cs[i] = m[i - 1] / 2.0; 
                    ds[i] = (m[i] - m[i - 1]) / 6.0 / h; 
                }
            }
            i = (int)((y - a1) / h);
            if (i == (n - 1)) 
                return x[n - 1];
            else
            {
                r = y - (a1 + i * h);
                s = x[i] + bs[i] * r + cs[i] * r * r + ds[i] * r * r * r;
                return s;
            }
        }
         
        public void Tabulation(int[] xp, int[] yp, int[] zp)
        {
            int k;
            double y, NormC, NormL2, s, h, yd, yr, zmax, ymax, zmin, ymin, xg, yg, zg;
            y = a1; NormC = -1.0; s = 0;
            ymas = -1.0; yg = 0.0; zg = 0.0;
            double z = (double)(ng - 1);
            h = (b1 - a1) / z;
            if ((KeyOfJob == 1) && (NumberMethod == 1)) 
            {
                RungeKutta1(x);
                MatrixVectS(alf, bet, gam, b);
                GaussS3(alf, bet, gam, b, m);
            }
            else
                if ((KeyOfJob == 1) && (NumberMethod == 2)) 
                {
                    LambdaP1(x);
                }
                else
                    if ((KeyOfJob == 2) && (NumberMethod == 1))
                    {
                        RungeKutta2(x);
                        MatrixVectS(alf, bet, gam, b);
                        GaussS3(alf, bet, gam, b, m);
                    }
                    else
                        if ((KeyOfJob == 2) && (NumberMethod == 2))
                        {
                            LambdaP2(x);
                        }
            for (k = 0; k < ng; k++)
            {
                xg = y;
                if ((KeyOfJob == 1) && (NumberMethod == 1)) 
                { 
                    yg = re1(y); zg = SummaS3(y, x, bs, cs, ds); 
                }
                else
                    if ((KeyOfJob == 2) && (NumberMethod == 1)) 
                    { 
                        yg = re2(y); zg = SummaS3(y, x, bs, cs, ds); 
                    }
                    else
                        if ((KeyOfJob == 1) && (NumberMethod == 2)) 
                        {
                            yg = re1(y); zg = SummaP1(x, y); 
                        }
                        else
                            if ((KeyOfJob == 2) && (NumberMethod == 2)) 
                            {
                                yg = re2(y); zg = SummaP2(x, y);
                            }
                if (Math.Abs(yg) > Math.Abs(zg))
                    yd = Math.Abs(yg);
                else
                    yd = Math.Abs(zg);
                if (yd > ymas)
                    ymas = yd;
                y = y + h;
            }

            ymax = ymas + 0.1 * ymas;
            ymin = -ymax;
            zmax = ymax;
            zmin = ymin;

            y = a1;
            ymas = -1.0;
            for (k = 0; k < ng; k++)
            {
                xg = y;
                if ((KeyOfJob == 1) && (NumberMethod == 1)) 
                { 
                    yg = re1(y); zg = SummaS3(y, x, bs, cs, ds); 
                }
                else
                    if ((KeyOfJob == 2) && (NumberMethod == 1)) 
                    { 
                        yg = re2(y); zg = SummaS3(y, x, bs, cs, ds); 
                    }
                    else
                        if ((KeyOfJob == 1) && (NumberMethod == 2)) 
                        {
                            yg = re1(y); zg = SummaP1(x, y); 
                        }
                        else
                            if ((KeyOfJob == 2) && (NumberMethod == 2))
                            {
                                yg = re2(y); zg = SummaP2(x, y); 
                            }
               
                yr = Math.Abs(yg - zg);
                if (yr > NormC)
                    NormC = yr;
                s = s + yr * yr;
                xp[k] = (int)(1024 / (b1 - a1) * (xg - a1));
                yp[k] = 780 - (int)(780 / (ymax - ymin) * (yg - ymin));
                zp[k] = 780 - (int)(780 / (zmax - zmin) * (zg - zmin));
                y = y + h;
            }

            Number = n;
            Rangemin = a1;
            Rangemax = b1;
            NumberGr = ng;
            NormL2 = Math.Sqrt(s / z);
            Xcoord = xp;
            Ycoord = yp;
            Zcoord = zp;
            MessageBox.Show("NormC = : " + NormC.ToString());
            MessageBox.Show("NormL2 = : " + NormL2.ToString());
        }
    }
}
