﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Spline8
{
    public partial class Form2 : Form
    {
        EvolutionEquation evolutionEquation = new EvolutionEquation();

        public Form2()
        {
            InitializeComponent();
            Graphics dc = this.CreateGraphics();
            this.Show();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            Graphics dc = e.Graphics;

            float width = 2.5F;                         // толщина пера
            Pen BluePen = new Pen(Color.Blue, width);   // цвет пера
            Rectangle area = new Rectangle();           // объект - прямоугольник
            int shift = 20;

            Point pnt = new Point();                    // точка
            pnt.X = 20; pnt.Y = 20;                     // определяем прямоугольник
            area.Location = pnt;
            area.Height = 760;
            area.Width = 1004;

            Pen RedPen = new Pen(Color.Red, width);     // красное перо
            System.Drawing.Color backColor = System.Drawing.Color.White;
            Size pixelsBetweenDots = new Size();
            pixelsBetweenDots.Width = 10;           // расстояние между точками сетки
            pixelsBetweenDots.Height = 10;
            ControlPaint.DrawGrid(dc, area, pixelsBetweenDots, backColor);   // покрываем область сеткой
            Pen WhitePen = new Pen(Color.White, width);     // перо белое

            Point p1 = new Point(512 + shift, 0 + shift);   // вертикальная ось графика
            Point p2 = new Point(512 + shift, 780);

            Point p3 = new Point(0 + shift, 390 + shift);   // горизонтальная ось графика
            Point p4 = new Point(1024, 390 + shift);

            dc.DrawLine(WhitePen, p1, p2);                  // рисуем вертикальную ось
            dc.DrawLine(WhitePen, p3, p4);                  // рисуем горизонтальную ось

            // Рисуем стрелки на концах осей
            int length = 8;
            int l1 = (int)Math.Ceiling(length * Math.Sqrt(3.0) * 2);
            int l2 = length / 2;
            p1.X = 512 + shift; p1.Y = shift;
            p3.X = p1.X - l2; p3.Y = p1.Y + l1;
            dc.DrawLine(WhitePen, p1, p3);              // стрелка на вертикальной оси
            p3.X = p1.X + l2; p3.Y = p1.Y + l1;
            dc.DrawLine(WhitePen, p1, p3);

            p1.X = 1024; p1.Y = 390 + shift;           // стрелка на горизонтальной оси
            p3.X = p1.X - l1; p3.Y = p1.Y - l2;
            dc.DrawLine(WhitePen, p1, p3);
            p3.X = p1.X - l1; p3.Y = p1.Y + l2;
            dc.DrawLine(WhitePen, p1, p3);

            string sa1 = BaseLibrary.BasicFunctionClass.a1.ToString();  // минимум по x
            string sb1 = BaseLibrary.BasicFunctionClass.b1.ToString();  // махимум по x
            if (sa1.IndexOf(",") <= 0)
            {
                sa1 += ",0";
            }
            if (sb1.IndexOf(",") <= 0)
            {
                sb1 += ",0";
            }
            Brush blackBrush = Brushes.Black;                                       // цвет заливки 
            Font boldTimes = new Font("Times New Roman", 15.0F, FontStyle.Bold);    // фонт
            PointF pf1 = new PointF();
            pf1.X = 20.0F; pf1.Y = 390.0F + 25.0F;                                  // позиция текста
            dc.DrawString(sa1, boldTimes, blackBrush, pf1);                         // отрисовать минимум по x

            pf1.X = 1000.0F; pf1.Y = 390.0F + 25.0F;                                // позиция текста
            dc.DrawString(sb1, boldTimes, blackBrush, pf1);                         // отрисовать максимум по x

            string symas = EvolutionEquation.ymas.ToString();                          // максимум по у    
            if (symas.IndexOf(",") <= 0)
            {
                symas += ",0";
            }
            string sout = symas;
            if (symas.Length > 4)
            {
                sout = symas.Substring(0, 4);
            }
            pf1.X = 512.0F + 25.0F; pf1.Y = 15.0F;                                  // позиция текста
            dc.DrawString(sout, boldTimes, blackBrush, pf1);                        // отрисовать максимум по у
            // заполняем массив точек графика
            int np = 1004;
            Point[] points = new Point[np];
            for (int i = 0; i < np; i++)
            {
                points[i] = new Point(evolutionEquation.Xcoord[i] + shift, evolutionEquation.Ycoord[i] + shift);
            }
            dc.DrawLines(RedPen, points);             // отрисовываем первый график красным
            // заполняем массив точек второго графика
            Point[] points2 = new Point[np];
            for (int i = 0; i < np; i++)
            {
                points2[i] = new Point(evolutionEquation.Xcoord[i] + shift, evolutionEquation.Zcoord[i] + shift);
            }
            Pen GreenPen = new Pen(Color.Green, width);
            dc.DrawLines(GreenPen, points2);         // отрисовываем второй график зеленым
       }
    }
}